#include "main.h"


uint64_t re64data0[64]={0};
uint64_t re64data1[64]={0};
//uint64_t re64data2[64]={0};

#define FLASH_SYS_KEY1                  ((uint32_t)0x39965075)
#define FLASH_SYS_KEY2                  ((uint32_t)0x5AA576A8)

//#define FLASH_CR_SYSWRE            ((uint32_t)(1<<14))

#define FLASH_PAGE_SIZE                 0x400U  /* 1 KB */
uint32_t GetPage(uint32_t Addr)
{
  return (Addr - 0x08000000) / FLASH_PAGE_SIZE;;
}


void INFO_Unlock(void)
{
  /* Authorize the FPEC of Bank1 Access */
  FLASH->KEYR = FLASH_CRKEY1;
  FLASH->KEYR = FLASH_CRKEY2;
//  FLASH->WRP1BR = FLASH_SYS_KEY1;
//  FLASH->WRP1BR = FLASH_SYS_KEY2;
//	
//	FLASH->RXKEY = FLASH_SYS_KEY1;
//  FLASH->RXKEY = FLASH_SYS_KEY2;
	
}

void INFO_Lock(void)
{
  FLASH->CR |= FLASH_CR_LOCK;
  CLEAR_BIT(FLASH->CR,FLASH_CR_SYSWRE);
}


void Systemmemory_Debug_Test(void)
{
  uint32_t data0=0,data1=0;
  INFO_Unlock();
  /*erase*/

    FLASH->CR |= 0<<13;  //Sysblocksel=0:systemmemory

	FLASH_Erase_Page(0);	//page0:0x1FFF0000
  for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFF0000+i*8);
    data1 = FLASH_Read_Word(0x1FFF0000+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0xFFFFFFFFFFFFFFFF)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }  
  /*program:0xAAAAAAAAAAAAAAAA*/
	for(int j = 0;j<4;j++)
	{
		FLASH_Program_DoubleWord(0x1FFF0000+j*8,(0xAAAAAAAAAAAAAAAA));
	}
   for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFF0000+i*8);
    data1 = FLASH_Read_Word(0x1FFF0000+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0xAAAAAAAAAAAAAAAA)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }  
  /*erase*/
  FLASH_Erase_Page(0);
  for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFF0000+i*8);
    data1 = FLASH_Read_Word(0x1FFF0000+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0xFFFFFFFFFFFFFFFF)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }
  
  /*program:0x5555555555555555*/
  for(int j = 0;j<4;j++)
	{
		FLASH_Program_DoubleWord(0x1FFF0000+j*8,(0x5555555555555555));    
	}
  for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFF0000+i*8);
    data1 = FLASH_Read_Word(0x1FFF0000+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0x5555555555555555)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }  
  /*erase*/
  FLASH_Erase_Page(0);
  for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFF0000+i*8);
    data1 = FLASH_Read_Word(0x1FFF0000+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0xFFFFFFFFFFFFFFFF)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }
	INFO_Lock();
  GPIO_Toggle_Pin(GPIOB,GPIO_PIN_0);
}

void RXmemory_Debug_Test(void)
{
  uint32_t data0=0,data1=0;
  INFO_Unlock();
  /*erase*/

    FLASH->CR |= 1<<13;  //Sysblocksel=1:RX data format

	FLASH_Erase_Page(0);	//page0:0x1FFFFA00
  for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFFFA00+i*8);
    data1 = FLASH_Read_Word(0x1FFFFA00+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0xFFFFFFFFFFFFFFFF)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }  
  /*program:0x55AA55AA55AA55AA*/
	for(int j = 0;j<4;j++)
	{
		FLASH_Program_DoubleWord(0x1FFFFA00+j*8,(0x55AA55AA55AA55AA));
	}
   for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFFFA00+i*8);
    data1 = FLASH_Read_Word(0x1FFFFA00+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0x55AA55AA55AA55AA)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }  
  /*erase*/
  FLASH_Erase_Page(0);
  for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFFFA00+i*8);
    data1 = FLASH_Read_Word(0x1FFFFA00+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0xFFFFFFFFFFFFFFFF)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }
  
  /*program:0xAA55AA55AA55AA55*/
  for(int j = 0;j<4;j++)
	{
		FLASH_Program_DoubleWord(0x1FFFFA00+j*8,(0xAA55AA55AA55AA55));    
	}
  for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFFFA00+i*8);
    data1 = FLASH_Read_Word(0x1FFFFA00+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0xAA55AA55AA55AA55)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }  
  /*erase*/
  FLASH_Erase_Page(0);
  for(int i = 0;i<4;i++)
	{
    data0 = FLASH_Read_Word(0x1FFFFA00+i*8);
    data1 = FLASH_Read_Word(0x1FFFFA00+4+i*8);
    re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
    if(re64data0[i] != 0xFFFFFFFFFFFFFFFF)
    {
      GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
    }
  }
	INFO_Lock();
  GPIO_Toggle_Pin(GPIOB,GPIO_PIN_0);
}

void Test_FLASH_RW_Erase(uint32_t StartAddress,uint32_t EndAddress)
{
  uint32_t data0=0,data1=0,startpage = 0,endpage = 0,pagestartaddress=0;    //pagenum=0,
  
  startpage = GetPage(StartAddress);
  endpage = GetPage(EndAddress);
//  pagenum = endpage-startpage;
  
  FLASH_Unlock();  
  for(int p = startpage;p<endpage;p++)
  {
     /*erase*/
    FLASH_Erase_Page(p);	// 
    pagestartaddress = p*FLASH_PAGE_SIZE+0x08000000;
    for(int i = 0;i<(FLASH_PAGE_SIZE/8);i++)
    {
      data0 = FLASH_Read_Word(pagestartaddress+i*8);
      data1 = FLASH_Read_Word(pagestartaddress+4+i*8);
      re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
      if(re64data0[i] != 0xFFFFFFFFFFFFFFFF)
      {
        GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
      }
    }  
    /*program:0xAAAAAAAAAAAAAAAA*/
    for(int j = 0;j<(FLASH_PAGE_SIZE/8);j++)
    {
      FLASH_Program_DoubleWord(pagestartaddress+j*8,(0xAAAAAAAAAAAAAAAA));
    }
     for(int i = 0;i<(FLASH_PAGE_SIZE/8);i++)
    {
      data0 = FLASH_Read_Word(pagestartaddress+i*8);
      data1 = FLASH_Read_Word(pagestartaddress+4+i*8);
      re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
      if(re64data0[i] != 0xAAAAAAAAAAAAAAAA)
      {
        GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
      }
    }  
    /*erase*/
    FLASH_Erase_Page(p);
    for(int i = 0;i<(FLASH_PAGE_SIZE/8);i++)
    {
      data0 = FLASH_Read_Word(pagestartaddress+i*8);
      data1 = FLASH_Read_Word(pagestartaddress+4+i*8);
      re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
      if(re64data0[i] != 0xFFFFFFFFFFFFFFFF)
      {
        GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
      }
    }
    
    /*program:0x5555555555555555*/
    for(int j = 0;j<(FLASH_PAGE_SIZE/8);j++)
    {
      FLASH_Program_DoubleWord(pagestartaddress+j*8,(0x5555555555555555));    
    }
    for(int i = 0;i<(FLASH_PAGE_SIZE/8);i++)
    {
      data0 = FLASH_Read_Word(pagestartaddress+i*8);
      data1 = FLASH_Read_Word(pagestartaddress+4+i*8);
      re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
      if(re64data0[i] != 0x5555555555555555)
      {
        GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
      }
    }  
    /*erase*/
    FLASH_Erase_Page(p);
    for(int i = 0;i<(FLASH_PAGE_SIZE/8);i++)
    {
      data0 = FLASH_Read_Word(pagestartaddress+i*8);
      data1 = FLASH_Read_Word(pagestartaddress+4+i*8);
      re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
      if(re64data0[i] != 0xFFFFFFFFFFFFFFFF)
      {
        GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
      }
    }
  }
  
 
	FLASH_Lock();
}


void Test_FLASH128bit_RW_Erase(uint32_t StartAddress,uint32_t EndAddress)
{
  uint32_t data0=0,startpage = 0,endpage = 0,pagestartaddress=0;   //pagenum=0,
  
  startpage = GetPage(StartAddress);
  endpage = GetPage(EndAddress);
//  pagenum = endpage-startpage;
  
  FLASH_Unlock();  
  
  for(int p = startpage;p<endpage;p++)
  {
     /*erase*/
    FLASH_Erase_Page(p);	// 
    pagestartaddress = p*FLASH_PAGE_SIZE+0x08000000;
   
    /*program:0xAAAAAAAAAAAAAAAA+0x5555555555555555*/
    for(int j = 0;j<(FLASH_PAGE_SIZE/16);j++)
    {
     FLASH_Program_DoubleDoubleWord(pagestartaddress+j*16,(0xAAAAAAAAAAAAAAAA),(0x5555555555555555));    /*4805*/
    }
		printf("\r\n---- R2265 2 page = 0x%x  -----\r\n",data0);

  
    /*erase*/
    FLASH_Erase_Page(p);
    
    
//    /*program:0x5555555555555555*/
//    for(int j = 0;j<(FLASH_PAGE_SIZE/16);j++)
//    {
//      FLASH_Program_DoubleDoubleWord(pagestartaddress+j*16,(0x5555555555555555),(0xAAAAAAAAAAAAAAAA));    
//    }
//    for(int i = 0;i<(FLASH_PAGE_SIZE/16);i++)
//    {
//      data0 = FLASH_Read_Word(pagestartaddress+i*16);
//      data1 = FLASH_Read_Word(pagestartaddress+4+i*16);
//      data2 = FLASH_Read_Word(pagestartaddress+8+i*16);
//      data3 = FLASH_Read_Word(pagestartaddress+12+i*16);
//      re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
//      re64data1[i]=(uint64_t)(((uint64_t)data3 << 32)|data2);
//      if((re64data0[i] != 0x5555555555555555)&(re64data1[i] != 0xAAAAAAAAAAAAAAAA))
//      {
//        GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
//      }
//    }  
//    /*erase*/
//    FLASH_Erase_Page(p);
//    for(int i = 0;i<(FLASH_PAGE_SIZE/16);i++)
//    {
//      data0 = FLASH_Read_Word(pagestartaddress+i*16);
//      data1 = FLASH_Read_Word(pagestartaddress+4+i*16);
//      data2 = FLASH_Read_Word(pagestartaddress+8+i*16);
//      data3 = FLASH_Read_Word(pagestartaddress+12+i*16);
//      re64data0[i]=(uint64_t)(((uint64_t)data1 << 32)|data0);
//      re64data1[i]=(uint64_t)(((uint64_t)data3 << 32)|data2);
//      if((re64data0[i] != 0xFFFFFFFFFFFFFFFF) & (re64data1[i] != 0xFFFFFFFFFFFFFFFF))
//      {
//        GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
//      }
//    }
  }
  
 
	FLASH_Lock();
}




