/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/

/*
*********************************************************************************************************
*                                              rx32s12xx
*                                           Library Function
*
*                                   Copyright 2019, RX Tech, Corp.
*                                        All Rights Reserved
*
*
* Project      : rx32s12xx
* File         : main.c
* By           : RX_SD_Team
* Version      : V1.0.0
* Description  : Only rx32s12xx
*********************************************************************************************************
*/
#include "main.h"

/*
*********************************************************************************************************
*                                           Global macro/Structure
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                             Global variable
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                           Global Function declaration
*********************************************************************************************************
*/

void Delay_us( uint32_t us )
{
	uint32_t Fsys;
	Fsys=RCC_Get_SystemClock()/1000000;
	//maximum:199728us 
	if( us*Fsys > SysTick_LOAD_RELOAD_Msk ) return;
	SysTick->CTRL = 0;      //Disable SysTick
	SysTick->LOAD = Fsys*us;//Set count number:72*us, 72 means 1us when SystemCoreClock is 72MHz
	SysTick->VAL  = 0;      //Clear current count number and count flag
	SysTick->CTRL = 5;      //Enable SysTick and Select SystemCoreClock as SysTick clock source
	while((SysTick->CTRL&0x10000)==0);//Wait for count flag set
	SysTick->CTRL = 0;      //Disable SysTick
}

void Delay_ms( uint32_t ms )
{
	uint32_t i;
	for(i=ms;i>0;i--)
	{
		Delay_us(1000);
	}
}


void GPIO_ToggleC(void)
{
  RCC_Enable_AHBClock(RCC_AHBENR_IOPCEN);
  
  GPIO_InitTypeDef GPIO_InitStruct = {0};
  GPIO_InitStruct.Pin = GPIO_PIN_0;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_PUPDR_Pulldown;
  GPIO_InitStruct.Speed = GPIO_OSPEEDR_High;
  GPIO_Init(GPIOC,&GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_1;
  GPIO_Init(GPIOC,&GPIO_InitStruct);
	GPIO_InitStruct.Pin = GPIO_PIN_2;
  GPIO_Init(GPIOC,&GPIO_InitStruct);
	 GPIO_InitStruct.Pin = GPIO_PIN_3;
  GPIO_Init(GPIOC,&GPIO_InitStruct);
	GPIO_InitStruct.Pin = GPIO_PIN_4;
  GPIO_Init(GPIOC,&GPIO_InitStruct);
	 GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOC,&GPIO_InitStruct);
	GPIO_InitStruct.Pin = GPIO_PIN_6;
  GPIO_Init(GPIOC,&GPIO_InitStruct);
	 GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOC,&GPIO_InitStruct);
}

void GPIO_ToggleB(void)
{
  RCC_Enable_AHBClock(RCC_AHBENR_IOPBEN);
  
  GPIO_InitTypeDef GPIO_InitStruct = {0};
  GPIO_InitStruct.Pin = GPIO_PIN_0;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_PUPDR_Pulldown;
  GPIO_InitStruct.Speed = GPIO_OSPEEDR_High;
  GPIO_Init(GPIOB,&GPIO_InitStruct);
  GPIO_InitStruct.Pin = GPIO_PIN_1;
  GPIO_Init(GPIOB,&GPIO_InitStruct);
	GPIO_InitStruct.Pin = GPIO_PIN_2;
  GPIO_Init(GPIOB,&GPIO_InitStruct);
	 GPIO_InitStruct.Pin = GPIO_PIN_3;
  GPIO_Init(GPIOB,&GPIO_InitStruct);
	GPIO_InitStruct.Pin = GPIO_PIN_4;
  GPIO_Init(GPIOB,&GPIO_InitStruct);
	 GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOB,&GPIO_InitStruct);
	GPIO_InitStruct.Pin = GPIO_PIN_6;
  GPIO_Init(GPIOB,&GPIO_InitStruct);
	 GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_Init(GPIOB,&GPIO_InitStruct);
}

void GPIO_ToggleA(void)
{
  RCC_Enable_AHBClock(RCC_AHBENR_IOPAEN);
  
  GPIO_InitTypeDef GPIO_InitStruct = {0};
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_PUPDR_Pulldown;
  GPIO_InitStruct.Speed = GPIO_OSPEEDR_High;
	 GPIO_InitStruct.Pin = GPIO_PIN_3;
  GPIO_Init(GPIOA,&GPIO_InitStruct);
	GPIO_InitStruct.Pin = GPIO_PIN_5;
  GPIO_Init(GPIOA,&GPIO_InitStruct);
}
void change_OPTR_1()
{
  FLASH_Unlock();
  FLASH_OB_Unlock();


  MODIFY_REG(FLASH->OPTR, FLASH_OPTR_RDP,  0xAAU);

  SET_BIT(FLASH->CR,0x20000);//17   OPT START
	
	 while((FLASH->SR & FLASH_SR_BSY) == FLASH_SR_BSY)
    {
    }; 
				
	
//	SET_BIT(FLASH->CR,0x8000000);//27
  
  FLASH_Lock();
	FLASH_OB_Lock();
  
}



void change_OPTR_2()
{
  FLASH_Unlock();
  FLASH_OB_Unlock();


  MODIFY_REG(FLASH->OPTR, FLASH_OPTR_RDP,  0xBBU);


  SET_BIT(FLASH->CR,0x20000);//17   OPT START

  while((FLASH->SR & FLASH_SR_BSY) == FLASH_SR_BSY)
  {
  }; 


  //		SET_BIT(FLASH->CR,0x8000000);//27   OBL


  FLASH_Lock();
  FLASH_OB_Lock();
  
}
   
void Toggle_PB0(void)
{
   for(int i=0;i<10;i++) GPIO_Toggle_Pin(GPIOB,GPIO_PIN_1);
}


int main(void)
{
//  GPIO_ToggleA();
	
  GPIO_ToggleB();
    Toggle_PB0();
  
  
	
	if((READ_REG(FLASH->OPTR) & 0xffU )== 0xAAU)
	{
//			change_OPTR_2();
	}
		else
		{
		  SET_BIT(GPIOB->ODR, BIT3);    
				  change_OPTR_1();
		}


  while(1)
  {
//    GPIO_Toggle_Pin(GPIOB,GPIO_PIN_0);
//    Delay_ms(100);
   }
}
