/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/

/*
*********************************************************************************************************
*                                              rx32s12xx
*                                           Library Function
*
*                                   Copyright 2021, RX Tech, Corp.
*                                        All Rights Reserved
*
*
* Project      : rx32s12xx
* File         : rx32s12xx_cmp.h
* By           : RX_SD_Team
* Version      : V1.0.0
* Description  : Only rx32s12xx
*********************************************************************************************************
*/
#ifndef __rx32s12xx_CMP_H__
#define __rx32s12xx_CMP_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s12xx.h"


/******************************************************************************/
/*                                                                            */
/*                      Analog CMParators (CMP)                             */
/*                                                                            */
/******************************************************************************/
/**********************  Bit definition for CMP_CxCR register  ****************/
#define CMP_CxCR_EN                ((uint32_t)0x00000001)

#define CMP_CxCR_CH_EN             ((uint32_t)0x00000002)

#define CMP_CxCR_RIE               ((uint32_t)0x00000004)
#define CMP_CxCR_FIE               ((uint32_t)0x00000008)

#define CMP_CxCR_INM_SEL         ((uint32_t)0x00000070)
#define CMP_INM_SEL_1N           ((uint32_t)0x00000000)
#define CMP_INM_SEL_2N           ((uint32_t)0x00000010)     // (CMP1 only)
#define CMP_INM_SEL_3N           ((uint32_t)0x00000020)     // (CMP1 only)      
#define CMP_INM_SEL_SRN_Center   ((uint32_t)0x00000030)     // (CMP1 only) 
#define CMP_INM_SEL_CRV          ((uint32_t)0x00000040)
//#define CMP_INM_SEL_DAC12             ((uint32_t)0x00000050)
//#define CMP_INM_SEL_0N                ((uint32_t)0x00000060)
//#define CMP_INM_SEL_1N                ((uint32_t)0x00000070)

#define CMP_CxCR_INP_SEL              ((uint32_t)0x00000180)
#define CMP_INP_SEL_1P                ((uint32_t)0x00000000)
#define CMP_INP_SEL_2P                ((uint32_t)0x00000080)
#define CMP_INP_SEL_3P                ((uint32_t)0x00000100)    //10: CMPx_P3(CMP1),OPA2_out(CMP2)
#define CMP_INP_SEL_OPA_out           ((uint32_t)0x00000180)    //11: OPA1_out(CMP1),OPA3_out(CMP2)

#define CMP_CxCR_BASEN                ((uint32_t)0x00000200)
#define CMP_CxCR_CH_DIS               ((uint32_t)0x00000400)
#define CMP_CxCR_CH_DIS_BLANKING      ((uint32_t)0x00000800)

#define CMP_CxCR_OFLT                 ((uint32_t)0x00007000)
#define CMP_CxCR_OFLT_DIV1            ((uint32_t)0x00000000)
#define CMP_CxCR_OFLT_DIV32           ((uint32_t)0x00001000)
#define CMP_CxCR_OFLT_DIV64           ((uint32_t)0x00002000)
#define CMP_CxCR_OFLT_DIV128          ((uint32_t)0x00003000)
#define CMP_CxCR_OFLT_DIV256          ((uint32_t)0x00004000)
#define CMP_CxCR_OFLT_DIV512          ((uint32_t)0x00005000)
#define CMP_CxCR_OFLT_DIV1024         ((uint32_t)0x00006000)
#define CMP_CxCR_OFLT_DIV2048         ((uint32_t)0x00007000)


#define CMP_CxCR_POL               ((uint32_t)0x00008000)
#define CMP_CxCR_POL_Positive   	 ((uint32_t)0x00000000) 
#define CMP_CxCR_POL_Negative    	 ((uint32_t)0x00008000) 

#define CMP_CxCR_RHYST             ((uint32_t)0x00030000)
#define CMP_CxCR_RHYST_0mV         ((uint32_t)0x00000000)
#define CMP_CxCR_RHYST_20mV        ((uint32_t)0x00010000)
#define CMP_CxCR_RHYST_40mV        ((uint32_t)0x00020000)
#define CMP_CxCR_RHYST_60mV        ((uint32_t)0x00030000)

#define CMP_CxCR_CMP_BAS_EN_OPA    ((uint32_t)0x00040000)

#define CMP_CxCR_BLANKING_SEL              ((uint32_t)0x00380000)
#define CMP_CxCR_BLANKING_SEL_NoBlanking   ((uint32_t)0x00000000)
#define CMP_CxCR_BLANKING_SEL_TIM2_OC4     ((uint32_t)0x00080000)
#define CMP_CxCR_BLANKING_SEL_TIM2_OC3     ((uint32_t)0x00100000)
#define CMP_CxCR_BLANKING_SEL_TIM3_OC3     ((uint32_t)0x00180000)
#define CMP_CxCR_BLANKING_SEL_TIM8_OC5     ((uint32_t)0x00200000)
#define CMP_CxCR_BLANKING_SEL_TIM8_OC4     ((uint32_t)0x00280000)
#define CMP_CxCR_BLANKING_SEL_TIM15_OC1    ((uint32_t)0x00300000)
#define CMP_CxCR_BLANKING_SEL_TIM15_OC2    ((uint32_t)0x00380000)

#define CMP_CxCR_HIE               ((uint32_t)0x00400000)
#define CMP_CxCR_LIE               ((uint32_t)0x00800000)

#define CMP_CxCR_FHYST             ((uint32_t)0x03000000)
#define CMP_CxCR_FHYST_0mV         ((uint32_t)0x00000000)
#define CMP_CxCR_FHYST_20mV        ((uint32_t)0x01000000)
#define CMP_CxCR_FHYST_40mV        ((uint32_t)0x02000000)
#define CMP_CxCR_FHYST_60mV        ((uint32_t)0x03000000)

#define CMP_CxCR_HIF               ((uint32_t)0x04000000)

#define CMP_CxCR_RIF               ((uint32_t)0x08000000)
#define CMP_CxCR_FIF               ((uint32_t)0x10000000)

#define CMP_CxCR_LIF               ((uint32_t)0x20000000)

#define CMP_CxCR_OUT               ((uint32_t)0x40000000)
#define CMP_CxCR_OUT_Low        	 ((uint32_t)0x00000000) 
#define CMP_CxCR_OUT_High       	 ((uint32_t)0x40000000) 

#define CMP_CxCR_LOCK              ((uint32_t)0x80000000)
#define CMP_CxCR_LOCK_RW         	 ((uint32_t)0x00000000) 
#define CMP_CxCR_LOCK_R         	 ((uint32_t)0x80000000) 

#define CMP_RGxCAL_PADJ                ((uint32_t)0x0000000F)
#define CMP_RGxCAL_PEN                 ((uint32_t)0x00000010)
#define CMP_RGxCAL_NEN                 ((uint32_t)0x00000020)
#define CMP_RGxCAL_NADJ                ((uint32_t)0x00000F00)

#define CMP_CR1_SRN_EN               ((uint32_t)0x00000001)
#define CMP_CR1_SRN_Dout             ((uint32_t)0x00000002)
#define CMP_CR1_CRV_LOCK             ((uint32_t)0x00000004)
#define CMP_CR1_SRN_BAS_EN           ((uint32_t)0x00000008)
 
#define CMP_CR2_CRV_SRC              ((uint32_t)0x00000001)
#define CMP_CR2_CRV_EN               ((uint32_t)0x00000002)
#define CMP_CR2_CRV_LOCK             ((uint32_t)0x00000004)

#define CMP_CR2_CRV1_SEL      ((uint32_t)0x000000F8)
#define CMP_CRV1_SEL_1_32     ((uint32_t)0x00000000)
#define CMP_CRV1_SEL_2_32     ((uint32_t)0x00000008)
#define CMP_CRV1_SEL_3_32     ((uint32_t)0x00000010)
#define CMP_CRV1_SEL_4_32     ((uint32_t)0x00000018)
#define CMP_CRV1_SEL_5_32     ((uint32_t)0x00000020)
#define CMP_CRV1_SEL_6_32     ((uint32_t)0x00000028)
#define CMP_CRV1_SEL_7_32     ((uint32_t)0x00000030)
#define CMP_CRV1_SEL_8_32     ((uint32_t)0x00000038)
#define CMP_CRV1_SEL_9_32     ((uint32_t)0x00000040)
#define CMP_CRV1_SEL_10_32    ((uint32_t)0x00000048)
#define CMP_CRV1_SEL_11_32    ((uint32_t)0x00000050)
#define CMP_CRV1_SEL_12_32    ((uint32_t)0x00000058)
#define CMP_CRV1_SEL_13_32    ((uint32_t)0x00000060)
#define CMP_CRV1_SEL_14_32    ((uint32_t)0x00000068)
#define CMP_CRV1_SEL_15_32    ((uint32_t)0x00000070)
#define CMP_CRV1_SEL_16_32    ((uint32_t)0x00000079)
#define CMP_CRV1_SEL_17_32    ((uint32_t)0x00000080)
#define CMP_CRV1_SEL_18_32    ((uint32_t)0x00000088)
#define CMP_CRV1_SEL_19_32    ((uint32_t)0x00000090)
#define CMP_CRV1_SEL_20_32    ((uint32_t)0x00000098)
#define CMP_CRV1_SEL_21_32    ((uint32_t)0x000000A0)
#define CMP_CRV1_SEL_22_32    ((uint32_t)0x000000A8)
#define CMP_CRV1_SEL_23_32    ((uint32_t)0x000000B0)
#define CMP_CRV1_SEL_24_32    ((uint32_t)0x000000B8)
#define CMP_CRV1_SEL_25_32    ((uint32_t)0x000000C0)
#define CMP_CRV1_SEL_26_32    ((uint32_t)0x000000C8)
#define CMP_CRV1_SEL_27_32    ((uint32_t)0x000000D0)
#define CMP_CRV1_SEL_28_32    ((uint32_t)0x000000D8)
#define CMP_CRV1_SEL_29_32    ((uint32_t)0x000000E0)
#define CMP_CRV1_SEL_30_32    ((uint32_t)0x000000E8)
#define CMP_CRV1_SEL_31_32    ((uint32_t)0x000000F0)
#define CMP_CRV1_SEL_32_32    ((uint32_t)0x000000F8)

#define CMP_CR2_CRV2_SEL        ((uint32_t)0x00001F00)
#define CMP_CRV2_SEL_1_32       ((uint32_t)0x00000000)
#define CMP_CRV2_SEL_2_32       ((uint32_t)0x00000100)
#define CMP_CRV2_SEL_3_32       ((uint32_t)0x00000200)
#define CMP_CRV2_SEL_4_32       ((uint32_t)0x00000300)
#define CMP_CRV2_SEL_5_32       ((uint32_t)0x00000400)
#define CMP_CRV2_SEL_6_32       ((uint32_t)0x00000500)
#define CMP_CRV2_SEL_7_32       ((uint32_t)0x00000600)
#define CMP_CRV2_SEL_8_32       ((uint32_t)0x00000700)
#define CMP_CRV2_SEL_9_32       ((uint32_t)0x00000800)
#define CMP_CRV2_SEL_10_32      ((uint32_t)0x00000900)
#define CMP_CRV2_SEL_11_32      ((uint32_t)0x00000A00)
#define CMP_CRV2_SEL_12_32      ((uint32_t)0x00000B00)
#define CMP_CRV2_SEL_13_32      ((uint32_t)0x00000C00)
#define CMP_CRV2_SEL_14_32      ((uint32_t)0x00000D00)
#define CMP_CRV2_SEL_15_32      ((uint32_t)0x00000E00)
#define CMP_CRV2_SEL_16_32      ((uint32_t)0x00000F00)
#define CMP_CRV2_SEL_17_32      ((uint32_t)0x00001000)
#define CMP_CRV2_SEL_18_32      ((uint32_t)0x00001100)
#define CMP_CRV2_SEL_19_32      ((uint32_t)0x00001200)
#define CMP_CRV2_SEL_20_32      ((uint32_t)0x00001300)
#define CMP_CRV2_SEL_21_32      ((uint32_t)0x00001400)
#define CMP_CRV2_SEL_22_32      ((uint32_t)0x00001500)
#define CMP_CRV2_SEL_23_32      ((uint32_t)0x00001600)
#define CMP_CRV2_SEL_24_32      ((uint32_t)0x00001700)
#define CMP_CRV2_SEL_25_32      ((uint32_t)0x00001800)
#define CMP_CRV2_SEL_26_32      ((uint32_t)0x00001900)
#define CMP_CRV2_SEL_27_32      ((uint32_t)0x00001A00)
#define CMP_CRV2_SEL_28_32      ((uint32_t)0x00001B00)
#define CMP_CRV2_SEL_29_32      ((uint32_t)0x00001C00)
#define CMP_CRV2_SEL_30_32      ((uint32_t)0x00001D00)
#define CMP_CRV2_SEL_31_32      ((uint32_t)0x00001E00)
#define CMP_CRV2_SEL_32_32      ((uint32_t)0x00001F00)

#define CMP_CRV_BAS_EN          ((uint32_t)0x00002000)


/* constant -------------------------------------------------------------*/

/**
  * @brief  Structure definition of some features of CMP instance.
  */
typedef struct
{
//	uint32_t Mode;    /** @arg CMP_CR1_MODE_Ultralow
//                        @arg CMP_CR1_MODE_Low
//                        @arg CMP_CR1_MODE_Medium
//                        @arg CMP_CR1_MODE_High ********/
	uint32_t Pol;	    /** @arg CMP_CR1_POL_Positive
                        @arg CMP_CR1_POL_Negative ********/
	uint32_t Rhyst;   /** @arg CMP_CR1_RHYST_0mV
                        @arg CMP_CR1_RHYST_20mV
                        @arg CMP_CR1_RHYST_40mV
                        @arg CMP_CR1_RHYST_60mV ********/
	uint32_t Fhyst;   /** @arg CMP_CR1_FHYST_0mV
                        @arg CMP_CR1_FHYST_20mV
                        @arg CMP_CR1_FHYST_40mV
                        @arg CMP_CR1_FHYST_60mV ********/
	uint32_t INP_Sel; /** @arg CMP_INP_SEL_1P
	                      @arg CMP_INP_SEL_2P
						            @arg CMP_INP_SEL_3P
	                      @arg CMP_INP_SEL_OPA1_out********/
	uint32_t INM_Sel; /** @arg CMP_INN_SEL_1N 
						            @arg CMP_INN_SEL_2N 
	                      @arg CMP_INN_SEL_3N 
                        @arg CMP_INN_SEL_SRN
                        @arg CMP_INN_SEL_CRV********/
  uint32_t OFLT;		/** @arg CMP_CxCR_OFLT_DIV1    
						            @arg CMP_CxCR_OFLT_DIV32   
	                      @arg CMP_CxCR_OFLT_DIV64   
                        @arg CMP_CxCR_OFLT_DIV128  
                        @arg CMP_CxCR_OFLT_DIV256  						
                        @arg CMP_CxCR_OFLT_DIV512  
                        @arg CMP_CxCR_OFLT_DIV1024 
                        @arg CMP_CxCR_OFLT_DIV2048 ********/
 	uint32_t CRV1SEL; /**  @arg CRV1_SEL_1_32 
                         @arg CRV1_SEL_2_32 
                         @arg CRV1_SEL_3_32 
                         @arg CRV1_SEL_4_32 
                         @arg CRV1_SEL_5_32 
                         @arg CRV1_SEL_6_32 
                         @arg CRV1_SEL_7_32 
                         @arg CRV1_SEL_8_32 
                         @arg CRV1_SEL_9_32 
                         @arg CRV1_SEL_10_32
                         @arg CRV1_SEL_11_32
                         @arg CRV1_SEL_12_32
                         @arg CRV1_SEL_13_32
                         @arg CRV1_SEL_14_32
                         @arg CRV1_SEL_15_32 
					               @arg CRV1_SEL_16_32
					               @arg CRV1_SEL_17_32
					               @arg CRV1_SEL_18_32
					               @arg CRV1_SEL_19_32
					               @arg CRV1_SEL_20_32
					               @arg CRV1_SEL_21_32
					               @arg CRV1_SEL_22_32
					               @arg CRV1_SEL_23_32
					               @arg CRV1_SEL_24_32
					               @arg CRV1_SEL_25_32
					               @arg CRV1_SEL_26_32
					               @arg CRV1_SEL_27_32
					               @arg CRV1_SEL_28_32
					               @arg CRV1_SEL_29_32
					               @arg CRV1_SEL_30_32
					               @arg CRV1_SEL_31_32
                         @arg CRV1_SEL_32_32********/
	uint32_t CRV2SEL; 
	FunctionalState CRV_En;	  /** @arg ENABLE
								                @arg DISABLE ********/
	uint32_t CRV_Src; /** @arg CRV_VREFBUF
		                    @arg VBG(1V)********/
 }CMP_InitTypeDef;  

void CMP_Init(COMP_TypeDef *COMPx, CMP_InitTypeDef *CMP_InitStruct);
void CMP_Enable(COMP_TypeDef *COMPx);
void CMP_Disable(COMP_TypeDef *COMPx);
void CMP_Set_POL(COMP_TypeDef *COMPx, uint32_t Pol);
uint32_t CMP_Read_OUT(COMP_TypeDef *COMPx);
void CMP_Enable_Lock(COMP_TypeDef *COMPx);
 void CMP_Enable_CR1Lock(void);
 void CMP_Enable_CR2Lock(void);
void CMP_Enable_IT(COMP_TypeDef *COMPx, uint32_t IT);
void CMP_Disable_IT(COMP_TypeDef *COMPx, uint32_t IT);
void CMP_Clear_Flag(COMP_TypeDef *COMPx, uint32_t Flag);
uint32_t CMP_Get_Flag(COMP_TypeDef *COMPx, uint32_t Flag);
void CMP_Set_RHYST(COMP_TypeDef *COMPx, uint32_t Rhyst);
void CMP_Set_FHYST(COMP_TypeDef *COMPx, uint32_t Fhyst);
void CMP_Set_INNSEL(COMP_TypeDef *COMPx, uint32_t Innsel);
void CMP_Set_INPSEL(COMP_TypeDef *COMPx, uint32_t Inpsel);
void CMP_Set_BLANKING(COMP_TypeDef *COMPx, uint32_t Blanking);
void CMP_Set_PADJ_DATA(COMP_TypeDef *COMPx, uint32_t offest);
uint32_t CMP_Read_PADJ_DATA(COMP_TypeDef *COMPx);
void CMP_Set_NADJ_DATA(COMP_TypeDef *COMPx, uint32_t offest);
uint32_t CMP_Get_NADJ_DATA(COMP_TypeDef *COMPx);
void CMP_Enable_CALP(COMP_TypeDef *COMPx);
void CMP_Disable_CALP(COMP_TypeDef *COMPx);
void CMP_Enable_CALN(COMP_TypeDef *COMPx);
void CMP_Disable_CALN(COMP_TypeDef *COMPx);
void CMP_Enable_CHBLANK(COMP_TypeDef *COMPx);
void CMP_Disable_CHBLANK(COMP_TypeDef *COMPx);
void CMP_Enable_BAS(COMP_TypeDef *COMPx,uint32_t bas_select);
void CMP_Enable_SRNBAS(void);
void CMP_Enable_CRVBAS(void );
void CMP_Disable_BAS(COMP_TypeDef *COMPx,uint32_t bas_select);
void CMP_Disable_SRNBAS(void);
void CMP_Disable_CRVBAS(void );
void CMP_Enable_CHDIS(COMP_TypeDef *COMPx);
void CMP_Disable_CHDIS(COMP_TypeDef *COMPx);
void CMP_Enable_CHDISBLK(COMP_TypeDef *COMPx);
void CMP_Disable_CHDISBLK(COMP_TypeDef *COMPx);
void CMP_Enable_SRN(void);
void CMP_Disable_SRN(void);
void CMP_Enable_SRNdout(void);
void CMP_Disable_SRNdout(void);
void CMP_Enable_CRV(void);
void CMP_Disable_CRV(void);
void CMP_Set_CRV1SEL(uint32_t val);
void CMP_Set_CRV2SEL(uint32_t val);

#ifdef __cplusplus
}
#endif

#endif /* __rx32s12xx_CMP_H__ */

