/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/

/*
*********************************************************************************************************
*                                              rx32s12xx
*                                           Library Function
*
*                                   Copyright 2021, RX Tech, Corp.
*                                        All Rights Reserved
*
*
* Project      : rx32s12xx
* File         : rx32s12xx_pwr.h
* By           : RX_SD_Team
* Version      : V1.0.0
* Description  : Only rx32s12xx
*********************************************************************************************************
*/
#ifndef __rx32s12xx_PWR_H__
#define __rx32s12xx_PWR_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s12xx.h"

/******************************************************************************/
/*                                                                            */
/*                             Power Control                                  */
/*                                                                            */
/******************************************************************************/

#if defined(PWR)

/** @defgroup PWR
  * @{
  */

/* Private types -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private constants ---------------------------------------------------------*/
/* Private macros ------------------------------------------------------------*/
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/** @defgroup PWR_Exported_Constants PWR Exported Constants
  * @{
  */

/********************  Bit definition for PWR_CR1 register  ********************/
#define PWR_CR1_LPMS_Pos                     (0U)
#define PWR_CR1_LPMS_Msk                     (0x3U << PWR_CR1_LPMS_Pos)          /*!< 0x00000001 */
#define PWR_CR1_LPMS                         PWR_CR1_LPMS_Msk                    /*!< Low-Power Deepsleep */
#define PWR_CR1_LPMS_0                       ((uint32_t)0x00000000U)             /*!< STOP 0 */
#define PWR_CR1_LPMS_1                       ((uint32_t)0x00000001U)             /*!< STOP 1 */
#define PWR_CR1_LPMS_3                       ((uint32_t)0x00000003U)             /*!< STANDBY */

#define PWR_CR1_DBP_Pos                      (8U)
#define PWR_CR1_DBP_Msk                      (0x1U << PWR_CR1_DBP_Pos)          /*!< 0x00000001 */
#define PWR_CR1_DBP                          PWR_CR1_DBP_Msk                    /*!< Low-Power Deepsleep */
//#define PWR_CR_LPDS_Pos                     (0U)
//#define PWR_CR_LPDS_Msk                     (0x1U << PWR_CR_LPDS_Pos)          /*!< 0x00000001 */
//#define PWR_CR_LPDS                         PWR_CR_LPDS_Msk                    /*!< Low-Power Deepsleep */
//#define PWR_CR_PDDS_Pos                     (1U)
//#define PWR_CR_PDDS_Msk                     (0x1U << PWR_CR_PDDS_Pos)          /*!< 0x00000002 */
//#define PWR_CR_PDDS                         PWR_CR_PDDS_Msk                    /*!< Power Down Deepsleep */
////#define PWR_CR_CWUF_Pos                     (2U)
////#define PWR_CR_CWUF_Msk                     (0x1U << PWR_CR_CWUF_Pos)          /*!< 0x00000004 */
////#define PWR_CR_CWUF                         PWR_CR_CWUF_Msk                    /*!< Clear Wakeup Flag */
////#define PWR_CR_CSBF_Pos                     (3U)
////#define PWR_CR_CSBF_Msk                     (0x1U << PWR_CR_CSBF_Pos)          /*!< 0x00000008 */
////#define PWR_CR_CSBF                         PWR_CR_CSBF_Msk                    /*!< Clear Standby Flag */
//#define PWR_CR_PVDE_Pos                     (4U)
//#define PWR_CR_PVDE_Msk                     (0x1U << PWR_CR_PVDE_Pos)          /*!< 0x00000010 */
//#define PWR_CR_PVDE                         PWR_CR_PVDE_Msk                    /*!< Power Voltage Detector Enable */

//#define PWR_CR2_PLS_Pos                      (5U)
//#define PWR_CR2_PLS_Msk                      (0x7U << PWR_CR2_PLS_Pos)           /*!< 0x000000E0 */
//#define PWR_CR2_PLS                          PWR_CR2_PLS_Msk                     /*!< PLS[2:0] bits (PVD Level Selection) */
//#define PWR_CR2_PLS_0                        (0x1U << PWR_CR2_PLS_Pos)           /*!< 0x00000020 */
//#define PWR_CR2_PLS_1                        (0x2U << PWR_CR2_PLS_Pos)           /*!< 0x00000040 */
//#define PWR_CR2_PLS_2                        (0x4U << PWR_CR2_PLS_Pos)           /*!< 0x00000080 */

///*!< PVD level configuration */
//#define PWR_CR2_PLS_LEV0                      0x00000000U                           /*!< PVD level 2.2V */
//#define PWR_CR2_PLS_LEV1                      0x00000020U                           /*!< PVD level 2.3V */
//#define PWR_CR2_PLS_LEV2                      0x00000040U                           /*!< PVD level 2.4V */
//#define PWR_CR2_PLS_LEV3                      0x00000060U                           /*!< PVD level 2.5V */
//#define PWR_CR2_PLS_LEV4                      0x00000080U                           /*!< PVD level 2.6V */
//#define PWR_CR2_PLS_LEV5                      0x000000A0U                           /*!< PVD level 2.7V */
//#define PWR_CR2_PLS_LEV6                      0x000000C0U                           /*!< PVD level 2.8V */
//#define PWR_CR2_PLS_LEV7                      0x000000E0U                           /*!< PVD level 2.9V */

///* Legacy defines */
//#define PWR_CR2_PLS_2V2                       PWR_CR2_PLS_LEV0
//#define PWR_CR2_PLS_2V3                       PWR_CR2_PLS_LEV1
//#define PWR_CR2_PLS_2V4                       PWR_CR2_PLS_LEV2
//#define PWR_CR2_PLS_2V5                       PWR_CR2_PLS_LEV3
//#define PWR_CR2_PLS_2V6                       PWR_CR2_PLS_LEV4
//#define PWR_CR2_PLS_2V7                       PWR_CR2_PLS_LEV5
//#define PWR_CR2_PLS_2V8                       PWR_CR2_PLS_LEV6
//#define PWR_CR2_PLS_2V9                       PWR_CR2_PLS_LEV7

//#define PWR_CR_DBP_Pos                      (8U)
//#define PWR_CR_DBP_Msk                      (0x1U << PWR_CR_DBP_Pos)           /*!< 0x00000100 */
//#define PWR_CR_DBP                          PWR_CR_DBP_Msk                     /*!< Disable Backup Domain write protection */


/*******************  Bit definition for PWR_CSR register  ********************/
//#define PWR_CSR_WUF_Pos                     (0U)
//#define PWR_CSR_WUF_Msk                     (0x1U << PWR_CSR_WUF_Pos)          /*!< 0x00000001 */
//#define PWR_CSR_WUF                         PWR_CSR_WUF_Msk                    /*!< Wakeup Flag */
//#define PWR_CSR_SBF_Pos                     (1U)
//#define PWR_CSR_SBF_Msk                     (0x1U << PWR_CSR_SBF_Pos)          /*!< 0x00000002 */
//#define PWR_CSR_SBF                         PWR_CSR_SBF_Msk                    /*!< Standby Flag */
//#define PWR_CSR_PVDO_Pos                    (2U)
//#define PWR_CSR_PVDO_Msk                    (0x1U << PWR_CSR_PVDO_Pos)         /*!< 0x00000004 */
//#define PWR_CSR_PVDO                        PWR_CSR_PVDO_Msk                   /*!< PVD Output */
//#define PWR_CSR_EWUP_Pos                    (8U)
//#define PWR_CSR_EWUP_Msk                    (0x1U << PWR_CSR_EWUP_Pos)         /*!< 0x00000100 */
//#define PWR_CSR_EWUP                        PWR_CSR_EWUP_Msk                   /*!< Enable WKUP pin */
/*******************  Bit definition for PWR_CR2 register  ********************/
#define PWR_CR2_PVDE_Pos                     (0U)
#define PWR_CR2_PVDE_Msk                     (0x1U << PWR_CR2_PVDE_Pos)          /*!< 0x00000010 */
#define PWR_CR2_PVDE                         PWR_CR2_PVDE_Msk                    /*!< Power Voltage Detector Enable */
              
#define PWR_CR2_PLS_Pos                      (1U)
#define PWR_CR2_PLS_Msk                      (0x7U << PWR_CR2_PLS_Pos)           /*!< 0x000000E0 */
#define PWR_CR2_PLS                          PWR_CR2_PLS_Msk                     /*!< PLS[2:0] bits (PVD Level Selection) */
//#define PWR_CR2_PLS_0                        (0x1U << PWR_CR2_PLS_Pos)           /*!< 0x00000020 */
//#define PWR_CR2_PLS_1                        (0x2U << PWR_CR2_PLS_Pos)           /*!< 0x00000040 */
//#define PWR_CR2_PLS_2                        (0x4U << PWR_CR2_PLS_Pos)           /*!< 0x00000080 */

#define PWR_CR2_PLS_LEV0                         ((uint32_t)0x00000000U)
#define PWR_CR2_PLS_LEV1                         ((uint32_t)0x00000002U)
#define PWR_CR2_PLS_LEV2                         ((uint32_t)0x00000004U)
#define PWR_CR2_PLS_LEV3                         ((uint32_t)0x00000006U)
#define PWR_CR2_PLS_LEV4                         ((uint32_t)0x00000008U)
#define PWR_CR2_PLS_LEV5                         ((uint32_t)0x0000000AU)
#define PWR_CR2_PLS_LEV6                         ((uint32_t)0x0000000CU)
#define PWR_CR2_PLS_LEV7                         ((uint32_t)0x0000000EU)

/*******************  Bit definition for PWR_CR3 register  ********************/
#define PWR_CR3_EWUP1_Pos                   (0U)
#define PWR_CR3_EWUP1_Msk                   (0x1U << PWR_CR3_EWUP1_Pos)         /*!< 0x00000100 */
#define PWR_CR3_EWUP1                       PWR_CR3_EWUP1_Msk                   /*!< Enable WKUP pin */
#define PWR_CR3_EIWUL_Pos                   (15U)
#define PWR_CR3_EIWUL_Msk                   (0x1U << PWR_CR3_EIWUL_Pos)         /*!< 0x00000100 */
#define PWR_CR3_EIWUL                       PWR_CR3_EIWUL_Msk                   /*!< Enable WKUP pin */

/*******************  Bit definition for PWR_CR4 register  ********************/
#define PWR_CR4_WP1_Pos                     (0U)
#define PWR_CR4_WP1_Msk                     (0x1U << PWR_CR4_WP1_Pos)         /*!< 0x00000100 */
#define PWR_CR4_WP1                         PWR_CR4_WP1_Msk                   /*!< Enable WKUP pin */

/*******************  Bit definition for PWR_SR register  ********************/
#define PWR_SR_WUF1_Pos                     (0U)
#define PWR_SR_WUF1_Msk                     (0x1U << PWR_SR_WUF1_Pos)         /*!< 0x00000100 */
#define PWR_SR_WUF1                         PWR_SR_WUF1_Msk                   /*!< Enable WKUP pin */
#define PWR_SR_SBF_Pos                      (8U)
#define PWR_SR_SBF_Msk                      (0x1U << PWR_SR_SBF_Pos)         /*!< 0x00000100 */
#define PWR_SR_SBF                          PWR_SR_SBF_Msk                   /*!< Enable WKUP pin */
#define PWR_SR_WUFI_Pos                     (15U)
#define PWR_SR_WUFI_Msk                     (0x1U << PWR_SR_WUFI_Pos)         /*!< 0x00000100 */
#define PWR_SR_WUFI                         PWR_SR_WUFI_Msk                   /*!< Enable WKUP pin */
/*******************  Bit definition for PWR_SR2 register  ********************/

#define PWR_SR2_PVDO_Pos                    (11U)
#define PWR_SR2_PVDO_Msk                    (0x1U << PWR_SR2_PVDO_Pos)         /*!< 0x00000004 */
#define PWR_SR2_PVDO                        PWR_SR2_PVDO_Msk                   /*!< PVD Output */
/*******************  Bit definition for PWR_SCR register  ********************/
#define PWR_SCR_CWUF1_Pos                     (0U)
#define PWR_SCR_CWUF1_Msk                     (0x1U << PWR_SCR_CWUF1_Pos)         /*!< 0x00000100 */
#define PWR_SCR_CWUF1                         PWR_SCR_CWUF1_Msk                   /*!< Enable WKUP pin */
#define PWR_SCR_CSBF_Pos                      (8U)
#define PWR_SCR_CSBF_Msk                      (0x1U << PWR_SCR_CSBF_Pos)         /*!< 0x00000100 */
#define PWR_SCR_CSBF                          PWR_SCR_CSBF_Msk                   /*!< Enable WKUP pin */
#define PWR_SCR_CWUFI_Pos                     (15U)
#define PWR_SCR_CWUFI_Msk                     (0x1U << PWR_SCR_CWUFI_Pos)         /*!< 0x00000100 */
#define PWR_SCR_CWUFI                         PWR_SCR_CWUFI_Msk                   /*!< Enable WKUP pin */

/** @defgroup PWR_EC_MODE_PWR Mode Power
  * @{
  */
#define PWR_MODE_STOP_MAINREGU             (PWR_CR1_LPMS_0)                    /*!< Enter Stop mode when the CPU enters deepsleep */
#define PWR_MODE_STOP_LPREGU               (PWR_CR1_LPMS_1)                  /*!< Enter Stop mode (with low power Regulator ON) when the CPU enters deepsleep */
#define PWR_MODE_STANDBY                   (PWR_CR1_LPMS_3)                  /*!< Enter Standby mode when the CPU enters deepsleep */
/**
  * @}
  */

/** @defgroup PWR_EC_REGU_MODE_DS_MODE  Regulator Mode In Deep Sleep Mode
 * @{
 */
#define PWR_REGU_DSMODE_MAIN        0x00000000U           /*!< Voltage Regulator in main mode during deepsleep mode */
#define PWR_REGU_DSMODE_LOW_POWER   (PWR_CR_LPDS)         /*!< Voltage Regulator in low-power mode during deepsleep mode */
/**
  * @}
  */

/** @defgroup PWR_EC_PVDLEVEL Power Voltage Detector Level
  * @{
  */
#define PWR_PVDLEVEL_0                  (PWR_CR2_PLS_LEV0)      /*!< Voltage threshold detected by PVD 2.2 V */
#define PWR_PVDLEVEL_1                  (PWR_CR2_PLS_LEV1)      /*!< Voltage threshold detected by PVD 2.3 V */
#define PWR_PVDLEVEL_2                  (PWR_CR2_PLS_LEV2)      /*!< Voltage threshold detected by PVD 2.4 V */
#define PWR_PVDLEVEL_3                  (PWR_CR2_PLS_LEV3)      /*!< Voltage threshold detected by PVD 2.5 V */
#define PWR_PVDLEVEL_4                  (PWR_CR2_PLS_LEV4)      /*!< Voltage threshold detected by PVD 2.6 V */
#define PWR_PVDLEVEL_5                  (PWR_CR2_PLS_LEV5)      /*!< Voltage threshold detected by PVD 2.7 V */
#define PWR_PVDLEVEL_6                  (PWR_CR2_PLS_LEV6)      /*!< Voltage threshold detected by PVD 2.8 V */
#define PWR_PVDLEVEL_7                  (PWR_CR2_PLS_LEV7)      /*!< Voltage threshold detected by PVD 2.9 V */
/**
  * @}
  */
/** @defgroup PWR_EC_WAKEUP_PIN  Wakeup Pins
  * @{
  */
#define PWR_WAKEUP_PIN1                 (PWR_CR3_EWUP1)         /*!< WKUP pin 1 : PA0 */
/**
  * @}
  */

/**
  * @}
  */


/* Exported macro ------------------------------------------------------------*/
/** @defgroup PWR_Exported_Macros PWR Exported Macros
  * @{
  */

/** @defgroup PWR_EM_WRITE_READ Common write and read registers Macros
  * @{
  */

/**
  * @brief  Write a value in PWR register
  * @param  __REG__ Register to be written
  * @param  __VALUE__ Value to be written in the register
  * @retval None
  */
#define PWR_WriteReg(__REG__, __VALUE__) WRITE_REG(PWR->__REG__, (__VALUE__))

/**
  * @brief  Read a value in PWR register
  * @param  __REG__ Register to be read
  * @retval Register value
  */
#define PWR_ReadReg(__REG__) READ_REG(PWR->__REG__)

#define PWR_STOPEntry_WFI      ((uint8_t)0x01)
#define PWR_STOPEntry_WFE      ((uint8_t)0x02)
#define IS_PWR_STOP_ENTRY(ENTRY) (((ENTRY) == PWR_STOPEntry_WFI))  || (((ENTRY) == PWR_STOPEntry_WFE)) 
/**
  * @}
  */

/**
  * @}
  */

/* Exported functions --------------------------------------------------------*/

void PWR_Enable_BkUpAccess(void);
void PWR_Disable_BkUpAccess(void);
uint32_t PWR_Get_BkUpAccess(void);
void PWR_Set_RegulModeDS(uint32_t RegulMode);
uint32_t PWR_Get_RegulModeDS(void);
void PWR_Set_PowerMode(uint32_t PDMode);
uint32_t PWR_Get_PowerMode(void);
void PWR_Set_PVDLevel(uint32_t PVDLevel);
uint32_t PWR_Get_PVDLevel(void);
void PWR_Enable_PVD(void);
void PWR_Disable_PVD(void);
uint32_t PWR_Get_PVD(void);
void PWR_Enable_WakeUpPin(uint32_t WakeUpPin);
void PWR_Disable_WakeUpPin(uint32_t WakeUpPin);
uint32_t PWR_Get_WakeUpPin(uint32_t WakeUpPin);
uint32_t PWR_Get_Flag(uint32_t Flag);
void PWR_Clear_Flag(uint32_t Flag);
void PWR_Enter_STOPMode(void);
void PWR_Enter_STANDBYMode(void);
void PWR_Enter_SLEEPMode(uint8_t SLEEPEntry);

/**
  * @}
  */


/**
  * @}
  */

/**
  * @}
  */

#endif /* defined(PWR) */

#ifdef __cplusplus
}
#endif

#endif /* __rx32s12xx_PWR_H__ */

