/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/

/*
*********************************************************************************************************
*                                              rx32s12xx
*                                           Library Function
*
*                                   Copyright 2021, RX Tech, Corp.
*                                        All Rights Reserved
*
*
* Project      : rx32s12xx
* File         : rx32s12xx_rcc.h
* By           : RX_SD_Team
* Version      : V1.0.0
* Description  : Only rx32s12xx
*********************************************************************************************************
*/
#ifndef _rx32s12xx_RCC_H
#define _rx32s12xx_RCC_H

#ifdef __cplusplus
extern "C" {
#endif

#include "rx32s12xx.h"
#include "main.h"


/* constant -------------------------------------------------------------*/

/*******************  Bit definition for RCC_CR register  *******************/
#define RCC_CR_HSION                  BIT0
#define RCC_CR_HSIRDY                 BIT1
#define RCC_CR_HSICAL                 (0xFF<<8)
#define RCC_CR_PLLON                  BIT24
#define RCC_CR_PLLRDY                 BIT25

#define RCC_CR_PLL_CTR                BIT26
#define RCC_CR_HSI_CTR                BIT28
//#define RCC_CR_HSICTR_MASK           BIT28|BIT29
//#define RCC_CR_HSICTR_00             0x00
//#define RCC_CR_HSICTR_01             BIT28
//#define RCC_CR_HSICTR_10             BIT29
//#define RCC_CR_HSICTR_11             BIT28|BIT29

/*******************  Bit definition for RCC_CFGR register  *******************/
#define RCC_CFGR_SW                    0x03
#define RCC_CFGR_SW_HSI                0x00
#define RCC_CFGR_SW_PLL                0x02
#define RCC_CFGR_SW_LSI                0x03

#define RCC_CFGR_SWS                   BIT2|BIT3
#define RCC_CFGR_SWS_HSI               (0x00<<2)
#define RCC_CFGR_SWS_PLL               (0x02<<2)
#define RCC_CFGR_SWS_LSI               (0x03<<2)

#define RCC_CFGR_HPRE                  (0x0F<<4)
#define RCC_CFGR_HPRE_DIV1             (0x00<<4)
#define RCC_CFGR_HPRE_DIV2             (0x08<<4)
#define RCC_CFGR_HPRE_DIV4             (0x09<<4)
#define RCC_CFGR_HPRE_DIV8             (0x0A<<4)
#define RCC_CFGR_HPRE_DIV16            (0x0B<<4)
#define RCC_CFGR_HPRE_DIV64            (0x0C<<4)
#define RCC_CFGR_HPRE_DIV128           (0x0D<<4)
#define RCC_CFGR_HPRE_DIV256           (0x0E<<4)
#define RCC_CFGR_HPRE_DIV512           (0x0F<<4)

#define RCC_CFGR_PPRE1                 (0x07<<8)
#define RCC_CFGR_PPRE1_DIV1            (0x00<<8)
#define RCC_CFGR_PPRE1_DIV2            (0x04<<8)
#define RCC_CFGR_PPRE1_DIV4            (0x05<<8)
#define RCC_CFGR_PPRE1_DIV8            (0x06<<8)
#define RCC_CFGR_PPRE1_DIV16           (0x07<<8)

#define RCC_CFGR_PPRE2                 (0x07<<11)
#define RCC_CFGR_PPRE2_DIV1            (0x00<<11)
#define RCC_CFGR_PPRE2_DIV2            (0x04<<11)
#define RCC_CFGR_PPRE2_DIV4            (0x05<<11)
#define RCC_CFGR_PPRE2_DIV8            (0x06<<11)
#define RCC_CFGR_PPRE2_DIV16           (0x07<<11)

#define RCC_CFGR_ADCPRE                BIT14|BIT15|BIT31
#define RCC_CFGR_ADCPRE_DIV2           (0x01<<14)
#define RCC_CFGR_ADCPRE_DIV3           (0x02<<14)
#define RCC_CFGR_ADCPRE_DIV4           (0x03<<14)
#define RCC_CFGR_ADCPRE_DIV5           (0x20000<<14)
#define RCC_CFGR_ADCPRE_DIV6           (0x20001<<14)
#define RCC_CFGR_ADCPRE_DIV7           (0x20002<<14)
#define RCC_CFGR_ADCPRE_DIV8           (0x20003<<14)

//#define RCC_CFGR_PLLSRC                BIT16
//#define RCC_CFGR_PLLSRC_HSI            0x00
//#define RCC_CFGR_PLLSRC_HSE            BIT16
//#define RCC_CFGR_PLLXTPRE              BIT17
//#define RCC_CFGR_PLLXTPRE1             BIT31

//#define RCC_CFGR_PLLSRC_HSIDIV2        0x00
//#define RCC_CFGR_PLLSRC_HSIDIV1        BIT31
//#define RCC_CFGR_PLLSRC_HSEDIV1        BIT16
//#define RCC_CFGR_PLLSRC_HSEDIV2        (BIT16|BIT17)

#define RCC_CFGR_PLLMULL          (0x07<<18)
#define RCC_CFGR_PLLMUL_10x             (0x00<<18)
#define RCC_CFGR_PLLMUL_12x             (0x01<<18)
#define RCC_CFGR_PLLMUL_14x             (0x02<<18)
#define RCC_CFGR_PLLMUL_15x             (0x03<<18)
#define RCC_CFGR_PLLMUL_16x             (0x04<<18)
#define RCC_CFGR_PLLMUL_17x             (0x05<<18)
#define RCC_CFGR_PLLMUL_18x             (0x06<<18)
#define RCC_CFGR_PLLMUL_19x             (0x07<<18)
//#define RCC_CFGR_PLLMUL_10x            (0x08<<18)
//#define RCC_CFGR_PLLMUL_11x            (0x09<<18)
//#define RCC_CFGR_PLLMUL_12x            (0x0A<<18)
//#define RCC_CFGR_PLLMUL_13x            (0x0B<<18)
//#define RCC_CFGR_PLLMUL_14x            (0x0C<<18)
//#define RCC_CFGR_PLLMUL_15x            (0x0D<<18)
//#define RCC_CFGR_PLLMUL_16x            (0x0E<<18)

#define RCC_CFGR_MCO_SEL              (0x07<<24)
//#define RCC_CFGR_MCO_NOCLK             (0x00<<24)
#define RCC_CFGR_MCO_LSI               (0x06<<24)
#define RCC_CFGR_MCO_FSYS              (0x01<<24)
#define RCC_CFGR_MCO_HSI               (0x03<<24)
//#define RCC_CFGR_MCO_HSE               (0x06<<24)
#define RCC_CFGR_MCO_PLL               (0x05<<24)

#define RCC_CFGR_MCO_PRE              (0x03<<27)
#define RCC_CFGR_MCO_DIV1             (0x00<<27)
#define RCC_CFGR_MCO_DIV2             (0x01<<27)
#define RCC_CFGR_MCO_DIV4             (0x02<<27)
#define RCC_CFGR_MCO_DIV8             (0x03<<27)

#define RCC_CFGR_ADCCLK_SEL            BIT29
#define RCC_CFGR_ADCCLK_SEL_SYSCLK     0x00
#define RCC_CFGR_ADCCLK_SEL_PLL2       BIT29

//#define RCC_CFGR_PLLXTPRE1             BIT31 
/*******************  Bit definition for RCC_CIR register  *******************/
#define RCC_CIR_LSIRDYF                BIT0
#define RCC_CIR_HSIRDYF                BIT2
//#define RCC_CIR_HSERDYF                BIT3
#define RCC_CIR_PLLRDYF                BIT4
//#define RCC_CIR_CSSF                   BIT7
#define RCC_CIR_LSIRDYIE               BIT8
#define RCC_CIR_HSIRDYIE               BIT10
//#define RCC_CIR_HSERDYIE               BIT11
#define RCC_CIR_PLLRDYIE               BIT12
#define RCC_CIR_LSIRDYC                BIT16
#define RCC_CIR_HSIRDYC                BIT18
//#define RCC_CIR_HSERDYC                BIT19
#define RCC_CIR_PLLRDYC                BIT20
//#define RCC_CIR_CSSC                   BIT23

/*******************  Bit definition for RCC_APB2RSTR register  *******************/
#define RCC_APB2RSTR_SYSCFGRST         BIT0
//#define RCC_APB2RSTR_ADC1RST           BIT9
//#define RCC_APB2RSTR_TIM1RST           BIT11
#define RCC_APB2RSTR_SPI1RST           BIT12
#define RCC_APB2RSTR_TIM8RST           BIT13
#define RCC_APB2RSTR_USART1RST         BIT14
#define RCC_APB2RSTR_TIM15RST          BIT16
//#define RCC_APB2RSTR_OPAMPRST          BIT30
//#define RCC_APB2RSTR_CMPRST            BIT31

/*******************  Bit definition for RCC_APB1RSTR register  *******************/
#define RCC_APB1RSTR_TIM2RST           BIT0
#define RCC_APB1RSTR_TIM3RST           BIT1
//#define RCC_APB1RSTR_TIM4RST           BIT2
#define RCC_APB1RSTR_TIM6RST           BIT4
#define RCC_APB1RSTR_TIM7RST           BIT5
#define RCC_APB1RSTR_USART2RST         BIT17
//#define RCC_APB1RSTR_USART3RST         BIT18
#define RCC_APB1RSTR_I2C1RST           BIT21
//#define RCC_APB1RSTR_CANRST            BIT25
//#define RCC_APB1RSTR_BKPRST            BIT27
#define RCC_APB1RSTR_PWRRST            BIT28

/*******************  Bit definition for RCC_AHBENR register  *******************/
//#define RCC_AHBENR_DMA1EN              BIT0
#define RCC_AHBENR_SRAMEN              BIT2
#define RCC_AHBENR_FLITEN              BIT4
#define RCC_AHBENR_CRCEN               BIT6
#define RCC_AHBENR_MEEN                BIT11
#define RCC_AHBENR_IOPAEN            	 BIT16
#define RCC_AHBENR_IOPBEN            	 BIT17
#define RCC_AHBENR_IOPCEN            	 BIT18
#define RCC_AHBENR_IOPDEN              BIT19
#define RCC_AHBENR_ADC1EN              BIT24
//#define RCC_AHBENR_DAC1EN              BIT28

/*******************  Bit definition for RCC_APB2ENR register  *******************/
#define RCC_APB2ENR_SYSCFGEN           BIT0
//#define RCC_APB2ENR_ADC1EN             BIT9
//#define RCC_APB2ENR_TIM1EN             BIT11
#define RCC_APB2ENR_SPI1EN             BIT12
#define RCC_APB2ENR_TIM8EN             BIT13
#define RCC_APB2ENR_USART1EN           BIT14
#define RCC_APB2ENR_TIM15EN            BIT15
//#define RCC_APB2ENR_OPAMPEN            BIT30
//#define RCC_APB2ENR_CMPEN              BIT31


/*******************  Bit definition for RCC_APB1ENR register  *******************/
#define RCC_APB1ENR_TIM2EN             BIT0
#define RCC_APB1ENR_TIM3EN             BIT1
//#define RCC_APB1ENR_TIM4EN             BIT2
#define RCC_APB1ENR_TIM6EN             BIT4
#define RCC_APB1ENR_TIM7EN             BIT5
#define RCC_APB1ENR_USART2EN           BIT17
//#define RCC_APB1ENR_USART3EN           BIT18
#define RCC_APB1ENR_I2C1EN             BIT21
//#define RCC_APB1ENR_CANEN              BIT25
//#define RCC_APB1ENR_BKPEN              BIT27
#define RCC_APB1ENR_PWREN              BIT28

/*******************  Bit definition for RCC_BDCR register  *******************/
//#define RCC_BDCR_RTCSEL           (0x03<<8)
//#define RCC_BDCR_RTCSEL_NONE           (0x00<<8)
//#define RCC_BDCR_RTCSEL_HSIDIV128      (0x02<<8)
//#define RCC_BDCR_RTCSEL_HSEDIV128      (0x03<<8)

#define RCC_BDCR_RTCEN                 BIT15
#define RCC_BDCR_BDRST                 BIT16

/*******************  Bit definition for RCC_CSR register  *******************/
#define RCC_CSR_LSION                  BIT0
#define RCC_CSR_LSIRDY                 BIT1
#define RCC_CSR_RMVF                   BIT24
#define RCC_CSR_PINRSTF                BIT26
#define RCC_CSR_PORRSTF                BIT27
#define RCC_CSR_SFTRSTF                BIT28
#define RCC_CSR_IWDGRSTF               BIT29
#define RCC_CSR_LPWRRSTF               BIT31


/*******************  Bit definition for RCC_AHBRSTR register  *******************/
//#define RCC_AHBRSTR_DMA1RST            BIT0
#define RCC_AHBRSTR_CRCRST             BIT6
#define RCC_AHBRSTR_MERST              BIT11
#define RCC_AHBRSTR_IOPARST            BIT16
#define RCC_AHBRSTR_IOPBRST            BIT17
#define RCC_AHBRSTR_IOPCRST            BIT18
#define RCC_AHBRSTR_IOPDRST            BIT19
#define RCC_AHBRSTR_ADC1RST            BIT24
//#define RCC_AHBRSTR_DAC1RST            BIT28


/*******************  Bit definition for RCC_HSEDET register  *******************/
//#define RCC_HSEDET_DELTA               0x1F
//#define RCC_HSEDET_FAIL_M0             BIT5
//#define RCC_HSEDET_FAIL_M1             BIT6
//#define RCC_HSEDET_TCNT_UPEN           BIT7

//#define RCC_HSEDET_FCNT_WIDTH          0X07<<8
//#define RCC_HSEDET_FCNT_WIDTH_5bit     0x000
//#define RCC_HSEDET_FCNT_WIDTH_6bit     0x100
//#define RCC_HSEDET_FCNT_WIDTH_7bit     0x200
//#define RCC_HSEDET_FCNT_WIDTH_8bit     0x300
//#define RCC_HSEDET_FCNT_WIDTH_9bit     0x400
//#define RCC_HSEDET_FCNT_WIDTH_10bit    0x500
//#define RCC_HSEDET_FCNT_WIDTH_11bit    0x600

//#define RCC_HSEDET_TOUT                0X7F<<16
//#define RCC_HSEDET_FAIL_M2             BIT31

//#define RCC_HSEDET_FAIL_M2             BIT31
//#define RCC_HSEDET_TCNT_UPEN           BIT7

//#define RCC_HSEDET_FCNT_WIDTH          0x700
//#define RCC_HSEDET_FCNT_WIDTH_5bit     0x000
//#define RCC_HSEDET_FCNT_WIDTH_6bit     0x100
//#define RCC_HSEDET_FCNT_WIDTH_7bit     0x200
//#define RCC_HSEDET_FCNT_WIDTH_8bit     0x300
//#define RCC_HSEDET_FCNT_WIDTH_9bit     0x400
//#define RCC_HSEDET_FCNT_WIDTH_10bit    0x500
//#define RCC_HSEDET_FCNT_WIDTH_11bit    0x600

//#define RCC_HSEDET_TOUT                0x007F0000

/*******************  Bit definition for RCC_PLLDET register  *******************/
#define RCC_PLLDET_DELTA               0x1F
#define RCC_PLLDET_FAIL_M0             BIT5
#define RCC_PLLDET_FAIL_M1             BIT6
#define RCC_PLLDET_TCNT_UPEN           BIT7
#define RCC_PLLDET_FCNT_WIDTH          0x7<<8
#define RCC_PLLDET_TOUT                0XFF<<16
#define RCC_PLLDET_FAIL_M2             BIT31

//#define RCC_PLLDET_FCNT_WIDTH          0x700
#define RCC_PLLDET_FCNT_WIDTH_5bit     0x000
#define RCC_PLLDET_FCNT_WIDTH_6bit     0x100
#define RCC_PLLDET_FCNT_WIDTH_7bit     0x200
#define RCC_PLLDET_FCNT_WIDTH_8bit     0x300
#define RCC_PLLDET_FCNT_WIDTH_9bit     0x400
#define RCC_PLLDET_FCNT_WIDTH_10bit    0x500
#define RCC_PLLDET_FCNT_WIDTH_11bit    0x600

//#define RCC_PLLDET_TOUT                0x00FF0000

/* constant -------------------------------------------------------------*/
typedef struct
{
  uint32_t SYSCLKSource;          /*!< The clock source (SYSCLKS) used as system clock.*/
  
  uint32_t PLLSource;             /*!< PLLSource: PLL entry clock source.*/
	
	uint32_t PLLMUL;                /*!< PLLMUL: PLL frequency multiplication.*/
  
  uint32_t LATENCY;

  uint32_t AHBCLKDivider;         /*!< The AHB clock (HCLK) divider. This clock is derived from the system clock (SYSCLK).*/

  uint32_t APB1CLKDivider;        /*!< The APB1 clock (PCLK1) divider. This clock is derived from the AHB clock (HCLK).*/

  uint32_t APB2CLKDivider;        /*!< The APB2 clock (PCLK2) divider. This clock is derived from the AHB clock (HCLK).*/
	
	uint32_t ADCSource;
   
  uint32_t ADCCLKDivider;         /*!< The ADC clock (ADCCLK) divider. This clock is derived from the APB2 clock (PCLK).*/
} RCC_ClkInitTypeDef;
  
typedef struct
{
  uint32_t SYSCLK_Frequency;        /*!< SYSCLK clock frequency */
  uint32_t HCLK_Frequency;          /*!< HCLK clock frequency */
  uint32_t PCLK1_Frequency;         /*!< PCLK1 clock frequency */
  uint32_t PCLK2_Frequency;         /*!< PCLK2 clock frequency */
} RCC_ClocksTypeDef;  


/* types -------------------------------------------------------------*/
/* functions -------------------------------------------------------------*/
void RCC_ClockConfig(RCC_ClkInitTypeDef  *RCC_ClkInitStruct);
void RCC_Enable_CSS(void);
void RCC_Disable_CSS(void);
void RCC_Enable_HSEBYP(void);
void RCC_Disable_HSEBYP(void);
void RCC_Enable_HSE(void);
void RCC_Disable_HSE(void);
uint32_t RCC_Get_HSERDY(void);
void RCC_Enable_HSI(void);
void RCC_Disable_HSI(void);
uint32_t RCC_Get_HSIRDY(void);
void RCC_Enable_LSI(void);
void RCC_Disable_LSI(void);
uint32_t RCC_Get_LSIRDY(void);
void RCC_Enable_PLL(void);
void RCC_Disable_PLL(void);
uint32_t RCC_Get_PLLRDY(void);
void RCC_Set_PLLMUL(uint32_t PLLMUL);
void RCC_Set_SysClkSource(uint32_t Source);
uint32_t RCC_Get_SysClkSource(void);
void RCC_Set_ADCClkSource(uint32_t Source);
uint32_t RCC_Get_ADCClkSource(void);
void RCC_Set_AHBPrescaler(uint32_t Prescaler);
void RCC_Set_APB1Prescaler(uint32_t Prescaler);
void RCC_Set_APB2Prescaler(uint32_t Prescaler);
void RCC_Set_ADCPrescaler(uint32_t ADCxSource);
uint32_t RCC_Get_AHBPrescaler(void);
uint32_t RCC_Get_APB1Prescaler(void);
uint32_t RCC_Get_APB2Prescaler(void);
uint32_t RCC_Get_ADCPrescaler(void);
void RCC_Select_MCO(uint32_t MCOxSource);
void RCC_Enable_APB1Clock(uint32_t Periphal);
void RCC_Disable_APB1Clock(uint32_t Periphal);
void RCC_Enable_APB2Clock(uint32_t Periphal);
void RCC_Disable_APB2Clock(uint32_t Periphal);
void RCC_Enable_AHBClock(uint32_t Periphal);
void RCC_Disable_AHBClock(uint32_t Periphal);
void RCC_Set_RTCClockSource(uint32_t Source);
uint32_t RCC_Get_RTCClockSource(void);
void RCC_Enable_RTC(void);
void RCC_Disable_RTC(void);
uint32_t RCC_Get_RTC(void);
void RCC_Enable_BDRST(void);
void RCC_Disable_BDRST(void);
void RCC_Enable_APB1RST(uint32_t Periphal);
void RCC_Disable_APB1RST(uint32_t Periphal);
void RCC_Enable_APB2RST(uint32_t Periphal);
void RCC_Disable_APB2RST(uint32_t Periphal);
void RCC_Enable_AHBRST(uint32_t Periphal);
void RCC_Disable_AHBRST(uint32_t Periphal);
uint32_t RCC_Get_RSTFlag(uint32_t FLAG);
void RCC_Clear_RSTFlags(void);
uint32_t RCC_Get_ITFlag(uint32_t InterruptFLAG);
void RCC_Clear_ITFlags(uint32_t InterruptFLAG);
void RCC_Enable_IT(uint32_t Periphal);
void RCC_Disable_IT(uint32_t Periphal);
uint32_t RCC_Get_HSEDET_DELTA(void);
void RCC_Enable_HSEDET_FAIL(uint32_t Periphal);
void RCC_Disable_HSEDET_FAIL(uint32_t Periphal);
uint32_t RCC_Get_HSEDET_TCNT_UPEN(void);
void RCC_Set_HSEDET_FCNT_WIDTH(uint32_t Periphal);
uint32_t RCC_Get_HSEDET_TOUT(void);
uint32_t RCC_Get_PLLDET_DELTA(void);
void RCC_Enable_PLLDET_FAIL(uint32_t Periphal);
void RCC_Disable_PLLDET_FAIL(uint32_t Periphal);
uint32_t RCC_Get_PLLDET_TCNT_UPEN(void);
void RCC_Set_PLLDET_FCNT_WIDTH(uint32_t Periphal);
uint32_t RCC_Get_PLLDET_TOUT(void);
uint32_t RCC_Get_PLLClock(void);
uint32_t RCC_Get_SystemClock(void);
uint32_t RCC_Get_AHBClock(void);
uint32_t RCC_Get_APB1Clock(void);
uint32_t RCC_Get_APB2Clock(void);
uint32_t RCC_Get_ADCClock(void);
void RCC_ConfigMCO(uint32_t MCOxSource, uint32_t MCOxPrescaler);

#ifdef __cplusplus
}
#endif

#endif /* __rx32s12xx_RCC_H__ */

