/*********************************************************************************************
Copyright <2021> <Icore Technology (Nanjing)  Co.,Ltd>
All Rights Reserved,
Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or other materials provided 
with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to 
endorse or promote products derived from this software without specific prior written
permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.
**********************************************************************************************/

/*
*********************************************************************************************************
*                                              rx32s12xx
*                                           Library Function
*
*                                   Copyright 2019, RX Tech, Corp.
*                                        All Rights Reserved
*
*
* Project      : rx32s12xx
* File         : rx32s12xx_tim.h
* By           : RX_SD_Team
* Version      : V1.0.0
* Description  : Only rx32s12xx
*********************************************************************************************************
*/
#ifndef _rx32s12xx_TIM_H
#define _rx32s12xx_TIM_H

#ifdef __cplusplus
extern "C" {
#endif
	
#include "rx32s12xx.h"
#include "main.h"


/*
**********************************************************************************************************
*                         Peripheral Registers_Bits_Definition of TIM Module
**********************************************************************************************************
*/
/**********************  Bit definition for CR1 register of TIM_TypeDef ***********************/
#define  TIM_CR1                                              ((uint32_t)0x03FF)	
#define  TIM_CR1_CEN                                          ((uint32_t)0x0001)          
#define  TIM_CR1_UDIS                                         ((uint32_t)0x0002)           
#define  TIM_CR1_URS                                          ((uint32_t)0x0004)           
#define  TIM_CR1_OPM                                          ((uint32_t)0x0008) 
	
#define  TIM_CR1_DIR                                          ((uint32_t)0x0010)         
#define  TIM_CR1_CMS                                          ((uint32_t)0x0060)
#define  TIM_COUNTERMODE_UP                                   ((uint32_t)0x0000)
#define  TIM_COUNTERMODE_DOWN                                 ((uint32_t)0x0010)
#define  TIM_COUNTERMODE_CENTER_UP                            ((uint32_t)0x0040)
#define  TIM_COUNTERMODE_CENTER_DOWN                          ((uint32_t)0x0020)
#define  TIM_COUNTERMODE_CENTER_UP_DOWN	                      ((uint32_t)0x0060)
        
#define  TIM_CR1_ARPE                                         ((uint32_t)0x0080)          

#define  TIM_CR1_CKD                                          ((uint32_t)0x0300)          
#define  TIM_CR1_CKD_1                                        ((uint32_t)0x0000)        
#define  TIM_CR1_CKD_2                                        ((uint32_t)0x0100)         
#define  TIM_CR1_CKD_4                                        ((uint32_t)0x0200)          
#define  TIM_CR1_CKD_Reserved                                 ((uint32_t)0x0300)    

#define TIM_CR1_UIFREMAP                                      ((uint32_t)0x0800)    
#define TIM_CR1_DITHEN                                        ((uint32_t)0x1000)    

/**********************  Bit definition for CR2 register of TIM_TypeDef ***********************/
#define  TIM_CR2                                              ((uint32_t)0x1FFFD)
#define  TIM_CR2_CCPC                                         ((uint32_t)0x00001)          
#define  TIM_CR2_CCUS                                         ((uint32_t)0x00004)          
#define  TIM_CR2_CCDS                                         ((uint32_t)0x00008)          

#define  TIM_CR2_MMS                                          ((uint32_t)0x00070)           
#define  TIM_CR2_MMS_TRGO_RESET                               ((uint32_t)0x00000)          
#define  TIM_CR2_MMS_TRGO_ENABLE                              ((uint32_t)0x00010)         
#define  TIM_CR2_MMS_TRGO_UPDATE                              ((uint32_t)0x00020)         
#define  TIM_CR2_MMS_TRGO_CC1IF                               ((uint32_t)0x00030)          
#define  TIM_CR2_MMS_TRGO_OC1REF                              ((uint32_t)0x00040)          
#define  TIM_CR2_MMS_TRGO_OC2REF                              ((uint32_t)0x00050)           
#define  TIM_CR2_MMS_TRGO_OC3REF                              ((uint32_t)0x00060)          
#define  TIM_CR2_MMS_TRGO_OC4REF                              ((uint32_t)0x00070)         


#define  TIM_CR2_TI1S                                         ((uint32_t)0x00080)         
#define  TIM_CR2_OIS1                                         ((uint32_t)0x00100)          
#define  TIM_CR2_OIS1N                                        ((uint32_t)0x00200)          
#define  TIM_CR2_OIS2                                         ((uint32_t)0x00400)         
#define  TIM_CR2_OIS2N                                        ((uint32_t)0x00800)         
#define  TIM_CR2_OIS3                                         ((uint32_t)0x01000)           
#define  TIM_CR2_OIS3N                                        ((uint32_t)0x02000)           
#define  TIM_CR2_OIS4                                         ((uint32_t)0x04000)          
#define  TIM_CR2_OIS5                                         ((uint32_t)0x08000)         
#define  TIM_CR2_OIS6                                         ((uint32_t)0x10000)

#define TIM_CR2_MMS2                                          ((uint32_t)0x00F00000)      
#define TIM_CR2_MMS2_0                                        ((uint32_t)0x00100000)      
#define TIM_CR2_MMS2_1                                        ((uint32_t)0x00200000)      
#define TIM_CR2_MMS2_2                                        ((uint32_t)0x00400000)      
#define TIM_CR2_MMS2_3                                        ((uint32_t)0x00800000) 


#define TIM_TRGO2_RESET                     0x00000000U                                                         /*!< UG bit from the TIMx_EGR register is used as trigger output 2 */
#define TIM_TRGO2_ENABLE                    TIM_CR2_MMS2_0                                                      /*!< Counter Enable signal (CNT_EN) is used as trigger output 2 */
#define TIM_TRGO2_UPDATE                    TIM_CR2_MMS2_1                                                      /*!< Update event is used as trigger output 2 */
#define TIM_TRGO2_CC1F                      (TIM_CR2_MMS2_1 | TIM_CR2_MMS2_0)                                   /*!< CC1 capture or a compare match is used as trigger output 2 */
#define TIM_TRGO2_OC1                       TIM_CR2_MMS2_2                                                      /*!< OC1REF signal is used as trigger output 2 */
#define TIM_TRGO2_OC2                       (TIM_CR2_MMS2_2 | TIM_CR2_MMS2_0)                                   /*!< OC2REF signal is used as trigger output 2 */
#define TIM_TRGO2_OC3                       (TIM_CR2_MMS2_2 | TIM_CR2_MMS2_1)                                   /*!< OC3REF signal is used as trigger output 2 */
#define TIM_TRGO2_OC4                       (TIM_CR2_MMS2_2 | TIM_CR2_MMS2_1 | TIM_CR2_MMS2_0)                  /*!< OC4REF signal is used as trigger output 2 */
#define TIM_TRGO2_OC5                       TIM_CR2_MMS2_3                                                      /*!< OC5REF signal is used as trigger output 2 */
#define TIM_TRGO2_OC6                       (TIM_CR2_MMS2_3 | TIM_CR2_MMS2_0)                                   /*!< OC6REF signal is used as trigger output 2 */
#define TIM_TRGO2_OC4_RISINGFALLING         (TIM_CR2_MMS2_3 | TIM_CR2_MMS2_1)                                   /*!< OC4REF rising or falling edges are used as trigger output 2 */
#define TIM_TRGO2_OC6_RISINGFALLING         (TIM_CR2_MMS2_3 | TIM_CR2_MMS2_1 | TIM_CR2_MMS2_0)                  /*!< OC6REF rising or falling edges are used as trigger output 2 */
#define TIM_TRGO2_OC4_RISING_OC6_RISING     (TIM_CR2_MMS2_3 | TIM_CR2_MMS2_2)                                   /*!< OC4REF or OC6REF rising edges are used as trigger output 2 */
#define TIM_TRGO2_OC4_RISING_OC6_FALLING    (TIM_CR2_MMS2_3 | TIM_CR2_MMS2_2 | TIM_CR2_MMS2_0)                  /*!< OC4REF rising or OC6REF falling edges are used as trigger output 2 */
#define TIM_TRGO2_OC5_RISING_OC6_RISING     (TIM_CR2_MMS2_3 | TIM_CR2_MMS2_2 |TIM_CR2_MMS2_1)                   /*!< OC5REF or OC6REF rising edges are used as trigger output 2 */
#define TIM_TRGO2_OC5_RISING_OC6_FALLING    (TIM_CR2_MMS2_3 | TIM_CR2_MMS2_2 | TIM_CR2_MMS2_1 | TIM_CR2_MMS2_0) /*!< OC5REF rising or OC6REF falling edges are used as trigger output 2 */

#define TIM_SMCR_OCCS             ((uint32_t)0x0008)
/**********************  Bit definition for SMCR register of TIM_TypeDef ***********************/
#define  TIM_SMCR                                             ((uint32_t)0x31FFF7)

#define TIM_SMCR_SMS_Pos          (0U)
#define TIM_SMCR_SMS_Msk          (0x10007UL << TIM_SMCR_SMS_Pos)              /*!< 0x00010007 */
#define TIM_SMCR_SMS              TIM_SMCR_SMS_Msk                             /*!<SMS[2:0] bits (Slave mode selection) */
#define TIM_SMCR_SMS_0            (0x00001UL << TIM_SMCR_SMS_Pos)              /*!< 0x00000001 */
#define TIM_SMCR_SMS_1            (0x00002UL << TIM_SMCR_SMS_Pos)              /*!< 0x00000002 */
#define TIM_SMCR_SMS_2            (0x00004UL << TIM_SMCR_SMS_Pos)              /*!< 0x00000004 */
#define TIM_SMCR_SMS_3            (0x10000UL << TIM_SMCR_SMS_Pos)              /*!< 0x00010000 */
        
#define  TIM_SMCR_SMS_DISABLED                                ((uint32_t)0x0000)          
#define  TIM_SMCR_SMS_ENCODER1                                ((uint32_t)0x0001)          
#define  TIM_SMCR_SMS_ENCODER2                                ((uint32_t)0x0002)          
#define  TIM_SMCR_SMS_ENCODER3                                ((uint32_t)0x0003)          
#define  TIM_SMCR_SMS_RESET                                   ((uint32_t)0x0004)         
#define  TIM_SMCR_SMS_GATEDRESET                              ((uint32_t)0x0005)        
#define  TIM_SMCR_SMS_TRIGGER                                 ((uint32_t)0x0006)         
#define  TIM_SMCR_SMS_EXTCLOCK1                               ((uint32_t)0x0007) 
#define  TIM_SMCR_SMS_COMBINED_RESETTRIGGER                   ((uint32_t)0x010000)
#define  TIM_SMCR_SMS_COMBINED_GATEDRESET                     ((uint32_t)0x010001)



#define TIM_ENCODERMODE_X2_TI1                      TIM_SMCR_SMS_0                                                      /*!< Quadrature encoder mode 1, x2 mode, counts up/down on TI1FP1 edge depending on TI2FP2 level  */
#define TIM_ENCODERMODE_X2_TI2                      TIM_SMCR_SMS_1                                                      /*!< Quadrature encoder mode 2, x2 mode, counts up/down on TI2FP2 edge depending on TI1FP1 level. */
#define TIM_ENCODERMODE_X4_TI12                     (TIM_SMCR_SMS_1 | TIM_SMCR_SMS_0)                                   /*!< Quadrature encoder mode 3, x4 mode, counts up/down on both TI1FP1 and TI2FP2 edges depending on the level of the other input. */
#define TIM_ENCODERMODE_CLOCKPLUSDIRECTION_X2    (TIM_SMCR_SMS_3 | TIM_SMCR_SMS_1)                                   /*!< Encoder mode: Clock plus direction, x2 mode */
#define TIM_ENCODERMODE_CLOCKPLUSDIRECTION_X1    (TIM_SMCR_SMS_3 | TIM_SMCR_SMS_1 | TIM_SMCR_SMS_0)                  /*!< Encoder mode: Clock plus direction, x1 mode, TI2FP2 edge sensitivity is set by CC2P */
#define TIM_ENCODERMODE_DIRECTIONALCLOCK_X2      (TIM_SMCR_SMS_3 | TIM_SMCR_SMS_2)                                   /*!< Encoder mode: Directional Clock, x2 mode */
#define TIM_ENCODERMODE_DIRECTIONALCLOCK_X1_TI12 (TIM_SMCR_SMS_3 | TIM_SMCR_SMS_2 | TIM_SMCR_SMS_0)                  /*!< Encoder mode: Directional Clock, x1 mode, TI1FP1 and TI2FP2 edge sensitivity is set by CC1P and CC2P */
#define TIM_ENCODERMODE_X1_TI1                   (TIM_SMCR_SMS_3 | TIM_SMCR_SMS_2 | TIM_SMCR_SMS_1)                  /*!< Quadrature encoder mode: x1 mode, counting on TI1FP1 edges only, edge sensitivity is set by CC1P */
#define TIM_ENCODERMODE_X1_TI2                   (TIM_SMCR_SMS_3 | TIM_SMCR_SMS_2 | TIM_SMCR_SMS_1 | TIM_SMCR_SMS_0) /*!< Quadrature encoder mode: x1 mode, counting on TI2FP2 edges only, edge sensitivity is set by CC1P */


#define  TIM_SMCR_TS                                          ((uint32_t)0x300070)          
#define  TIM_SMCR_TS_ITR0                                     ((uint32_t)0x0000)       
#define  TIM_SMCR_TS_ITR1                                     ((uint32_t)0x0010)         
#define  TIM_SMCR_TS_ITR2                                     ((uint32_t)0x0020)          
#define  TIM_SMCR_TS_ITR3                                     ((uint32_t)0x0030)          
#define  TIM_SMCR_TS_TI1F_ED                                  ((uint32_t)0x0040)          
#define  TIM_SMCR_TS_TI1FP1                                   ((uint32_t)0x0050)         
#define  TIM_SMCR_TS_TI2FP2                                   ((uint32_t)0x0060)          
#define  TIM_SMCR_TS_ETRF                                     ((uint32_t)0x0070)  
#define  TIM_SMCR_TS_ITR4                                     ((uint32_t)0x100000) 
#define  TIM_SMCR_TS_ITR5                                     ((uint32_t)0x100010)
#define  TIM_SMCR_TS_ITR6                                     ((uint32_t)0x100020)
#define  TIM_SMCR_TS_ITR7                                     ((uint32_t)0x100030)
#define  TIM_SMCR_TS_ITR8                                     ((uint32_t)0x100040)
#define  TIM_SMCR_TS_ITR9                                     ((uint32_t)0x100050)
#define  TIM_SMCR_TS_ITR10                                    ((uint32_t)0x100060)


#define  TIM_SMCR_MSM                                         ((uint32_t)0x0080)         

#define  TIM_SMCR_ETF                                         ((uint32_t)0x0F00)          
#define  TIM_SMCR_ETF_FDIV1                                   ((uint32_t)0x0000) 
#define  TIM_SMCR_ETF_FDIV1_N2                                ((uint32_t)0x0100) 
#define  TIM_SMCR_ETF_FDIV1_N4                                ((uint32_t)0x0200) 
#define  TIM_SMCR_ETF_FDIV1_N8                                ((uint32_t)0x0300) 
#define  TIM_SMCR_ETF_FDIV2_N6                                ((uint32_t)0x0400) 
#define  TIM_SMCR_ETF_FDIV2_N8                                ((uint32_t)0x0500) 
#define  TIM_SMCR_ETF_FDIV4_N6                                ((uint32_t)0x0600) 
#define  TIM_SMCR_ETF_FDIV4_N8                                ((uint32_t)0x0700) 
#define  TIM_SMCR_ETF_FDIV8_N6                                ((uint32_t)0x0800) 
#define  TIM_SMCR_ETF_FDIV8_N8                                ((uint32_t)0x0900) 
#define  TIM_SMCR_ETF_FDIV16_N5                               ((uint32_t)0x0A00) 
#define  TIM_SMCR_ETF_FDIV16_N6                               ((uint32_t)0x0B00) 
#define  TIM_SMCR_ETF_FDIV16_N8                               ((uint32_t)0x0C00) 
#define  TIM_SMCR_ETF_FDIV32_N5                               ((uint32_t)0x0D00) 
#define  TIM_SMCR_ETF_FDIV32_N6                               ((uint32_t)0x0E00) 
#define  TIM_SMCR_ETF_FDIV32_N8                               ((uint32_t)0x0F00) 

#define  TIM_SMCR_ETPS                                        ((uint32_t)0x3000)         
#define  TIM_SMCR_ETPS_DIV1                                   ((uint32_t)0x0000)        
#define  TIM_SMCR_ETPS_DIV2                                   ((uint32_t)0x1000)       
#define  TIM_SMCR_ETPS_DIV4                                   ((uint32_t)0x2000)          
#define  TIM_SMCR_ETPS_DIV8                                   ((uint32_t)0x3000)          


#define  TIM_SMCR_ECE                                         ((uint32_t)0x4000)          
#define  TIM_SMCR_ETP                                         ((uint32_t)0x8000)        

#define TIM_SMCR_SMSPE                                        ((uint32_t)0x01000000)  
#define TIM_SMCR_SMSPS                                        ((uint32_t)0x02000000)

/**********************  Bit definition for DIER register of TIM_TypeDef ***********************/
#define  TIM_DIER                                             ((uint32_t)0x7FFFF)
#define  TIM_DIER_UIE                                         ((uint32_t)0x00001)         
#define  TIM_DIER_CC1IE                                       ((uint32_t)0x00002)          
#define  TIM_DIER_CC2IE                                       ((uint32_t)0x00004)          
#define  TIM_DIER_CC3IE                                       ((uint32_t)0x00008)           
#define  TIM_DIER_CC4IE                                       ((uint32_t)0x00010)          
#define  TIM_DIER_COMIE                                       ((uint32_t)0x00020)          
#define  TIM_DIER_TIE                                         ((uint32_t)0x00040)         
#define  TIM_DIER_BIE                                         ((uint32_t)0x00080)         
#define  TIM_DIER_UDE                                         ((uint32_t)0x00100)         
#define  TIM_DIER_CC1DE                                       ((uint32_t)0x00200)        
#define  TIM_DIER_CC2DE                                       ((uint32_t)0x00400)          
#define  TIM_DIER_CC3DE                                       ((uint32_t)0x00800)          
#define  TIM_DIER_CC4DE                                       ((uint32_t)0x01000)          
#define  TIM_DIER_COMDE                                       ((uint32_t)0x02000)          
#define  TIM_DIER_TDE                                         ((uint32_t)0x04000)         
#define  TIM_DIER_CC5IE                                       ((uint32_t)0x08000)          
#define  TIM_DIER_CC5DE                                       ((uint32_t)0x10000)        
#define  TIM_DIER_CC6IE                                       ((uint32_t)0x20000)          
#define  TIM_DIER_CC6DE                                       ((uint32_t)0x40000)
#define  TIM_DIER_IDXIE                                       ((uint32_t)0x10000) 
#define  TIM_DIER_DIRIE                                       ((uint32_t)0x20000) 
#define  TIM_DIER_IERRIE                                      ((uint32_t)0x40000)
#define  TIM_DIER_TERRIE                                      ((uint32_t)0x80000)


/**********************  Bit definition for SR register of TIM_TypeDef ***********************/
#define  TIM_SR                                               ((uint32_t)0xFFFFFF)
#define  TIM_SR_UIF                                           ((uint32_t)0x0001)          
#define  TIM_SR_CC1IF                                         ((uint32_t)0x0002)          
#define  TIM_SR_CC2IF                                         ((uint32_t)0x0004)           
#define  TIM_SR_CC3IF                                         ((uint32_t)0x0008)         
#define  TIM_SR_CC4IF                                         ((uint32_t)0x0010)   
#define  TIM_SR_CC5IF                                         ((uint32_t)0x0010000) 
#define  TIM_SR_CC6IF                                         ((uint32_t)0x0020000) 
#define  TIM_SR_COMIF                                         ((uint32_t)0x0020)          
#define  TIM_SR_TIF                                           ((uint32_t)0x0040)          
#define  TIM_SR_BIF                                           ((uint32_t)0x0080)          
#define  TIM_SR_B2IF                                          ((uint32_t)0x0100)   

#define  TIM_SR_CC1OF                                         ((uint32_t)0x0200)          
#define  TIM_SR_CC2OF                                         ((uint32_t)0x0400)          
#define  TIM_SR_CC3OF                                         ((uint32_t)0x0800)          
#define  TIM_SR_CC4OF                                         ((uint32_t)0x1000) 
#define  TIM_SR_SBIF                                          ((uint32_t)0x2000) 
 
#define  TIM_SR_IDXF                                          ((uint32_t)0x100000)
#define  TIM_SR_DIRF                                          ((uint32_t)0x200000)
#define  TIM_SR_IERRF                                         ((uint32_t)0x400000)
#define  TIM_SR_TERRF                                         ((uint32_t)0x800000)

 
/**********************  Bit definition for EGR register of TIM_TypeDef ***********************/
#define  TIM_EGR                                              ((uint32_t)0x03FF)
#define  TIM_EGR_UG                                           ((uint32_t)0x0001)          
#define  TIM_EGR_CC1G                                         ((uint32_t)0x0002)          
#define  TIM_EGR_CC2G                                         ((uint32_t)0x0004)          
#define  TIM_EGR_CC3G                                         ((uint32_t)0x0008)           
#define  TIM_EGR_CC4G                                         ((uint32_t)0x0010)           
#define  TIM_EGR_COMG                                         ((uint32_t)0x0020)          
#define  TIM_EGR_TG                                           ((uint32_t)0x0040)          
#define  TIM_EGR_BG                                           ((uint32_t)0x0080)          
#define  TIM_EGR_CC5G                                         ((uint32_t)0x0100)          
#define  TIM_EGR_CC6G                                         ((uint32_t)0x0200)

/**********************  Bit definition for CCMR1 register of TIM_TypeDef ***********************/
#define  TIM_CCMR1                                            ((uint32_t)0xFFFF)
#define  TIM_CCMR1_CC1S                                       ((uint32_t)0x0003)           
#define  TIM_CCMR1_CC1S_OUTPUT                                ((uint32_t)0x0000)           
#define  TIM_CCMR1_CC1S_INPUT_TI1                             ((uint32_t)0x0001)           
#define  TIM_CCMR1_CC1S_INPUT_TI2                             ((uint32_t)0x0002)           
#define  TIM_CCMR1_CC1S_INPUT_TRC                             ((uint32_t)0x0003)           

#define  TIM_CCMR1_OC1FE                                      ((uint32_t)0x0004)           
#define  TIM_CCMR1_OC1PE                                      ((uint32_t)0x0008)          

#define  TIM_CCMR1_OC1M                                       ((uint32_t)0x10070)           
#define  TIM_CCMR1_OC1M_FROZEN                                ((uint32_t)0x00000)
#define  TIM_CCMR1_OC1M_ACTIVE                                ((uint32_t)0x00010)
#define  TIM_CCMR1_OC1M_INACTIVE                              ((uint32_t)0x00020)
#define  TIM_CCMR1_OC1M_TOGGLE                                ((uint32_t)0x00030)
#define  TIM_CCMR1_OC1M_FORCED_INACTIVE                       ((uint32_t)0x00040)
#define  TIM_CCMR1_OC1M_FORCED_ACTIVE                         ((uint32_t)0x00050)
#define  TIM_CCMR1_OC1M_PWM1                                  ((uint32_t)0x00060)
#define  TIM_CCMR1_OC1M_PWM2                                  ((uint32_t)0x00070)
#define  TIM_CCMR1_OC1M_RETRIG_OPM1                           ((uint32_t)0x10000)
#define  TIM_CCMR1_OC1M_RETRIG_OPM2                           ((uint32_t)0x10010)
#define  TIM_CCMR1_OC1M_COMBINED_PWM1                         ((uint32_t)0x10040)
#define  TIM_CCMR1_OC1M_COMBINED_PWM2                         ((uint32_t)0x10050)
#define  TIM_CCMR1_OC1M_ASSYMETRIC_PWM1                       ((uint32_t)0x10060)
#define  TIM_CCMR1_OC1M_ASSYMETRIC_PWM2                       ((uint32_t)0x10070)
#define  TIM_CCMR1_OC1M_PULSE_ON_COMPARE                      ((uint32_t)0x10020)
#define  TIM_CCMR1_OC1M_DIRECTION_OUTPUT                      ((uint32_t)0x10030)

#define  TIM_CCMR1_OC1CE                                      ((uint32_t)0x0080)          

#define  TIM_CCMR1_CC2S                                       ((uint32_t)0x0300)           
#define  TIM_CCMR1_CC2S_OUTPUT                                ((uint32_t)0x0000)
#define  TIM_CCMR1_CC2S_INPUT_TI2                             ((uint32_t)0x0100)
#define  TIM_CCMR1_CC2S_INPUT_TI1                             ((uint32_t)0x0200)
#define  TIM_CCMR1_CC2S_INPUT_TRC                             ((uint32_t)0x0300)

#define  TIM_CCMR1_OC2FE                                      ((uint32_t)0x0400)          
#define  TIM_CCMR1_OC2PE                                      ((uint32_t)0x0800)           

#define  TIM_CCMR1_OC2M                                       ((uint32_t)0x1007000)          
#define  TIM_CCMR1_OC2M_FROZEN                                ((uint32_t)0x0000)
#define  TIM_CCMR1_OC2M_ACTIVE                                ((uint32_t)0x1000)
#define  TIM_CCMR1_OC2M_INACTIVE                              ((uint32_t)0x2000)
#define  TIM_CCMR1_OC2M_TOGGLE                                ((uint32_t)0x3000)
#define  TIM_CCMR1_OC2M_FORCED_INACTIVE                       ((uint32_t)0x4000)
#define  TIM_CCMR1_OC2M_FORCED_ACTIVE                         ((uint32_t)0x5000)
#define  TIM_CCMR1_OC2M_PWM1                                  ((uint32_t)0x6000)
#define  TIM_CCMR1_OC2M_PWM2                                  ((uint32_t)0x7000)

#define  TIM_CCMR1_OC2CE                                      ((uint32_t)0x8000)          

/*----------------------------------------------------------------------------*/

#define  TIM_CCMR1_IC1PSC                                     ((uint16_t)0x000C)            /*!< IC1PSC[1:0] bits (Input Capture 1 Prescaler) */
#define  TIM_CCMR1_IC1PSC_DIV1                                ((uint16_t)0x0000)            
#define  TIM_CCMR1_IC1PSC_DIV2                                ((uint16_t)0x0004)            
#define  TIM_CCMR1_IC1PSC_DIV4                                ((uint16_t)0x0008) 
#define  TIM_CCMR1_IC1PSC_DIV8                                ((uint16_t)0x000C) 

#define  TIM_CCMR1_IC1F                                       ((uint16_t)0x00F0)            /*!< IC1F[3:0] bits (Input Capture 1 Filter) */
#define  TIM_CCMR1_IC1F_FDIV1                                 ((uint16_t)0x0000)            
#define  TIM_CCMR1_IC1F_FDIV1_N2                              ((uint16_t)0x0010)            
#define  TIM_CCMR1_IC1F_FDIV1_N4                              ((uint16_t)0x0020)            
#define  TIM_CCMR1_IC1F_FDIV1_N8                              ((uint16_t)0x0030)            
#define  TIM_CCMR1_IC1F_FDIV2_N6                              ((uint16_t)0x0040)
#define  TIM_CCMR1_IC1F_FDIV2_N8                              ((uint16_t)0x0050)
#define  TIM_CCMR1_IC1F_FDIV4_N6                              ((uint16_t)0x0060)
#define  TIM_CCMR1_IC1F_FDIV4_N8                              ((uint16_t)0x0070)
#define  TIM_CCMR1_IC1F_FDIV8_N6                              ((uint16_t)0x0080)
#define  TIM_CCMR1_IC1F_FDIV8_N8                              ((uint16_t)0x0090)
#define  TIM_CCMR1_IC1F_FDIV16_N5                             ((uint16_t)0x00A0)
#define  TIM_CCMR1_IC1F_FDIV16_N6                             ((uint16_t)0x00B0)
#define  TIM_CCMR1_IC1F_FDIV16_N8                             ((uint16_t)0x00C0)
#define  TIM_CCMR1_IC1F_FDIV32_N5                             ((uint16_t)0x00D0)
#define  TIM_CCMR1_IC1F_FDIV32_N6                             ((uint16_t)0x00E0)
#define  TIM_CCMR1_IC1F_FDIV32_N8                             ((uint16_t)0x00F0)

#define  TIM_CCMR1_IC2PSC                                     ((uint16_t)0x0C00)            /*!< IC2PSC[1:0] bits (Input Capture 1 Prescaler) */
#define  TIM_CCMR1_IC2PSC_DIV1                                ((uint16_t)0x0000)            
#define  TIM_CCMR1_IC2PSC_DIV2                                ((uint16_t)0x0400)            
#define  TIM_CCMR1_IC2PSC_DIV4                                ((uint16_t)0x0800) 
#define  TIM_CCMR1_IC2PSC_DIV8                                ((uint16_t)0x0C00)

#define  TIM_CCMR1_IC2F                                       ((uint16_t)0xF000)            /*!< IC2F[3:0] bits (Input Capture 1 Filter) */
#define  TIM_CCMR1_IC2F_FDIV1                                 ((uint16_t)0x0000)            
#define  TIM_CCMR1_IC2F_FDIV1_N2                              ((uint16_t)0x1000)            
#define  TIM_CCMR1_IC2F_FDIV1_N4                              ((uint16_t)0x2000)            
#define  TIM_CCMR1_IC2F_FDIV1_N8                              ((uint16_t)0x3000)            
#define  TIM_CCMR1_IC2F_FDIV2_N6                              ((uint16_t)0x4000)
#define  TIM_CCMR1_IC2F_FDIV2_N8                              ((uint16_t)0x5000)
#define  TIM_CCMR1_IC2F_FDIV4_N6                              ((uint16_t)0x6000)
#define  TIM_CCMR1_IC2F_FDIV4_N8                              ((uint16_t)0x7000)
#define  TIM_CCMR1_IC2F_FDIV8_N6                              ((uint16_t)0x8000)
#define  TIM_CCMR1_IC2F_FDIV8_N8                              ((uint16_t)0x9000)
#define  TIM_CCMR1_IC2F_FDIV16_N5                             ((uint16_t)0xA000)
#define  TIM_CCMR1_IC2F_FDIV16_N6                             ((uint16_t)0xB000)
#define  TIM_CCMR1_IC2F_FDIV16_N8                             ((uint16_t)0xC000)
#define  TIM_CCMR1_IC2F_FDIV32_N5                             ((uint16_t)0xD000)
#define  TIM_CCMR1_IC2F_FDIV32_N6                             ((uint16_t)0xE000)
#define  TIM_CCMR1_IC2F_FDIV32_N8                             ((uint16_t)0xF000)

/**********************  Bit definition for CCMR2 register of TIM_TypeDef ***********************/
#define  TIM_CCMR2                                            ((uint32_t)0xFFFF)
#define  TIM_CCMR2_CC3S                                       ((uint32_t)0x0003)           
#define  TIM_CCMR2_CC3S_OUTPUT                                ((uint32_t)0x0000)           
#define  TIM_CCMR2_CC3S_INPUT_TI3                             ((uint32_t)0x0001)           
#define  TIM_CCMR2_CC3S_INPUT_TI4                             ((uint32_t)0x0002)         
#define  TIM_CCMR2_CC3S_INPUT_TRC                             ((uint32_t)0x0003)          

#define  TIM_CCMR2_OC3FE                                      ((uint32_t)0x0004)          
#define  TIM_CCMR2_OC3PE                                      ((uint32_t)0x0008)         

#define  TIM_CCMR2_OC3M                                       ((uint32_t)0x0070)           
#define  TIM_CCMR2_OC3M_FROZEN                                ((uint32_t)0x0000)
#define  TIM_CCMR2_OC3M_ACTIVE                                ((uint32_t)0x0010)
#define  TIM_CCMR2_OC3M_INACTIVE                              ((uint32_t)0x0020)
#define  TIM_CCMR2_OC3M_TOGGLE                                ((uint32_t)0x0030)
#define  TIM_CCMR2_OC3M_FORCED_INACTIVE                       ((uint32_t)0x0040)
#define  TIM_CCMR2_OC3M_FORCED_ACTIVE                         ((uint32_t)0x0050)
#define  TIM_CCMR2_OC3M_PWM1                                  ((uint32_t)0x0060)
#define  TIM_CCMR2_OC3M_PWM2                                  ((uint32_t)0x0070)

#define  TIM_CCMR2_OC3CE                                      ((uint32_t)0x0080)          

#define  TIM_CCMR2_CC4S                                       ((uint32_t)0x0300)          
#define  TIM_CCMR2_CC4S_OUTPUT                                ((uint32_t)0x0000)
#define  TIM_CCMR2_CC4S_INPUT_TI4                             ((uint32_t)0x0100)
#define  TIM_CCMR2_CC4S_INPUT_TI3                             ((uint32_t)0x0200)
#define  TIM_CCMR2_CC4S_INPUT_TRC                             ((uint32_t)0x0300)

#define  TIM_CCMR2_OC4FE                                      ((uint32_t)0x0400)          
#define  TIM_CCMR2_OC4PE                                      ((uint32_t)0x0800)          

#define  TIM_CCMR2_OC4M                                       ((uint32_t)0x7000)          
#define  TIM_CCMR2_OC4M_FROZEN                                ((uint32_t)0x0000)
#define  TIM_CCMR2_OC4M_ACTIVE                                ((uint32_t)0x1000)
#define  TIM_CCMR2_OC4M_INACTIVE                              ((uint32_t)0x2000)
#define  TIM_CCMR2_OC4M_TOGGLE                                ((uint32_t)0x3000)
#define  TIM_CCMR2_OC4M_FORCED_INACTIVE                       ((uint32_t)0x4000)
#define  TIM_CCMR2_OC4M_FORCED_ACTIVE                         ((uint32_t)0x5000)
#define  TIM_CCMR2_OC4M_PWM1                                  ((uint32_t)0x6000)
#define  TIM_CCMR2_OC4M_PWM2                                  ((uint32_t)0x7000)

#define  TIM_CCMR2_OC4CE                                      ((uint32_t)0x8000)         

/*----------------------------------------------------------------------------*/
#define  TIM_CCMR2_IC3PSC                                     ((uint16_t)0x000C)            /*!< IC1PSC[1:0] bits (Input Capture 1 Prescaler) */
#define  TIM_CCMR2_IC3PSC_DIV1                                ((uint16_t)0x0000)            
#define  TIM_CCMR2_IC3PSC_DIV2                                ((uint16_t)0x0004)            
#define  TIM_CCMR2_IC3PSC_DIV4                                ((uint16_t)0x0008) 
#define  TIM_CCMR2_IC3PSC_DIV8                                ((uint16_t)0x000C) 

#define  TIM_CCMR2_IC3F                                       ((uint16_t)0x00F0)            /*!< IC1F[3:0] bits (Input Capture 1 Filter) */
#define  TIM_CCMR2_IC3F_FDIV1                                 ((uint16_t)0x0000)            
#define  TIM_CCMR2_IC3F_FDIV1_N2                              ((uint16_t)0x0010)            
#define  TIM_CCMR2_IC3F_FDIV1_N4                              ((uint16_t)0x0020)            
#define  TIM_CCMR2_IC3F_FDIV1_N8                              ((uint16_t)0x0030)            
#define  TIM_CCMR2_IC3F_FDIV2_N6                              ((uint16_t)0x0040)
#define  TIM_CCMR2_IC3F_FDIV2_N8                              ((uint16_t)0x0050)
#define  TIM_CCMR2_IC3F_FDIV4_N6                              ((uint16_t)0x0060)
#define  TIM_CCMR2_IC3F_FDIV4_N8                              ((uint16_t)0x0070)
#define  TIM_CCMR2_IC3F_FDIV8_N6                              ((uint16_t)0x0080)
#define  TIM_CCMR2_IC3F_FDIV8_N8                              ((uint16_t)0x0090)
#define  TIM_CCMR2_IC3F_FDIV16_N5                             ((uint16_t)0x00A0)
#define  TIM_CCMR2_IC3F_FDIV16_N6                             ((uint16_t)0x00B0)
#define  TIM_CCMR2_IC3F_FDIV16_N8                             ((uint16_t)0x00C0)
#define  TIM_CCMR2_IC3F_FDIV32_N5                             ((uint16_t)0x00D0)
#define  TIM_CCMR2_IC3F_FDIV32_N6                             ((uint16_t)0x00E0)
#define  TIM_CCMR2_IC3F_FDIV32_N8                             ((uint16_t)0x00F0)

#define  TIM_CCMR2_IC4PSC                                     ((uint16_t)0x0C00)            /*!< IC2PSC[1:0] bits (Input Capture 1 Prescaler) */
#define  TIM_CCMR2_IC4PSC_DIV1                                ((uint16_t)0x0000)            
#define  TIM_CCMR2_IC4PSC_DIV2                                ((uint16_t)0x0400)            
#define  TIM_CCMR2_IC4PSC_DIV4                                ((uint16_t)0x0800) 
#define  TIM_CCMR2_IC4PSC_DIV8                                ((uint16_t)0x0C00)

#define  TIM_CCMR2_IC4F                                       ((uint16_t)0xF000)            /*!< IC2F[3:0] bits (Input Capture 1 Filter) */
#define  TIM_CCMR2_IC4F_FDIV1                                 ((uint16_t)0x0000)            
#define  TIM_CCMR2_IC4F_FDIV1_N2                              ((uint16_t)0x1000)            
#define  TIM_CCMR2_IC4F_FDIV1_N4                              ((uint16_t)0x2000)            
#define  TIM_CCMR2_IC4F_FDIV1_N8                              ((uint16_t)0x3000)            
#define  TIM_CCMR2_IC4F_FDIV2_N6                              ((uint16_t)0x4000)
#define  TIM_CCMR2_IC4F_FDIV2_N8                              ((uint16_t)0x5000)
#define  TIM_CCMR2_IC4F_FDIV4_N6                              ((uint16_t)0x6000)
#define  TIM_CCMR2_IC4F_FDIV4_N8                              ((uint16_t)0x7000)
#define  TIM_CCMR2_IC4F_FDIV8_N6                              ((uint16_t)0x8000)
#define  TIM_CCMR2_IC4F_FDIV8_N8                              ((uint16_t)0x9000)
#define  TIM_CCMR2_IC4F_FDIV16_N5                             ((uint16_t)0xA000)
#define  TIM_CCMR2_IC4F_FDIV16_N6                             ((uint16_t)0xB000)
#define  TIM_CCMR2_IC4F_FDIV16_N8                             ((uint16_t)0xC000)
#define  TIM_CCMR2_IC4F_FDIV32_N5                             ((uint16_t)0xD000)
#define  TIM_CCMR2_IC4F_FDIV32_N6                             ((uint16_t)0xE000)
#define  TIM_CCMR2_IC4F_FDIV32_N8                             ((uint16_t)0xF000)

/**********************  Bit definition for CCER register of TIM_TypeDef ***********************/
#define  TIM_CCER                                             ((uint32_t)0x3FFFF)
#define  TIM_CCER_CC1E                                        ((uint32_t)0x00001)          
#define  TIM_CCER_CC1P                                        ((uint32_t)0x00002)           
#define  TIM_CCER_CC1NE                                       ((uint32_t)0x00004)          
#define  TIM_CCER_CC1NP                                       ((uint32_t)0x00008)          
#define  TIM_CCER_CC2E                                        ((uint32_t)0x00010)          
#define  TIM_CCER_CC2P                                        ((uint32_t)0x00020)          
#define  TIM_CCER_CC2NE                                       ((uint32_t)0x00040)          
#define  TIM_CCER_CC2NP                                       ((uint32_t)0x00080)          
#define  TIM_CCER_CC3E                                        ((uint32_t)0x00100)          
#define  TIM_CCER_CC3P                                        ((uint32_t)0x00200)          
#define  TIM_CCER_CC3NE                                       ((uint32_t)0x00400)         
#define  TIM_CCER_CC3NP                                       ((uint32_t)0x00800)          
#define  TIM_CCER_CC4E                                        ((uint32_t)0x01000)         
#define  TIM_CCER_CC4P                                        ((uint32_t)0x02000)          
#define  TIM_CCER_CC5E                                        ((uint32_t)0x04000)          
#define  TIM_CCER_CC5P                                        ((uint32_t)0x08000)          
#define  TIM_CCER_CC6E                                        ((uint32_t)0x10000)          
#define  TIM_CCER_CC6P                                        ((uint32_t)0x20000) 

/**********************  Bit definition for CNT register of TIM_TypeDef ***********************/
#define  TIM_CNT                                              ((uint32_t)0xFFFF)          
#define  TIM_CNT_UIFCPY                                       ((uint32_t)0x80000000)

/**********************  Bit definition for PSC register of TIM_TypeDef ***********************/
#define  TIM_PSC                                              ((uint32_t)0xFFFF)         

/**********************  Bit definition for ARR register of TIM_TypeDef ***********************/
#define  TIM_ARR                                              ((uint32_t)0xFFFF)           

/**********************  Bit definition for RCR register of TIM_TypeDef ***********************/
#define  TIM_RCR                                              ((uint32_t)0x00FF)          

/**********************  Bit definition for CCR1 register of TIM_TypeDef ***********************/
#define  TIM_CCR1                                             ((uint32_t)0xFFFF)           

/**********************  Bit definition for CCR2 register of TIM_TypeDef ***********************/
#define  TIM_CCR2                                             ((uint32_t)0xFFFF)          

/**********************  Bit definition for CCR3 register of TIM_TypeDef ***********************/
#define  TIM_CCR3                                             ((uint32_t)0xFFFF)          

/**********************  Bit definition for CCR4 register of TIM_TypeDef ***********************/
#define  TIM_CCR4                                             ((uint32_t)0xFFFF)         
       
/*******************  Bit definition for TIM_CCR5 register  *******************/
#define TIM_CCR5_CCR5_Pos         (0U)
#define TIM_CCR5_CCR5_Msk         (0xFFFFFFFFUL << TIM_CCR5_CCR5_Pos)          /*!< 0xFFFFFFFF */
#define TIM_CCR5_CCR5             TIM_CCR5_CCR5_Msk                            /*!<Capture/Compare 5 Value */
#define TIM_CCR5_GC5C1_Pos        (29U)
#define TIM_CCR5_GC5C1_Msk        (0x1UL << TIM_CCR5_GC5C1_Pos)                /*!< 0x20000000 */
#define TIM_CCR5_GC5C1            TIM_CCR5_GC5C1_Msk                           /*!<Group Channel 5 and Channel 1 */
#define TIM_CCR5_GC5C2_Pos        (30U)
#define TIM_CCR5_GC5C2_Msk        (0x1UL << TIM_CCR5_GC5C2_Pos)                /*!< 0x40000000 */
#define TIM_CCR5_GC5C2            TIM_CCR5_GC5C2_Msk                           /*!<Group Channel 5 and Channel 2 */
#define TIM_CCR5_GC5C3_Pos        (31U)
#define TIM_CCR5_GC5C3_Msk        (0x1UL << TIM_CCR5_GC5C3_Pos)                /*!< 0x80000000 */
#define TIM_CCR5_GC5C3            TIM_CCR5_GC5C3_Msk                           /*!<Group Channel 5 and Channel 3 */

/*******************  Bit definition for TIM_CCR6 register  *******************/
#define TIM_CCR6_CCR6_Pos         (0U)
#define TIM_CCR6_CCR6_Msk         (0xFFFFUL << TIM_CCR6_CCR6_Pos)              /*!< 0x0000FFFF */
#define TIM_CCR6_CCR6             TIM_CCR6_CCR6_Msk                            /*!<Capture/Compare 6 Value */

       
/*******************  Bit definition for TIM_BDTR register  *******************/
#define TIM_BDTR_DTG_Pos          (0U)
#define TIM_BDTR_DTG_Msk          (0xFFUL << TIM_BDTR_DTG_Pos)                 /*!< 0x000000FF */
#define TIM_BDTR_DTG              TIM_BDTR_DTG_Msk                             /*!<DTG[0:7] bits (Dead-Time Generator set-up) */
#define TIM_BDTR_DTG_0            (0x01UL << TIM_BDTR_DTG_Pos)                 /*!< 0x00000001 */
#define TIM_BDTR_DTG_1            (0x02UL << TIM_BDTR_DTG_Pos)                 /*!< 0x00000002 */
#define TIM_BDTR_DTG_2            (0x04UL << TIM_BDTR_DTG_Pos)                 /*!< 0x00000004 */
#define TIM_BDTR_DTG_3            (0x08UL << TIM_BDTR_DTG_Pos)                 /*!< 0x00000008 */
#define TIM_BDTR_DTG_4            (0x10UL << TIM_BDTR_DTG_Pos)                 /*!< 0x00000010 */
#define TIM_BDTR_DTG_5            (0x20UL << TIM_BDTR_DTG_Pos)                 /*!< 0x00000020 */
#define TIM_BDTR_DTG_6            (0x40UL << TIM_BDTR_DTG_Pos)                 /*!< 0x00000040 */
#define TIM_BDTR_DTG_7            (0x80UL << TIM_BDTR_DTG_Pos)                 /*!< 0x00000080 */


#define TIM_BDTR_BKF_Pos          (16U)
#define TIM_BDTR_BKF_Msk          (0xFUL << TIM_BDTR_BKF_Pos)                  /*!< 0x000F0000 */
#define TIM_BDTR_BKF              TIM_BDTR_BKF_Msk                             /*!<Break Filter for Break 1 */
#define TIM_BDTR_BK2F_Pos         (20U)
#define TIM_BDTR_BK2F_Msk         (0xFUL << TIM_BDTR_BK2F_Pos)                 /*!< 0x00F00000 */
#define TIM_BDTR_BK2F             TIM_BDTR_BK2F_Msk                            /*!<Break Filter for Break 2 */

#define TIM_BDTR_BK2E_Pos         (24U)
#define TIM_BDTR_BK2E_Msk         (0x1UL << TIM_BDTR_BK2E_Pos)                 /*!< 0x01000000 */
#define TIM_BDTR_BK2E             TIM_BDTR_BK2E_Msk                            /*!<Break enable for Break 2 */
#define TIM_BDTR_BK2P_Pos         (25U)
#define TIM_BDTR_BK2P_Msk         (0x1UL << TIM_BDTR_BK2P_Pos)                 /*!< 0x02000000 */
#define TIM_BDTR_BK2P             TIM_BDTR_BK2P_Msk                            /*!<Break Polarity for Break 2 */

#define TIM_BDTR_BKDSRM_Pos       (26U)
#define TIM_BDTR_BKDSRM_Msk       (0x1UL << TIM_BDTR_BKDSRM_Pos)               /*!< 0x04000000 */
#define TIM_BDTR_BKDSRM           TIM_BDTR_BKDSRM_Msk                          /*!<Break disarming/re-arming */
#define TIM_BDTR_BK2DSRM_Pos      (27U)
#define TIM_BDTR_BK2DSRM_Msk      (0x1UL << TIM_BDTR_BK2DSRM_Pos)              /*!< 0x08000000 */
#define TIM_BDTR_BK2DSRM          TIM_BDTR_BK2DSRM_Msk                         /*!<Break2 disarming/re-arming */

#define TIM_BDTR_BKBID_Pos        (28U)
#define TIM_BDTR_BKBID_Msk        (0x1UL << TIM_BDTR_BKBID_Pos)                /*!< 0x10000000 */
#define TIM_BDTR_BKBID            TIM_BDTR_BKBID_Msk                           /*!<Break BIDirectional */
#define TIM_BDTR_BK2BID_Pos       (29U)
#define TIM_BDTR_BK2BID_Msk       (0x1UL << TIM_BDTR_BK2BID_Pos)               /*!< 0x20000000 */
#define TIM_BDTR_BK2BID           TIM_BDTR_BK2BID_Msk                          /*!<Break2 BIDirectional */

#define  TIM_BDTR                                             ((uint32_t)0x0FFFFFFF)          
#define  TIM_BDTR_LOCK                                        ((uint32_t)0x00000300)         
#define  TIM_BDTR_LOCK_OFF                                    ((uint32_t)0x00000000)         
#define  TIM_BDTR_LOCK_1                                      ((uint32_t)0x00000100)        
#define  TIM_BDTR_LOCK_2                                      ((uint32_t)0x00000200)        
#define  TIM_BDTR_LOCK_3                                      ((uint32_t)0x00000300)        


#define  TIM_BDTR_OSSI                                        ((uint32_t)0x00000400)          
#define  TIM_BDTR_OSSR                                        ((uint32_t)0x00000800)          
#define  TIM_BDTR_BKE                                         ((uint32_t)0x00001000)          
#define  TIM_BDTR_BKP                                         ((uint32_t)0x00002000) 
#define  TIM_BDTR_AOE                                         ((uint32_t)0x00004000)
#define  TIM_BDTR_MOE                                         ((uint32_t)0x00008000)

#define  TIM_BREAK_AFMODE_INPUT              0x00000000U              /*!< Break input BRK in input mode */
#define  TIM_BREAK_AFMODE_BIDIRECTIONAL      TIM_BDTR_BKBID           /*!< Break input BRK in bidirectional mode */

#define  TIM_BDTR_CMP1_OE                                     ((uint32_t)0x00010000)
#define  TIM_BDTR_CMP1_OEP                                    ((uint32_t)0x00020000)
#define  TIM_CMP1OEP_POLARITY_LOW                             ((uint32_t)0x00000000)
#define  TIM_CMP1OEP_POLARITY_HIGH                            ((uint32_t)0x00020000)

#define  TIM_BDTR_CMP2_OE                                     ((uint32_t)0x00040000)
#define  TIM_BDTR_CMP2_OEP                                    ((uint32_t)0x00080000)
#define  TIM_CMP2OEP_POLARITY_LOW                             ((uint32_t)0x00000000)
#define  TIM_CMP2OEP_POLARITY_HIGH                            ((uint32_t)0x00080000)

#define  TIM_BDTR_CMP3_OE                                     ((uint32_t)0x00100000)
#define  TIM_BDTR_CMP3_OEP                                    ((uint32_t)0x00200000)
#define  TIM_CMP3OEP_POLARITY_LOW                             ((uint32_t)0x00000000)
#define  TIM_CMP3OEP_POLARITY_HIGH                            ((uint32_t)0x00200000)

#define  TIM_BDTR_Hardfault_OE                                ((uint32_t)0x00400000)
#define  TIM_BDTR_PVD_OE                                      ((uint32_t)0x00800000)

//#define  TIM_BDTR_BKF                                         ((uint32_t)0x0F000000)
#define  TIM_BDTR_BKF_FDIV1                                   ((uint32_t)0x00000000)
#define  TIM_BDTR_BKF_FDIV1_N2                                ((uint32_t)0x01000000)
#define  TIM_BDTR_BKF_FDIV1_N4                                ((uint32_t)0x02000000)
#define  TIM_BDTR_BKF_FDIV1_N8                                ((uint32_t)0x03000000)
#define  TIM_BDTR_BKF_FDIV2_N6                                ((uint32_t)0x04000000)
#define  TIM_BDTR_BKF_FDIV2_N8                                ((uint32_t)0x05000000)
#define  TIM_BDTR_BKF_FDIV4_N6                                ((uint32_t)0x06000000)
#define  TIM_BDTR_BKF_FDIV4_N8                                ((uint32_t)0x07000000)
#define  TIM_BDTR_BKF_FDIV8_N6                                ((uint32_t)0x08000000)
#define  TIM_BDTR_BKF_FDIV8_N8                                ((uint32_t)0x09000000)
#define  TIM_BDTR_BKF_FDIV16_N5                               ((uint32_t)0x0A000000)
#define  TIM_BDTR_BKF_FDIV16_N6                               ((uint32_t)0x0B000000)
#define  TIM_BDTR_BKF_FDIV16_N8                               ((uint32_t)0x0C000000)
#define  TIM_BDTR_BKF_FDIV32_N5                               ((uint32_t)0x0D000000)
#define  TIM_BDTR_BKF_FDIV32_N6                               ((uint32_t)0x0E000000)
#define  TIM_BDTR_BKF_FDIV32_N8                               ((uint32_t)0x0F000000)


#define TIM_BREAK_FILTER_FDIV1              0x00000000U   /*!< No filter, BRK acts asynchronously */
#define TIM_BREAK_FILTER_FDIV1_N2           0x00010000U   /*!< fSAMPLING=fCK_INT, N=2 */
#define TIM_BREAK_FILTER_FDIV1_N4           0x00020000U   /*!< fSAMPLING=fCK_INT, N=4 */
#define TIM_BREAK_FILTER_FDIV1_N8           0x00030000U   /*!< fSAMPLING=fCK_INT, N=8 */
#define TIM_BREAK_FILTER_FDIV2_N6           0x00040000U   /*!< fSAMPLING=fDTS/2, N=6 */
#define TIM_BREAK_FILTER_FDIV2_N8           0x00050000U   /*!< fSAMPLING=fDTS/2, N=8 */
#define TIM_BREAK_FILTER_FDIV4_N6           0x00060000U   /*!< fSAMPLING=fDTS/4, N=6 */
#define TIM_BREAK_FILTER_FDIV4_N8           0x00070000U   /*!< fSAMPLING=fDTS/4, N=8 */
#define TIM_BREAK_FILTER_FDIV8_N6           0x00080000U   /*!< fSAMPLING=fDTS/8, N=6 */
#define TIM_BREAK_FILTER_FDIV8_N8           0x00090000U   /*!< fSAMPLING=fDTS/8, N=8 */
#define TIM_BREAK_FILTER_FDIV16_N5          0x000A0000U   /*!< fSAMPLING=fDTS/16, N=5 */
#define TIM_BREAK_FILTER_FDIV16_N6          0x000B0000U   /*!< fSAMPLING=fDTS/16, N=6 */
#define TIM_BREAK_FILTER_FDIV16_N8          0x000C0000U   /*!< fSAMPLING=fDTS/16, N=8 */
#define TIM_BREAK_FILTER_FDIV32_N5          0x000D0000U   /*!< fSAMPLING=fDTS/32, N=5 */
#define TIM_BREAK_FILTER_FDIV32_N6          0x000E0000U   /*!< fSAMPLING=fDTS/32, N=6 */
#define TIM_BREAK_FILTER_FDIV32_N8          0x000F0000U   /*!< fSAMPLING=fDTS/32, N=8 */
       
/**********************  Bit definition for DCR register of TIM_TypeDef ***********************/
#define  TIM_DCR                                              ((uint32_t)0x1F3F)          
#define  TIM_DCR_DBA                                          ((uint32_t)0x001F)
#define  TIM_DCR_DBA_BASEADDR_CR1                             ((uint32_t)0x0000)
#define  TIM_DCR_DBA_BASEADDR_CR2                             ((uint32_t)0x0001)
#define  TIM_DCR_DBA_BASEADDR_SMCR                            ((uint32_t)0x0002)
#define  TIM_DCR_DBA_BASEADDR_DIER                            ((uint32_t)0x0003)
#define  TIM_DCR_DBA_BASEADDR_SR                              ((uint32_t)0x0004)
#define  TIM_DCR_DBA_BASEADDR_EGR                             ((uint32_t)0x0005)
#define  TIM_DCR_DBA_BASEADDR_CCMR1                           ((uint32_t)0x0006)
#define  TIM_DCR_DBA_BASEADDR_CCMR2                           ((uint32_t)0x0007)
#define  TIM_DCR_DBA_BASEADDR_CCER                            ((uint32_t)0x0008)
#define  TIM_DCR_DBA_BASEADDR_CNT                             ((uint32_t)0x0009)
#define  TIM_DCR_DBA_BASEADDR_PSC                             ((uint32_t)0x000A)
#define  TIM_DCR_DBA_BASEADDR_ARR                             ((uint32_t)0x000B)
#define  TIM_DCR_DBA_BASEADDR_RCR                             ((uint32_t)0x000C)
#define  TIM_DCR_DBA_BASEADDR_CCR1                            ((uint32_t)0x000D)
#define  TIM_DCR_DBA_BASEADDR_CCR2                            ((uint32_t)0x000E)
#define  TIM_DCR_DBA_BASEADDR_CCR3                            ((uint32_t)0x000F)
#define  TIM_DCR_DBA_BASEADDR_CCR4                            ((uint32_t)0x0010)
#define  TIM_DCR_DBA_BASEADDR_BDTR                            ((uint32_t)0x0011)
#define  TIM_DCR_DBA_BASEADDR_DCR                             ((uint32_t)0x0012)
#define  TIM_DCR_DBA_BASEADDR_DMAR                            ((uint32_t)0x0013)
#define  TIM_DCR_DBA_BASEADDR_CCR5                            ((uint32_t)0x0014)
#define  TIM_DCR_DBA_BASEADDR_CCMR3                           ((uint32_t)0x0015)
#define  TIM_DCR_DBA_BASEADDR_CCR6                            ((uint32_t)0x0016)
#define  TIM_DCR_DBA_BASEADDR_CCR1N                           ((uint32_t)0x0017)
#define  TIM_DCR_DBA_BASEADDR_CCR2N                           ((uint32_t)0x0018)
#define  TIM_DCR_DBA_BASEADDR_CCR3N                           ((uint32_t)0x0019)

#define  TIM_DCR_INDEX_RESET                                  ((uint32_t)0x0020)

#define  TIM_DCR_DBL                                          ((uint32_t)0x1F00)
#define  TIM_DCR_LENGTH_1                                     ((uint32_t)0x0000)
#define  TIM_DCR_LENGTH_2                                     ((uint32_t)0x0100)
#define  TIM_DCR_LENGTH_3                                     ((uint32_t)0x0200)
#define  TIM_DCR_LENGTH_4                                     ((uint32_t)0x0300)
#define  TIM_DCR_LENGTH_5                                     ((uint32_t)0x0400)
#define  TIM_DCR_LENGTH_6                                     ((uint32_t)0x0500)
#define  TIM_DCR_LENGTH_7                                     ((uint32_t)0x0600)
#define  TIM_DCR_LENGTH_8                                     ((uint32_t)0x0700)
#define  TIM_DCR_LENGTH_9                                     ((uint32_t)0x0800)
#define  TIM_DCR_LENGTH_10                                    ((uint32_t)0x0900)
#define  TIM_DCR_LENGTH_11                                    ((uint32_t)0x0A00)
#define  TIM_DCR_LENGTH_12                                    ((uint32_t)0x0B00)
#define  TIM_DCR_LENGTH_13                                    ((uint32_t)0x0C00)
#define  TIM_DCR_LENGTH_14                                    ((uint32_t)0x0D00)
#define  TIM_DCR_LENGTH_15                                    ((uint32_t)0x0E00)
#define  TIM_DCR_LENGTH_16                                    ((uint32_t)0x0F00)
#define  TIM_DCR_LENGTH_17                                    ((uint32_t)0x1000)
#define  TIM_DCR_LENGTH_18                                    ((uint32_t)0x1100)

/**********************  Bit definition for DMAR register of TIM_TypeDef ***********************/
#define  TIM_DMAR                                             ((uint32_t)0xFFFF)         

///**********************  Bit definition for CCR5 register of TIM_TypeDef ***********************/
//#define  TIM_CCR5                                             ((uint32_t)0xFFFF)          
//#define  TIM_CCR5_GC5C1                                       ((uint32_t)0x20000000)  
//#define  TIM_CCR5_GC5C2                                       ((uint32_t)0x40000000)  
//#define  TIM_CCR5_GC5C3                                       ((uint32_t)0x80000000)  

#define  TIM_GROUPCH5_NONE                   0x00000000U           /*!< No effect of OC5REF on OC1REFC, OC2REFC and OC3REFC */
#define  TIM_GROUPCH5_OC1REFC                TIM_CCR5_GC5C1        /*!< OC1REFC is the logical AND of OC1REFC and OC5REF */
#define  TIM_GROUPCH5_OC2REFC                TIM_CCR5_GC5C2        /*!< OC2REFC is the logical AND of OC2REFC and OC5REF */
#define  TIM_GROUPCH5_OC3REFC                TIM_CCR5_GC5C3        /*!< OC3REFC is the logical AND of OC3REFC and OC5REF */


/**********************  Bit definition for CCMR3 register of TIM_TypeDef *****************/
#define  TIM_CCMR3                                            ((uint32_t)0xFCFC)           
#define  TIM_CCMR3_OC5FE                                      ((uint32_t)0x0004) 
#define  TIM_CCMR3_OC5PE                                      ((uint32_t)0x0008)
      
#define  TIM_CCMR3_OC5M                                       ((uint32_t)0x0070)           
#define  TIM_CCMR3_OC5M_FROZEN                                ((uint32_t)0x0000)
#define  TIM_CCMR3_OC5M_ACTIVE                                ((uint32_t)0x0010)
#define  TIM_CCMR3_OC5M_INACTIVE                              ((uint32_t)0x0020)
#define  TIM_CCMR3_OC5M_TOGGLE                                ((uint32_t)0x0030)
#define  TIM_CCMR3_OC5M_FORCED_INACTIVE                       ((uint32_t)0x0040)
#define  TIM_CCMR3_OC5M_FORCED_ACTIVE                         ((uint32_t)0x0050)
#define  TIM_CCMR3_OC5M_PWM1                                  ((uint32_t)0x0060)
#define  TIM_CCMR3_OC5M_PWM2                                  ((uint32_t)0x0070)

#define  TIM_CCMR3_OC5CE                                      ((uint32_t)0x0080)          
#define  TIM_CCMR3_OC6FE                                      ((uint32_t)0x0400) 
#define  TIM_CCMR3_OC6PE                                      ((uint32_t)0x0800)

#define  TIM_CCMR3_OC6M                                       ((uint32_t)0x7000)           
#define  TIM_CCMR3_OC6M_FROZEN                                ((uint32_t)0x0000)
#define  TIM_CCMR3_OC6M_ACTIVE                                ((uint32_t)0x1000)
#define  TIM_CCMR3_OC6M_INACTIVE                              ((uint32_t)0x2000)
#define  TIM_CCMR3_OC6M_TOGGLE                                ((uint32_t)0x3000)
#define  TIM_CCMR3_OC6M_FORCED_INACTIVE                       ((uint32_t)0x4000)
#define  TIM_CCMR3_OC6M_FORCED_ACTIVE                         ((uint32_t)0x5000)
#define  TIM_CCMR3_OC6M_PWM1                                  ((uint32_t)0x6000)
#define  TIM_CCMR3_OC6M_PWM2                                  ((uint32_t)0x7000)

#define  TIM_CCMR3_OC6CE                                      ((uint32_t)0x8000)

 

/**********************  Bit definition for CCR1N register of TIM_TypeDef ***********************/
#define  TIM_CCR1N                                            ((uint32_t)0xFFFF) 
#define  TIM_CCR1N_EN                                         ((uint32_t)0x80000000) 

/**********************  Bit definition for CCR2N register of TIM_TypeDef ***********************/
#define  TIM_CCR2N                                            ((uint32_t)0xFFFF) 
#define  TIM_CCR2N_EN                                         ((uint32_t)0x80000000) 

/**********************  Bit definition for CCR3N register of TIM_TypeDef ***********************/
#define  TIM_CCR3N                                            ((uint32_t)0xFFFF) 
#define  TIM_CCR3N_EN                                         ((uint32_t)0x80000000) 

/**********************  Bit definition for CCR4N register of TIM_TypeDef ***********************/
#define  TIM_CCR4N                                            ((uint32_t)0xFFFF) 
#define  TIM_CCR4N_EN                                         ((uint32_t)0x80000000) 

/**********************  Bit definition for CCRxN register of TIM_TypeDef ***********************/
#define  TIM_CCRxN                                            ((uint32_t)0xFFFF) 
#define  TIM_CCRxN_EN                                         ((uint32_t)0x80000000) 

/**********************  Bit definition for BIC register of TIM_TypeDef ***********************/
#define  TIM_BIC                                              ((uint32_t)0x0000003F) 
#define  TIM_BICE_EN                                          ((uint32_t)0x00000001) 
#define  TIM_BICS_CH1_EN                                      ((uint32_t)0x00000002) 
#define  TIM_BICS_CH2_EN                                      ((uint32_t)0x00000004) 
#define  TIM_BICS_CH3_EN                                      ((uint32_t)0x00000008) 
#define  TIM_BICS_CH4_EN                                      ((uint32_t)0x00000010) 
#define  TIM_BICS_CH5_EN                                      ((uint32_t)0x00000020) 
#define  TIM_BICS_CH6_EN                                      ((uint32_t)0x00000040) 


/*******************  Bit definition for TIM_DTR2 register  *********************/
#define TIM_DTR2_DTGF          ((uint32_t)0x000000FF) 
#define TIM_DTR2_DTGF_0        ((uint32_t)0x00000001)
#define TIM_DTR2_DTGF_1        ((uint32_t)0x00000002)
#define TIM_DTR2_DTGF_2        ((uint32_t)0x00000004)
#define TIM_DTR2_DTGF_3        ((uint32_t)0x00000008)
#define TIM_DTR2_DTGF_4        ((uint32_t)0x00000010)
#define TIM_DTR2_DTGF_5        ((uint32_t)0x00000020)
#define TIM_DTR2_DTGF_6        ((uint32_t)0x00000040)
#define TIM_DTR2_DTGF_7        ((uint32_t)0x00000080)

#define TIM_DTR2_DTAE          ((uint32_t)0x00010000)
#define TIM_DTR2_DTPE          ((uint32_t)0x00020000)

/*******************  Bit definition for TIM_ECR register  *********************/
#define TIM_ECR_IE            ((uint32_t)0x00000001) 

#define TIM_ECR_IDIR          ((uint32_t)0x00000006) 
#define TIM_ECR_IDIR_0        ((uint32_t)0x00000002)      
#define TIM_ECR_IDIR_1        ((uint32_t)0x00000004)      

#define TIM_ECR_FIDX          ((uint32_t)0x00000020) 

#define TIM_ECR_IPOS          ((uint32_t)0x0000000C0)
#define TIM_ECR_IPOS_0        ((uint32_t)0x000000040)
#define TIM_ECR_IPOS_1        ((uint32_t)0x000000080)

#define TIM_ECR_PW            ((uint32_t)0x00FF0000)
#define TIM_ECR_PW_0          ((uint32_t)0x00010000)
#define TIM_ECR_PW_1          ((uint32_t)0x00020000)
#define TIM_ECR_PW_2          ((uint32_t)0x00040000)
#define TIM_ECR_PW_3          ((uint32_t)0x00080000)
#define TIM_ECR_PW_4          ((uint32_t)0x00100000)
#define TIM_ECR_PW_5          ((uint32_t)0x00200000)
#define TIM_ECR_PW_6          ((uint32_t)0x00400000)
#define TIM_ECR_PW_7          ((uint32_t)0x00800000)

#define TIM_ECR_PWPRSC        ((uint32_t)0x07000000)
#define TIM_ECR_PWPRSC_0      ((uint32_t)0x01000000)
#define TIM_ECR_PWPRSC_1      ((uint32_t)0x02000000)
#define TIM_ECR_PWPRSC_2      ((uint32_t)0x04000000)

#define TIM_PWPRSC_X1          0x00000000U                                              /*!< Pulse on compare pulse width prescaler 1 */
#define TIM_PWPRSC_X2          TIM_ECR_PWPRSC_0                                         /*!< Pulse on compare pulse width prescaler 2 */
#define TIM_PWPRSC_X4          TIM_ECR_PWPRSC_1                                         /*!< Pulse on compare pulse width prescaler 4 */
#define TIM_PWPRSC_X8          (TIM_ECR_PWPRSC_1 | TIM_ECR_PWPRSC_0)                    /*!< Pulse on compare pulse width prescaler 8 */
#define TIM_PWPRSC_X16         TIM_ECR_PWPRSC_2                                         /*!< Pulse on compare pulse width prescaler 16 */
#define TIM_PWPRSC_X32         (TIM_ECR_PWPRSC_2 | TIM_ECR_PWPRSC_0)                    /*!< Pulse on compare pulse width prescaler 32 */
#define TIM_PWPRSC_X64         (TIM_ECR_PWPRSC_2 | TIM_ECR_PWPRSC_1)                    /*!< Pulse on compare pulse width prescaler 64 */
#define TIM_PWPRSC_X128        (TIM_ECR_PWPRSC_2 | TIM_ECR_PWPRSC_1 | TIM_ECR_PWPRSC_0) /*!< Pulse on compare pulse width prescaler 128 */


/*******************  Bit definition for TIM1_AF1 register  *******************/
#define TIM1_AF1_BKINE            ((uint32_t)0x00000001)
#define TIM1_AF1_BKCMP1E          ((uint32_t)0x00000002)
#define TIM1_AF1_BKCMP2E          ((uint32_t)0x00000004)
#define TIM1_AF1_BKCMP3E          ((uint32_t)0x00000008)
#define TIM1_AF1_BKCMP4E          ((uint32_t)0x00000010)
#define TIM1_AF1_BKCMP5E          ((uint32_t)0x00000020)
#define TIM1_AF1_BKCMP6E          ((uint32_t)0x00000040)
#define TIM1_AF1_BKCMP7E          ((uint32_t)0x00000080)
#define TIM1_AF1_BKINP            ((uint32_t)0x00000200)
#define TIM1_AF1_BKCMP1P          ((uint32_t)0x00000400)
#define TIM1_AF1_BKCMP2P          ((uint32_t)0x00000800)
#define TIM1_AF1_BKCMP3P          ((uint32_t)0x00001000)
#define TIM1_AF1_BKCMP4P          ((uint32_t)0x00002000)

#define TIM1_AF1_ETRSEL           ((uint32_t)0x0003C000)
#define TIM1_AF1_ETRSEL_0         ((uint32_t)0x00004000)
#define TIM1_AF1_ETRSEL_1         ((uint32_t)0x00008000)
#define TIM1_AF1_ETRSEL_2         ((uint32_t)0x00010000)
#define TIM1_AF1_ETRSEL_3         ((uint32_t)0x00020000)

/*******************  Bit definition for TIM1_AF2 register  *********************/
#define TIM1_AF2_BK2INE            ((uint32_t)0x00000001)
#define TIM1_AF2_BK2CMP1E          ((uint32_t)0x00000002)
#define TIM1_AF2_BK2CMP2E          ((uint32_t)0x00000004)
#define TIM1_AF2_BK2CMP3E          ((uint32_t)0x00000008)
#define TIM1_AF2_BK2CMP4E          ((uint32_t)0x00000010)
#define TIM1_AF2_BK2CMP5E          ((uint32_t)0x00000020)
#define TIM1_AF2_BK2CMP6E          ((uint32_t)0x00000040)
#define TIM1_AF2_BK2CMP7E          ((uint32_t)0x00000080)
#define TIM1_AF2_BK2INP            ((uint32_t)0x00000200)
#define TIM1_AF2_BK2CMP1P          ((uint32_t)0x00000400)
#define TIM1_AF2_BK2CMP2P          ((uint32_t)0x00000800)
#define TIM1_AF2_BK2CMP3P          ((uint32_t)0x00000400)
#define TIM1_AF2_BK2CMP4P          ((uint32_t)0x00000800)
#define TIM1_AF2_OCRSEL            ((uint32_t)0x00070000)
#define TIM1_AF2_OCRSEL_0          ((uint32_t)0x00010000)
#define TIM1_AF2_OCRSEL_1          ((uint32_t)0x00020000)
#define TIM1_AF2_OCRSEL_2          ((uint32_t)0x00040000)

/*******************  Bit definition for TIM_TISEL register  *********************/
#define TIM_TISEL_TI1SEL          ((uint32_t)0x0000000F)
#define TIM_TISEL_TI1SEL_0        ((uint32_t)0x00000001)
#define TIM_TISEL_TI1SEL_1        ((uint32_t)0x00000002)
#define TIM_TISEL_TI1SEL_2        ((uint32_t)0x00000004)
#define TIM_TISEL_TI1SEL_3        ((uint32_t)0x00000008)

#define TIM_TISEL_TI2SEL          ((uint32_t)0x00000F00)
#define TIM_TISEL_TI2SEL_0        ((uint32_t)0x00000100)
#define TIM_TISEL_TI2SEL_1        ((uint32_t)0x00000200)
#define TIM_TISEL_TI2SEL_2        ((uint32_t)0x00000400)
#define TIM_TISEL_TI2SEL_3        ((uint32_t)0x00000800)
/**********************  Bit definition for AF register of TIM_TypeDef ***********************/
#define TIM_AF_BKINE                 BIT0
#define TIM_AF_BKCMP1E               BIT1
#define TIM_AF_BKCMP2E               BIT2
#define TIM_AF_BKCMP3E               BIT3
#define TIM_AF_BKCMP4E               BIT4
#define TIM_AF_BKCMP5E               BIT5

#define TIM_AF_BKINP                 BIT9
#define TIM_AF_BKCMP1P               BIT10
#define TIM_AF_BKCMP2P               BIT11
#define TIM_AF_BKCMP3P               BIT12
#define TIM_AF_BKCMP4P               BIT13
#define TIM_AF_BKCMP5P               BIT14

#define TIM_BKCMP_POLARITY_NoInvert            0           /*!< BRK BKCMP input is no invert */
#define TIM_BKCMP_POLARITY_Invert              1           /*!< BRK BKCMP input is invert */

#define TIM_BKIN_POLARITY_Invert               TIM1_AF1_BKINP           /*!< BRK BKIN input is active low */
#define TIM_BKIN_POLARITY_NoInvert              0x00000000U              /*!< BRK BKIN input is active high */


#define TIM_TISEL_TI3SEL          ((uint32_t)0x000F0000)
#define TIM_TISEL_TI3SEL_0        ((uint32_t)0x00010000)
#define TIM_TISEL_TI3SEL_1        ((uint32_t)0x00020000)
#define TIM_TISEL_TI3SEL_2        ((uint32_t)0x00040000)
#define TIM_TISEL_TI3SEL_3        ((uint32_t)0x00080000)

#define TIM_TISEL_TI4SEL          ((uint32_t)0x0F000000)
#define TIM_TISEL_TI4SEL_0        ((uint32_t)0x01000000)
#define TIM_TISEL_TI4SEL_1        ((uint32_t)0x02000000)
#define TIM_TISEL_TI4SEL_2        ((uint32_t)0x04000000)
#define TIM_TISEL_TI4SEL_3        ((uint32_t)0x08000000)

/*******************  Bit definition for TIM_OR register  *********************/
#define TIM_OR_HSE32EN           ((uint32_t)0x00000001)

/** @defgroup TIM_Private_Macros TIM Private Macros
  * @{
  */
/** @brief  Convert channel id into channel index.
  * @param  __CHANNEL__ This parameter can be one of the following values:
  *         @arg @ref TIM_CHANNEL_CH1
  *         @arg @ref TIM_CHANNEL_CH1N
  *         @arg @ref TIM_CHANNEL_CH2
  *         @arg @ref TIM_CHANNEL_CH2N
  *         @arg @ref TIM_CHANNEL_CH3
  *         @arg @ref TIM_CHANNEL_CH3N
  *         @arg @ref TIM_CHANNEL_CH4
	*         @arg @ref TIM_CHANNEL_CH5
  * @retval none
  */
#define TIM_GET_CHANNEL_INDEX( __CHANNEL__) \
(((__CHANNEL__) == TIM_CHANNEL_CH1) ? 0U :\
   ((__CHANNEL__) == TIM_CHANNEL_CH1N) ? 1U :\
   ((__CHANNEL__) == TIM_CHANNEL_CH2) ? 2U :\
   ((__CHANNEL__) == TIM_CHANNEL_CH2N) ? 3U :\
   ((__CHANNEL__) == TIM_CHANNEL_CH3) ? 4U :\
   ((__CHANNEL__) == TIM_CHANNEL_CH3N) ? 5U :\
   ((__CHANNEL__) == TIM_CHANNEL_CH4) ? 6U :\
   ((__CHANNEL__) == TIM_CHANNEL_CH4N) ? 7U :\
   ((__CHANNEL__) == TIM_CHANNEL_CH5) ? 8U : 9U)


/** @defgroup  TIM_Channel
  * @{
  */
#define TIM_CHANNEL_CH1                     (1<<0)     /*!< Timer input/output channel 1 */
#define TIM_CHANNEL_CH1N                    (1<<2)     /*!< Timer complementary output channel 1 */
#define TIM_CHANNEL_CH2                     (1<<4)     /*!< Timer input/output channel 2 */
#define TIM_CHANNEL_CH2N                    (1<<6)     /*!< Timer complementary output channel 2 */
#define TIM_CHANNEL_CH3                     (1<<8)     /*!< Timer input/output channel 3 */
#define TIM_CHANNEL_CH3N                    (1<<10)    /*!< Timer complementary output channel 3 */
#define TIM_CHANNEL_CH4                     (1<<12)    /*!< Timer input/output channel 4 */
#define TIM_CHANNEL_CH4N                    (1<<14)    /*!< Timer complementary output channel 4 */
#define TIM_CHANNEL_CH5                     (1<<16)    /*!< Timer input/output channel 5 */
#define TIM_CHANNEL_CH6                     (1<<20)    /*!< Timer input/output channel 6 */

/** @defgroup TIM_Output_Compare_state 
  * @{
  */
#define TIM_OutputState_Disable             ((uint16_t)0x0000)
#define TIM_OutputState_Enable              ((uint16_t)0x0001)

/** @defgroup TIM_Output_Compare_N_state 
  * @{
  */
#define TIM_OutputNState_Disable            ((uint16_t)0x0000)
#define TIM_OutputNState_Enable             ((uint16_t)0x0004)

/** @defgroup TIM_Output_Compare_Idle_State 
  * @{
  */
#define TIM_OCIdleState_Set                 ((uint16_t)0x0100)
#define TIM_OCIdleState_Reset               ((uint16_t)0x0000)

/** @defgroup TIM_Output_Compare_N_Idle_State 
  * @{
  */
#define TIM_OCNIdleState_Set                ((uint16_t)0x0200)
#define TIM_OCNIdleState_Reset              ((uint16_t)0x0000)

/** @defgroup TIM_Output_Compare_Polarity 
  * @{
  */
#define TIM_OCPolarity_High                 ((uint16_t)0x0000)
#define TIM_OCPolarity_Low                  ((uint16_t)0x0002)

/** @defgroup TIM_Output_Compare_N_Polarity 
  * @{
  */ 
#define TIM_OCNPolarity_High                ((uint16_t)0x0000)
#define TIM_OCNPolarity_Low                 ((uint16_t)0x0008)

/** @defgroup TIM_Update_Source
  * @{
  */
#define TIM_UPDATESOURCE_REGULAR            0x00000000U     /*!< Counter overflow/underflow, Setting the UG bit or Update generation through the slave mode controller generates an update request */
#define TIM_UPDATESOURCE_COUNTER            (1<<2)          /*!< Only counter overflow/underflow generates an update request */

/** @defgroup TIM_OnePulseMode
  * @{
  */
#define TIM_ONEPULSEMODE_SINGLE             (1<<3)          /*!< Counter is not stopped at update event */
#define TIM_ONEPULSEMODE_REPETITIVE         0x00000000U     /*!< Counter stops counting at the next update event */

/** @defgroup TIM_Capture_Compare_Update_Source
  * @{
  */
#define TIM_CCUPDATESOURCE_COMG_ONLY        0x00000000U     /*!< Capture/compare control bits are updated by setting the COMG bit only */
#define TIM_CCUPDATESOURCE_COMG_AND_TRGI    (0x01<<2)       /*!< Capture/compare control bits are updated by setting the COMG bit or when a rising edge occurs on trigger input (TRGI) */

/** @defgroup TIM_Capture_Compare_DMA_Source
  * @{
  */
#define TIM_CCDMASOURCE_CC_EVENT            0x00000000U     /*!< Capture/compare control bits are updated by setting the COMG bit only */
#define TIM_CCDMASOURCE_UPDATE_EVENT        (0x01<<3)       /*!< Capture/compare control bits are updated by setting the COMG bit or when a rising edge occurs on trigger input (TRGI) */

/** @defgroup TIM_Output_Configuration_Idle_State
  * @{
  */
#define TIM_OCIDLESTATE_LOW                 0x00000000U     /*!<OCx=0 (after a dead-time if OC is implemented) when MOE=0*/
#define TIM_OCIDLESTATE_HIGH                (1<<8)          /*!<OCx=1 (after a dead-time if OC is implemented) when MOE=0*/

/** @defgroup TIM_ETR_Polarity
  * @{
  */
#define TIM_ETR_POLARITY_NONINVERTED        0x00000000U             /*!< ETR is non-inverted, active at high level or rising edge */
#define TIM_ETR_POLARITY_INVERTED           (0x01<<15)            /*!< ETR is inverted, active at low level or falling edge */

/** @defgroup TIM_Clock_Source
  * @{
  */
#define TIM_CLOCKSOURCE_INTERNAL            0x00000000U                                          /*!< The timer is clocked by the internal clock provided from the RCC */
#define TIM_CLOCKSOURCE_EXT_MODE1           ((0x04<<0) | (0x02<<0) | (0x01<<0))   /*!< Counter counts at each rising or falling edge on a selected inpu t*/
#define TIM_CLOCKSOURCE_EXT_MODE2           (0x01<<14)      

 
/** @defgroup TIM_Output_Compare_and_PWM_modes 
  * @{
  */
#define TIM_OCMODE_FROZEN                   0x00000000U                                              /*!<The comparison between the output compare register TIM_CCRy and the counter TIM_CNT has no effect on the output channel level */
#define TIM_OCMODE_ACTIVE                   (1<<4)                                         /*!<OCyREF is forced high on compare match*/
#define TIM_OCMODE_INACTIVE                 (0x02<<4)                                         /*!<OCyREF is forced low on compare match*/
#define TIM_OCMODE_TOGGLE                   ((0x02<<4) | (1<<4))                    /*!<OCyREF toggles on compare match*/
#define TIM_OCMODE_FORCED_INACTIVE          (0x04<<4)                                       /*!<OCyREF is forced low*/
#define TIM_OCMODE_FORCED_ACTIVE            ((0x04<<4)  | (1<<4))                    /*!<OCyREF is forced high*/
#define TIM_OCMODE_PWM1                     ((0x04<<4)  | (0x02<<4))                    /*!<In upcounting, channel y is active as long as TIM_CNT<TIM_CCRy else inactive.  In downcounting, channel y is inactive as long as TIM_CNT>TIM_CCRy else active.*/
#define TIM_OCMODE_PWM2                     ((0x04<<4)  | (0x02<<4) | (1<<4)) /*!<In upcounting, channel y is inactive as long as TIM_CNT<TIM_CCRy else active.  In downcounting, channel y is active as long as TIM_CNT>TIM_CCRy else inactive*/
#define TIM_OCMODE_RETRIG_OPM1              (0x1000UL<<4)                                         /*!<Retrigerrable OPM mode 1*/
#define TIM_OCMODE_RETRIG_OPM2              ((0x1000UL<<4) | (1<<4))                    /*!<Retrigerrable OPM mode 2*/
#define TIM_OCMODE_COMBINED_PWM1            ((0x1000UL<<4) | (0x04<<4))                    /*!<Combined PWM mode 1*/
#define TIM_OCMODE_COMBINED_PWM2            ((0x1000UL<<4) | (1<<4) | (0x04<<4)) /*!<Combined PWM mode 2*/
#define TIM_OCMODE_ASSYMETRIC_PWM1          ((0x1000UL<<4) | (0x02<<4) | (0x04<<4)) /*!<Asymmetric PWM mode 1*/
#define TIM_OCMODE_ASSYMETRIC_PWM2          ((0x1000UL<<4) | TIM_CCMR1_OC1M)                      /*!<Asymmetric PWM mode 2*/
#define TIM_OCMODE_PULSE_ON_COMPARE         ((0x1000UL<<4) | (0x02<<4))                    /*!<Pulse on Compare mode */
#define TIM_OCMODE_DIRECTION_OUTPUT         ((0x1000UL<<4) | (0x02<<4) | (1<<4)) /*!<Direction output mode */


/** @defgroup TIM_Output_Polarity 
  * @{
  */
#define TIM_OCPOLARITY_HIGH                 ((uint16_t)0x0000)
#define TIM_OCPOLARITY_LOW                  ((uint16_t)0x0002)

/** @defgroup TIM_Active_Input_Selection
  * @{
  */
#define TIM_ACTIVEINPUT_DIRECTTI            ((uint16_t)0x01<<16) /*!< ICx is mapped on TIx */
#define TIM_ACTIVEINPUT_INDIRECTTI          ((uint16_t)0x02<<16) /*!< ICx is mapped on TIy */
#define TIM_ACTIVEINPUT_TRC                 ((uint16_t)0x03<<16)   /*!< ICx is mapped on TRC */

/** @defgroup TIM_Input_Capture_Prescaler 
  * @{
  */
#define TIM_ICPSC_DIV1                      ((uint16_t)0x00<<16) /*!< Capture performed each time an edge is detected on the capture input. */
#define TIM_ICPSC_DIV2                      ((uint16_t)0x04<<16) /*!< Capture performed once every 2 events. */
#define TIM_ICPSC_DIV4                      ((uint16_t)0x08<<16) /*!< Capture performed once every 4 events. */
#define TIM_ICPSC_DIV8                      ((uint16_t)0x0C<<16) /*!< Capture performed once every 8 events. */

/** @defgroup TIM_Input_Configuration_Filter
  * @{
  */
#define TIM_IC_FILTER_FDIV1                 0x00000000U                                   /*!< No filter, sampling is done at fDTS */
#define TIM_IC_FILTER_FDIV1_N2              ((0x01<<4) << 16U)                            /*!< fSAMPLING=fCK_INT, N=2 */
#define TIM_IC_FILTER_FDIV1_N4              ((0x02<<4) << 16U)                            /*!< fSAMPLING=fCK_INT, N=4 */
#define TIM_IC_FILTER_FDIV1_N8              (((0x02<<4) | (0x01<<4)) << 16U)              /*!< fSAMPLING=fCK_INT, N=8 */
#define TIM_IC_FILTER_FDIV2_N6              ((0x04<<4) << 16U)                            /*!< fSAMPLING=fDTS/2, N=6 */
#define TIM_IC_FILTER_FDIV2_N8              (((0x04<<4) | (0x01<<4)) << 16U)              /*!< fSAMPLING=fDTS/2, N=8 */
#define TIM_IC_FILTER_FDIV4_N6              (((0x04<<4) | (0x02<<4)) << 16U)              /*!< fSAMPLING=fDTS/4, N=6 */
#define TIM_IC_FILTER_FDIV4_N8              (((0x04<<4) | (0x02<<4) | (0x01<<4)) << 16U)  /*!< fSAMPLING=fDTS/4, N=8 */
#define TIM_IC_FILTER_FDIV8_N6              ((0x08<<4) << 16U)                            /*!< fSAMPLING=fDTS/8, N=6 */
#define TIM_IC_FILTER_FDIV8_N8              (((0x08<<4) | (0x01<<4)) << 16U)              /*!< fSAMPLING=fDTS/8, N=8 */
#define TIM_IC_FILTER_FDIV16_N5             (((0x08<<4) | (0x02<<4)) << 16U)              /*!< fSAMPLING=fDTS/16, N=5 */
#define TIM_IC_FILTER_FDIV16_N6             (((0x08<<4) | (0x02<<4) | (0x01<<4)) << 16U)  /*!< fSAMPLING=fDTS/16, N=6 */
#define TIM_IC_FILTER_FDIV16_N8             (((0x08<<4) | (0x04<<4)) << 16U)              /*!< fSAMPLING=fDTS/16, N=8 */
#define TIM_IC_FILTER_FDIV32_N5             (((0x08<<4) | (0x04<<4) | (0x01<<4)) << 16U)  /*!< fSAMPLING=fDTS/32, N=5 */
#define TIM_IC_FILTER_FDIV32_N6             (((0x08<<4) | (0x04<<4) | (0x02<<4)) << 16U)  /*!< fSAMPLING=fDTS/32, N=6 */
#define TIM_IC_FILTER_FDIV32_N8             ((0x0f<<4) << 16U)                            /*!< fSAMPLING=fDTS/32, N=8 */

/** @defgroup TIM_LL_EC_IC_POLARITY Input Configuration Polarity
  * @{
  */
#define TIM_IC_POLARITY_RISING              ((uint16_t)0x0000)                    /*!< The circuit is sensitive to TIxFP1 rising edge, TIxFP1 is not inverted */
#define TIM_IC_POLARITY_FALLING             ((uint16_t)0x0002)                    /*!< The circuit is sensitive to TIxFP1 falling edge, TIxFP1 is inverted */

/** @defgroup TIM_Off-state_Selection_for_Run_Mode
  * @{
  */
#define TIM_OSSR_DISABLE                    0x00000000U             /*!< When inactive, OCx/OCxN outputs are disabled */
#define TIM_OSSR_ENABLE                     (1<<11)           /*!< When inactive, OC/OCN outputs are enabled with their inactive level as soon as CCxE=1 or CCxNE=1 */

/** @defgroup TIM_Off-state_Selection_for_Idle_Mode
  * @{
  */
#define TIM_OSSI_DISABLE                    0x00000000U             /*!< When inactive, OCx/OCxN outputs are disabled */
#define TIM_OSSI_ENABLE                     (1<<10)           /*!< When inactive, OxC/OCxN outputs are first forced with their inactive level then forced to their idle level after the deadtime */

/** @defgroup TIM_Break_Polarity
  * @{
  */
#define TIM_BREAK_POLARITY_LOW              0x00000000U               /*!< Break input BRK is active low */
#define TIM_BREAK_POLARITY_HIGH             (1<<13)              /*!< Break input BRK is active high */

/** @defgroup TIM_Break2_Polarity
  * @{
  */
#define TIM_BREAK2_POLARITY_LOW              0x00000000U               /*!< Break input BRK2 is active low */
#define TIM_BREAK2_POLARITY_HIGH             (1<<25)              /*!< Break input BRK2 is active high */

/** @defgroup TIM_Break_Input_enable_disable 
  * @{
  */
#define TIM_Break_Enable                    ((uint16_t)0x1000)
#define TIM_Break_Disable                   ((uint16_t)0x0000)

/** @defgroup CMP1_Break_Input_enable_disable 
  * @{
  */
#define TIM_CMP1_Break_Enable                 ((uint16_t)0x10000)
#define TIM_CMP1_Break_Disable                ((uint16_t)0x00000)

/** @defgroup CMP2_Break_Input_enable_disable 
  * @{
  */
#define TIM_CMP2_Break_Enable                 ((uint16_t)0x40000)
#define TIM_CMP2_Break_Disable                ((uint16_t)0x00000)

/** @defgroup CMP3_Break_Input_enable_disable 
  * @{
  */
#define TIM_CMP3_Break_Enable                 ((uint16_t)0x100000)
#define TIM_CMP3_Break_Disable                ((uint16_t)0x000000)

/** @defgroup TIM_HDFE_Bit_Set_Reset
  * @{
  */
#define  TIM_HDFE_Enable                    ((uint32_t)0x400000)
#define  TIM_HDFE_Disable                   ((uint32_t)0x000000)

/** @defgroup TIM_PVD_Bit_Set_Reset
  * @{
  */
#define  TIM_PVD_Enable                    ((uint32_t)0x800000)
#define  TIM_PVD_Disable                   ((uint32_t)0x000000)

/** @defgroup TIM_AOE_Bit_Set_Reset 
  * @{
  */
#define TIM_AutomaticOutput_Enable          ((uint16_t)0x4000)
#define TIM_AutomaticOutput_Disable         ((uint16_t)0x0000)


/* Generic bit definitions for TIMx_AF1 register */
#define TIMx_AF1_BKINP     TIM1_AF1_BKINP     /*!< BRK BKIN input polarity */
#define TIMx_AF1_ETRSEL    TIM1_AF1_ETRSEL    /*!< TIMx ETR source selection */


/** @defgroup TIM_EC_TIM1_ETRSOURCE External Trigger Source TIM1
  * @{
  */
#define TIM_TIM1_ETRSOURCE_GPIO        0x00000000U                                                  /*!< ETR input is connected to GPIO */
#define TIM_TIM1_ETRSOURCE_COMP1       TIM1_AF1_ETRSEL_0                                            /*!< ETR input is connected to COMP1_OUT */
#define TIM_TIM1_ETRSOURCE_COMP2       TIM1_AF1_ETRSEL_1                                            /*!< ETR input is connected to COMP2_OUT */
#define TIM_TIM1_ETRSOURCE_COMP3       (TIM1_AF1_ETRSEL_1 | TIM1_AF1_ETRSEL_0)                      /*!< ETR input is connected to COMP3_OUT */
#define TIM_TIM1_ETRSOURCE_COMP4       TIM1_AF1_ETRSEL_2                                            /*!< ETR input is connected to COMP4_OUT */
#define TIM_TIM1_ETRSOURCE_ADC1_AWD1   TIM1_AF1_ETRSEL_3                                            /*!< ADC1 analog watchdog 1 */
#define TIM_TIM1_ETRSOURCE_ADC1_AWD2   (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_0)                      /*!< ADC1 analog watchdog 2 */
#define TIM_TIM1_ETRSOURCE_ADC1_AWD3   (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_1)                      /*!< ADC1 analog watchdog 3 */

/** @defgroup TIM_EC_TIM2_ETRSOURCE External Trigger Source TIM2
  */
#define TIM_TIM2_ETRSOURCE_GPIO         0x00000000U                                                 /*!< ETR input is connected to GPIO */
#define TIM_TIM2_ETRSOURCE_COMP1        TIM1_AF1_ETRSEL_0                                           /*!< ETR input is connected to COMP1_OUT */
#define TIM_TIM2_ETRSOURCE_COMP2        TIM1_AF1_ETRSEL_1                                           /*!< ETR input is connected to COMP2_OUT */
#define TIM_TIM2_ETRSOURCE_COMP3        (TIM1_AF1_ETRSEL_1 | TIM1_AF1_ETRSEL_0)                     /*!< ETR input is connected to COMP3_OUT */
#define TIM_TIM2_ETRSOURCE_COMP4        TIM1_AF1_ETRSEL_2                                           /*!< ETR input is connected to COMP4_OUT */
#define TIM_TIM2_ETRSOURCE_TIM3_ETR     TIM1_AF1_ETRSEL_3                                           /*!< ETR input is connected to TIM3 ETR */
#define TIM_TIM2_ETRSOURCE_TIM4_ETR     (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_0)                     /*!< ETR input is connected to TIM4 ETR */
#define TIM_TIM2_ETRSOURCE_TIM5_ETR     (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_1)                     /*!< ETR input is connected to TIM5 ETR */
#define TIM_TIM2_ETRSOURCE_LSE          (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_1 | TIM1_AF1_ETRSEL_0) /*!< ETR input is connected to LSE */


/** @defgroup TIM_EC_TIM3_ETRSOURCE External Trigger Source TIM3
  */
#define TIM_TIM3_ETRSOURCE_GPIO         0x00000000U                                                 /*!< ETR input is connected to GPIO */
#define TIM_TIM3_ETRSOURCE_COMP1        TIM1_AF1_ETRSEL_0                                           /*!< ETR input is connected to COMP1_OUT */
#define TIM_TIM3_ETRSOURCE_COMP2        TIM1_AF1_ETRSEL_1                                           /*!< ETR input is connected to COMP2_OUT */
#define TIM_TIM3_ETRSOURCE_COMP3        (TIM1_AF1_ETRSEL_1 | TIM1_AF1_ETRSEL_0)                     /*!< ETR input is connected to COMP3_OUT */
#define TIM_TIM3_ETRSOURCE_COMP4        TIM1_AF1_ETRSEL_2                                           /*!< ETR input is connected to COMP4_OUT */
#define TIM_TIM3_ETRSOURCE_TIM2_ETR     TIM1_AF1_ETRSEL_3                                           /*!< ETR input is connected to TIM2 ETR */
#define TIM_TIM3_ETRSOURCE_TIM4_ETR     (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_0)                     /*!< ETR input is connected to TIM4 ETR */
#define TIM_TIM3_ETRSOURCE_ADC2_AWD1    (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_1 | TIM1_AF1_ETRSEL_0) /*!< ADC2 analog watchdog 1 */
#define TIM_TIM3_ETRSOURCE_ADC2_AWD2    (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_2)                     /*!< ADC2 analog watchdog 2 */
#define TIM_TIM3_ETRSOURCE_ADC2_AWD3    (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_2 | TIM1_AF1_ETRSEL_0) /*!< ADC2 analog watchdog 3 */


/** @defgroup TIM_EC_TIM4_ETRSOURCE External Trigger Source TIM4
  */
#define TIM_TIM4_ETRSOURCE_GPIO         0x00000000U                                                 /*!< ETR input is connected to GPIO */
#define TIM_TIM4_ETRSOURCE_COMP1        TIM1_AF1_ETRSEL_0                                           /*!< ETR input is connected to COMP1_OUT */
#define TIM_TIM4_ETRSOURCE_COMP2        TIM1_AF1_ETRSEL_1                                           /*!< ETR input is connected to COMP2_OUT */
#define TIM_TIM4_ETRSOURCE_COMP3        (TIM1_AF1_ETRSEL_1 | TIM1_AF1_ETRSEL_0)                     /*!< ETR input is connected to COMP3_OUT */
#define TIM_TIM4_ETRSOURCE_COMP4        TIM1_AF1_ETRSEL_2                                           /*!< ETR input is connected to COMP4_OUT */
#define TIM_TIM4_ETRSOURCE_TIM3_ETR     TIM1_AF1_ETRSEL_3                                           /*!< ETR input is connected to TIM3 ETR */
#define TIM_TIM4_ETRSOURCE_TIM5_ETR     (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_0)                     /*!< ETR input is connected to TIM5 ETR */


/** @defgroup TIM_EC_TIM5_ETRSOURCE External Trigger Source TIM5
  */
#define TIM_TIM5_ETRSOURCE_GPIO         0x00000000U                                                 /*!< ETR input is connected to GPIO */
#define TIM_TIM5_ETRSOURCE_COMP1        TIM1_AF1_ETRSEL_0                                           /*!< ETR input is connected to COMP1_OUT */
#define TIM_TIM5_ETRSOURCE_COMP2        TIM1_AF1_ETRSEL_1                                           /*!< ETR input is connected to COMP2_OUT */
#define TIM_TIM5_ETRSOURCE_COMP3        (TIM1_AF1_ETRSEL_1 | TIM1_AF1_ETRSEL_0)                     /*!< ETR input is connected to COMP3_OUT */
#define TIM_TIM5_ETRSOURCE_COMP4        TIM1_AF1_ETRSEL_2                                           /*!< ETR input is connected to COMP4_OUT */
#define TIM_TIM5_ETRSOURCE_TIM2_ETR     TIM1_AF1_ETRSEL_3                                           /*!< ETR input is connected to TIM2 ETR */
#define TIM_TIM5_ETRSOURCE_TIM3_ETR     (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_0)                     /*!< ETR input is connected to TIM3 ETR */


/** @defgroup TIM_EC_TIM8_ETRSOURCE External Trigger Source TIM8
  */
#define TIM_TIM8_ETRSOURCE_GPIO        0x00000000U                                                  /*!< ETR input is connected to GPIO */
#define TIM_TIM8_ETRSOURCE_COMP1       TIM1_AF1_ETRSEL_0                                            /*!< ETR input is connected to COMP1_OUT */
#define TIM_TIM8_ETRSOURCE_COMP2       TIM1_AF1_ETRSEL_1                                            /*!< ETR input is connected to COMP2_OUT */
#define TIM_TIM8_ETRSOURCE_COMP3       (TIM1_AF1_ETRSEL_1 | TIM1_AF1_ETRSEL_0)                      /*!< ETR input is connected to COMP3_OUT */
#define TIM_TIM8_ETRSOURCE_COMP4       TIM1_AF1_ETRSEL_2                                            /*!< ETR input is connected to COMP4_OUT */
#define TIM_TIM8_ETRSOURCE_ADC2_AWD1   TIM1_AF1_ETRSEL_3                                            /*!< ADC2 analog watchdog 1 */
#define TIM_TIM8_ETRSOURCE_ADC2_AWD2   (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_0)                      /*!< ADC2 analog watchdog 2 */
#define TIM_TIM8_ETRSOURCE_ADC2_AWD3   (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_1)                      /*!< ADC2 analog watchdog 3 */
#define TIM_TIM8_ETRSOURCE_ADC3_AWD1   (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_1 | TIM1_AF1_ETRSEL_0)  /*!< ADC3 analog watchdog 1 */
#define TIM_TIM8_ETRSOURCE_ADC3_AWD2   (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_2)                      /*!< ADC3 analog watchdog 2 */
#define TIM_TIM8_ETRSOURCE_ADC3_AWD3   (TIM1_AF1_ETRSEL_3 | TIM1_AF1_ETRSEL_2 | TIM1_AF1_ETRSEL_0)  /*!< ADC3 analog watchdog 3 */

/** @defgroup TIM_EC_SMS_PRELOAD_SOURCE SMS Preload Source
  */
#define TIM_SMSPS_TIMUPDATE                 0x00000000U                         /*!< The SMS preload transfer is triggered by the Timer's Update event */
#define TIM_SMSPS_INDEX                     TIM_SMCR_SMSPS                      /*!< The SMS preload transfer is triggered by the Index event */

/** @defgroup TIM_EC_BREAK_FILTER break filter
  */
#define TIM_BREAK_FILTER_FDIV1              0x00000000U   /*!< No filter, BRK acts asynchronously */
#define TIM_BREAK_FILTER_FDIV1_N2           0x00010000U   /*!< fSAMPLING=fCK_INT, N=2 */
#define TIM_BREAK_FILTER_FDIV1_N4           0x00020000U   /*!< fSAMPLING=fCK_INT, N=4 */
#define TIM_BREAK_FILTER_FDIV1_N8           0x00030000U   /*!< fSAMPLING=fCK_INT, N=8 */
#define TIM_BREAK_FILTER_FDIV2_N6           0x00040000U   /*!< fSAMPLING=fDTS/2, N=6 */
#define TIM_BREAK_FILTER_FDIV2_N8           0x00050000U   /*!< fSAMPLING=fDTS/2, N=8 */
#define TIM_BREAK_FILTER_FDIV4_N6           0x00060000U   /*!< fSAMPLING=fDTS/4, N=6 */
#define TIM_BREAK_FILTER_FDIV4_N8           0x00070000U   /*!< fSAMPLING=fDTS/4, N=8 */
#define TIM_BREAK_FILTER_FDIV8_N6           0x00080000U   /*!< fSAMPLING=fDTS/8, N=6 */
#define TIM_BREAK_FILTER_FDIV8_N8           0x00090000U   /*!< fSAMPLING=fDTS/8, N=8 */
#define TIM_BREAK_FILTER_FDIV16_N5          0x000A0000U   /*!< fSAMPLING=fDTS/16, N=5 */
#define TIM_BREAK_FILTER_FDIV16_N6          0x000B0000U   /*!< fSAMPLING=fDTS/16, N=6 */
#define TIM_BREAK_FILTER_FDIV16_N8          0x000C0000U   /*!< fSAMPLING=fDTS/16, N=8 */
#define TIM_BREAK_FILTER_FDIV32_N5          0x000D0000U   /*!< fSAMPLING=fDTS/32, N=5 */
#define TIM_BREAK_FILTER_FDIV32_N6          0x000E0000U   /*!< fSAMPLING=fDTS/32, N=6 */
#define TIM_BREAK_FILTER_FDIV32_N8          0x000F0000U   /*!< fSAMPLING=fDTS/32, N=8 */

/** @defgroup TIM_EC_BREAK_AFMODE BREAK AF MODE
  */
#define TIM_BREAK_AFMODE_INPUT              0x00000000U              /*!< Break input BRK in input mode */
#define TIM_BREAK_AFMODE_BIDIRECTIONAL      TIM_BDTR_BKBID           /*!< Break input BRK in bidirectional mode */

/** @defgroup TIM_EC_BREAK2_FILTER BREAK2 FILTER
  */
#define TIM_BREAK2_FILTER_FDIV1             0x00000000U   /*!< No filter, BRK acts asynchronously */
#define TIM_BREAK2_FILTER_FDIV1_N2          0x00100000U   /*!< fSAMPLING=fCK_INT, N=2 */
#define TIM_BREAK2_FILTER_FDIV1_N4          0x00200000U   /*!< fSAMPLING=fCK_INT, N=4 */
#define TIM_BREAK2_FILTER_FDIV1_N8          0x00300000U   /*!< fSAMPLING=fCK_INT, N=8 */
#define TIM_BREAK2_FILTER_FDIV2_N6          0x00400000U   /*!< fSAMPLING=fDTS/2, N=6 */
#define TIM_BREAK2_FILTER_FDIV2_N8          0x00500000U   /*!< fSAMPLING=fDTS/2, N=8 */
#define TIM_BREAK2_FILTER_FDIV4_N6          0x00600000U   /*!< fSAMPLING=fDTS/4, N=6 */
#define TIM_BREAK2_FILTER_FDIV4_N8          0x00700000U   /*!< fSAMPLING=fDTS/4, N=8 */
#define TIM_BREAK2_FILTER_FDIV8_N6          0x00800000U   /*!< fSAMPLING=fDTS/8, N=6 */
#define TIM_BREAK2_FILTER_FDIV8_N8          0x00900000U   /*!< fSAMPLING=fDTS/8, N=8 */
#define TIM_BREAK2_FILTER_FDIV16_N5         0x00A00000U   /*!< fSAMPLING=fDTS/16, N=5 */
#define TIM_BREAK2_FILTER_FDIV16_N6         0x00B00000U   /*!< fSAMPLING=fDTS/16, N=6 */
#define TIM_BREAK2_FILTER_FDIV16_N8         0x00C00000U   /*!< fSAMPLING=fDTS/16, N=8 */
#define TIM_BREAK2_FILTER_FDIV32_N5         0x00D00000U   /*!< fSAMPLING=fDTS/32, N=5 */
#define TIM_BREAK2_FILTER_FDIV32_N6         0x00E00000U   /*!< fSAMPLING=fDTS/32, N=6 */
#define TIM_BREAK2_FILTER_FDIV32_N8         0x00F00000U   /*!< fSAMPLING=fDTS/32, N=8 */

/** @defgroup TIM_EC_BREAK2_AFMODE BREAK2 AF MODE
  */
#define TIM_BREAK2_AFMODE_INPUT             0x00000000U             /*!< Break2 input BRK2 in input mode */
#define TIM_BREAK2_AFMODE_BIDIRECTIONAL     TIM_BDTR_BK2BID         /*!< Break2 input BRK2 in bidirectional mode */

/** @defgroup TIM_EC_BREAK_INPUT BREAK INPUT
  */
#define TIM_BREAK_INPUT_BKIN                0x00000000U  /*!< TIMx_BKIN input */
#define TIM_BREAK_INPUT_BKIN2               0x00000004U  /*!< TIMx_BKIN2 input */


/** @defgroup TIM_EC_BKIN_SOURCE BKIN SOURCE
  */
#define TIM_BKIN_SOURCE_BKIN                TIM1_AF1_BKINE      /*!< BKIN input from AF controller */
#define TIM_BKIN_SOURCE_BKCOMP1             TIM1_AF1_BKCMP1E    /*!< internal signal: COMP1 output */
#define TIM_BKIN_SOURCE_BKCOMP2             TIM1_AF1_BKCMP2E    /*!< internal signal: COMP2 output */
#define TIM_BKIN_SOURCE_BKCOMP3             TIM1_AF1_BKCMP3E    /*!< internal signal: COMP3 output */
#define TIM_BKIN_SOURCE_BKCOMP4             TIM1_AF1_BKCMP4E    /*!< internal signal: COMP4 output */


/* Defines used for the bit position in the register and perform offsets */
#define TIM_POSITION_BRK_SOURCE            (POSITION_VAL(Source) & 0x1FUL)


/** @defgroup TIM_EC_INDEX_DIR index direction selection
  */
#define TIM_INDEX_UP_DOWN     0x00000000U         /*!< Index resets the counter whatever the direction */
#define TIM_INDEX_UP          TIM_ECR_IDIR_0      /*!< Index resets the counter when up-counting only */
#define TIM_INDEX_DOWN        TIM_ECR_IDIR_1      /*!< Index resets the counter when down-counting only */

/** @defgroup TIM_EC_INDEX_POSITION index positioning selection
  */
#define TIM_INDEX_POSITION_DOWN_DOWN    0x00000000U                           /*!< Index resets the counter when AB = 00 */
#define TIM_INDEX_POSITION_DOWN_UP      TIM_ECR_IPOS_0                        /*!< Index resets the counter when AB = 01 */
#define TIM_INDEX_POSITION_UP_DOWN      TIM_ECR_IPOS_1                        /*!< Index resets the counter when AB = 10 */
#define TIM_INDEX_POSITION_UP_UP        (TIM_ECR_IPOS_1 | TIM_ECR_IPOS_0)     /*!< Index resets the counter when AB = 11 */
#define TIM_INDEX_POSITION_DOWN         0x00000000U                           /*!< Index resets the counter when clock is 0 */
#define TIM_INDEX_POSITION_UP           TIM_ECR_IPOS_0                        /*!< Index resets the counter when clock is 1 */

/** @defgroup TIM_EC_TIM1_TI1_RMP  TIM1 Timer Input Ch1 Remap
  */
#define TIM_TIM1_TI1_RMP_GPIO   0x00000000U                                       /*!< TIM1 input 1 is connected to GPIO */
#define TIM_TIM1_TI1_RMP_COMP1  TIM_TISEL_TI1SEL_0                                /*!< TIM1 input 1 is connected to COMP1_OUT */
#define TIM_TIM1_TI1_RMP_COMP2  TIM_TISEL_TI1SEL_1                                /*!< TIM1 input 1 is connected to COMP2_OUT */
#define TIM_TIM1_TI1_RMP_COMP3  (TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)         /*!< TIM1 input 1 is connected to COMP3_OUT */
#define TIM_TIM1_TI1_RMP_COMP4  TIM_TISEL_TI1SEL_2                                /*!< TIM1 input 1 is connected to COMP4_OUT */

#define TIM_TIM1_TI2_RMP_GPIO    0x00000000U                                     /*!< TIM1 input 2 is connected to GPIO */
/** @defgroup TIM_EC_TIM2_TI1_RMP  TIM2 Timer Input Ch1 Remap
  */
#define TIM_TIM2_TI1_RMP_GPIO   0x00000000U                                       /*!< TIM2 input 1 is connected to GPIO */
#define TIM_TIM2_TI1_RMP_COMP1  TIM_TISEL_TI1SEL_0                                /*!< TIM2 input 1 is connected to COMP1_OUT */
#define TIM_TIM2_TI1_RMP_COMP2  TIM_TISEL_TI1SEL_1                                /*!< TIM2 input 1 is connected to COMP2_OUT */
#define TIM_TIM2_TI1_RMP_COMP3  (TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)         /*!< TIM2 input 1 is connected to COMP3_OUT */
#define TIM_TIM2_TI1_RMP_COMP4  TIM_TISEL_TI1SEL_2                                /*!< TIM2 input 1 is connected to COMP4_OUT */

/** @defgroup TIM_EC_TIM2_TI2_RMP  TIM2 Timer Input Ch2 Remap
  */
#define TIM_TIM2_TI2_RMP_GPIO   0x00000000U                                       /*!< TIM2 input 2 is connected to GPIO */
#define TIM_TIM2_TI2_RMP_COMP1  TIM_TISEL_TI2SEL_0                                /*!< TIM2 input 2 is connected to COMP1_OUT */
#define TIM_TIM2_TI2_RMP_COMP2  TIM_TISEL_TI2SEL_1                                /*!< TIM2 input 2 is connected to COMP2_OUT */
#define TIM_TIM2_TI2_RMP_COMP3  (TIM_TISEL_TI2SEL_1 | TIM_TISEL_TI2SEL_0)         /*!< TIM2 input 2 is connected to COMP3_OUT */
#define TIM_TIM2_TI2_RMP_COMP4  TIM_TISEL_TI2SEL_2                                /*!< TIM2 input 2 is connected to COMP4_OUT */


/** @defgroup TIM_EC_TIM2_TI3_RMP  TIM2 Timer Input Ch3 Remap
  */
#define TIM_TIM2_TI3_RMP_GPIO   0x00000000U                                       /*!< TIM2 input 3 is connected to GPIO */
#define TIM_TIM2_TI3_RMP_COMP4  TIM_TISEL_TI3SEL_0                                /*!< TIM2 input 3 is connected to COMP4_OUT */


/** @defgroup TIM_EC_TIM2_TI4_RMP  TIM2 Timer Input Ch4 Remap
  */
#define TIM_TIM2_TI4_RMP_GPIO   0x00000000U                                       /*!< TIM2 input 4 is connected to GPIO */
#define TIM_TIM2_TI4_RMP_COMP1  TIM_TISEL_TI4SEL_0                                /*!< TIM2 input 4 is connected to COMP1_OUT */
#define TIM_TIM2_TI4_RMP_COMP2  TIM_TISEL_TI4SEL_1                                /*!< TIM2 input 4 is connected to COMP2_OUT */


/** @defgroup TIM_EC_TIM3_TI1_RMP  TIM3 Timer Input Ch1 Remap
  */
#define TIM_TIM3_TI1_RMP_GPIO   0x00000000U                                       /*!< TIM3 input 1 is connected to GPIO */
#define TIM_TIM3_TI1_RMP_COMP1  TIM_TISEL_TI1SEL_0                                /*!< TIM3 input 1 is connected to COMP1_OUT */
#define TIM_TIM3_TI1_RMP_COMP2  TIM_TISEL_TI1SEL_1                                /*!< TIM3 input 1 is connected to COMP2_OUT */
#define TIM_TIM3_TI1_RMP_COMP3  (TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)         /*!< TIM3 input 1 is connected to COMP3_OUT */
#define TIM_TIM3_TI1_RMP_COMP4  TIM_TISEL_TI1SEL_2                                /*!< TIM3 input 1 is connected to COMP4_OUT */


/** @defgroup TIM_EC_TIM3_TI2_RMP  TIM3 Timer Input Ch2 Remap
  */
#define TIM_TIM3_TI2_RMP_GPIO   0x00000000U                                       /*!< TIM3 input 2 is connected to GPIO */
#define TIM_TIM3_TI2_RMP_COMP1  TIM_TISEL_TI2SEL_0                                /*!< TIM3 input 2 is connected to COMP1_OUT */
#define TIM_TIM3_TI2_RMP_COMP2  TIM_TISEL_TI2SEL_1                                /*!< TIM3 input 2 is connected to COMP2_OUT */
#define TIM_TIM3_TI2_RMP_COMP3  (TIM_TISEL_TI2SEL_1 | TIM_TISEL_TI2SEL_0)         /*!< TIM3 input 2 is connected to COMP3_OUT */
#define TIM_TIM3_TI2_RMP_COMP4  TIM_TISEL_TI2SEL_2                                /*!< TIM3 input 2 is connected to COMP4_OUT */


/** @defgroup TIM_EC_TIM3_TI3_RMP  TIM3 Timer Input Ch3 Remap
  */
#define TIM_TIM3_TI3_RMP_GPIO   0x00000000U                                       /*!< TIM3 input 3 is connected to GPIO */
#define TIM_TIM3_TI3_RMP_COMP3  TIM_TISEL_TI3SEL_0                                /*!< TIM3 input 3 is connected to COMP3_OUT */


/** @defgroup TIM_EC_TIM4_TI1_RMP  TIM4 Timer Input Ch1 Remap
  */
#define TIM_TIM4_TI1_RMP_GPIO   0x00000000U                                       /*!< TIM4 input 1 is connected to GPIO */
#define TIM_TIM4_TI1_RMP_COMP1  TIM_TISEL_TI1SEL_0                                /*!< TIM4 input 1 is connected to COMP1_OUT */
#define TIM_TIM4_TI1_RMP_COMP2  TIM_TISEL_TI1SEL_1                                /*!< TIM4 input 1 is connected to COMP2_OUT */
#define TIM_TIM4_TI1_RMP_COMP3  (TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)         /*!< TIM4 input 1 is connected to COMP3_OUT */
#define TIM_TIM4_TI1_RMP_COMP4  TIM_TISEL_TI1SEL_2                                /*!< TIM4 input 1 is connected to COMP4_OUT */


/** @defgroup TIM_EC_TIM4_TI2_RMP  TIM4 Timer Input Ch2 Remap
  */
#define TIM_TIM4_TI2_RMP_GPIO   0x00000000U                                       /*!< TIM4 input 2 is connected to GPIO */
#define TIM_TIM4_TI2_RMP_COMP1  TIM_TISEL_TI2SEL_0                                /*!< TIM4 input 2 is connected to COMP1_OUT */
#define TIM_TIM4_TI2_RMP_COMP2  TIM_TISEL_TI2SEL_1                                /*!< TIM4 input 2 is connected to COMP2_OUT */
#define TIM_TIM4_TI2_RMP_COMP3  (TIM_TISEL_TI2SEL_1 | TIM_TISEL_TI2SEL_0)         /*!< TIM4 input 2 is connected to COMP3_OUT */
#define TIM_TIM4_TI2_RMP_COMP4  TIM_TISEL_TI2SEL_2                                /*!< TIM4 input 2 is connected to COMP4_OUT */


/** @defgroup TIM_EC_TIM4_TI3_RMP  TIM4 Timer Input Ch3 Remap
  */
#define TIM_TIM4_TI3_RMP_GPIO   0x00000000U                                       /*!< TIM4 input 3 is connected to GPIO */


/** @defgroup TIM_EC_TIM4_TI4_RMP  TIM4 Timer Input Ch4 Remap
  */
#define TIM_TIM4_TI4_RMP_GPIO   0x00000000U                                       /*!< TIM4 input 4 is connected to GPIO */


/** @defgroup TIM_EC_TIM5_TI1_RMP  TIM5 Timer Input Ch1 Remap
  */
#define TIM_TIM5_TI1_RMP_GPIO   0x00000000U                                       /*!< TIM5 input 1 is connected to GPIO */
#define TIM_TIM5_TI1_RMP_LSI    TIM_TISEL_TI1SEL_0                                /*!< TIM5 input 1 is connected to LSI */
#define TIM_TIM5_TI1_RMP_LSE    TIM_TISEL_TI1SEL_1                                /*!< TIM5 input 1 is connected to LSE */
#define TIM_TIM5_TI1_RMP_RTC_WK (TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)         /*!< TIM5 input 1 is connected to RTC_WAKEUP */
#define TIM_TIM5_TI1_RMP_COMP1  TIM_TISEL_TI1SEL_2                                /*!< TIM5 input 1 is connected to COMP1_OUT */
#define TIM_TIM5_TI1_RMP_COMP2  (TIM_TISEL_TI1SEL_2 | TIM_TISEL_TI1SEL_0)         /*!< TIM5 input 1 is connected to COMP2_OUT */
#define TIM_TIM5_TI1_RMP_COMP3  (TIM_TISEL_TI1SEL_2 | TIM_TISEL_TI1SEL_1)         /*!< TIM5 input 1 is connected to COMP3_OUT */
#define TIM_TIM5_TI1_RMP_COMP4  (TIM_TISEL_TI1SEL_2 | TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)   /*!< TIM5 input 1 is connected to COMP4_OUT */

/** @defgroup TIM_EC_TIM5_TI2_RMP  TIM5 Timer Input Ch2 Remap
  */
#define TIM_TIM5_TI2_RMP_GPIO   0x00000000U                                       /*!< TIM5 input 2 is connected to GPIO */
#define TIM_TIM5_TI2_RMP_COMP1  TIM_TISEL_TI2SEL_0                                /*!< TIM5 input 2 is connected to COMP1_OUT */
#define TIM_TIM5_TI2_RMP_COMP2  TIM_TISEL_TI2SEL_1                                /*!< TIM5 input 2 is connected to COMP2_OUT */
#define TIM_TIM5_TI2_RMP_COMP3  (TIM_TISEL_TI2SEL_1 | TIM_TISEL_TI2SEL_0)         /*!< TIM5 input 2 is connected to COMP3_OUT */
#define TIM_TIM5_TI2_RMP_COMP4  TIM_TISEL_TI2SEL_2                                /*!< TIM5 input 2 is connected to COMP4_OUT */


/** @defgroup TIM_EC_TIM8_TI1_RMP  TIM8 Timer Input Ch1 Remap
  */
#define TIM_TIM8_TI1_RMP_GPIO   0x00000000U                                       /*!< TIM8 input 1 is connected to GPIO */
#define TIM_TIM8_TI1_RMP_COMP1  TIM_TISEL_TI1SEL_0                                /*!< TIM8 input 1 is connected to COMP1_OUT */
#define TIM_TIM8_TI1_RMP_COMP2  TIM_TISEL_TI1SEL_1                                /*!< TIM8 input 1 is connected to COMP2_OUT */
#define TIM_TIM8_TI1_RMP_COMP3  (TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)         /*!< TIM8 input 1 is connected to COMP3_OUT */
#define TIM_TIM8_TI1_RMP_COMP4  TIM_TISEL_TI1SEL_2                                /*!< TIM8 input 1 is connected to COMP4_OUT */


/** @defgroup TIM_EC_TIM15_TI1_RMP  TIM15 Timer Input Ch1 Remap
  */
#define TIM_TIM15_TI1_RMP_GPIO  0x00000000U                                       /*!< TIM15 input 1 is connected to GPIO */
#define TIM_TIM15_TI1_RMP_LSE   TIM_TISEL_TI1SEL_0                                /*!< TIM15 input 1 is connected to LSE */
#define TIM_TIM15_TI1_RMP_COMP1 TIM_TISEL_TI1SEL_1                                /*!< TIM15 input 1 is connected to COMP1_OUT */
#define TIM_TIM15_TI1_RMP_COMP2 (TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)         /*!< TIM15 input 1 is connected to COMP2_OUT */


/** @defgroup TIM_EC_TIM15_TI2_RMP  TIM15 Timer Input Ch2 Remap
  */
#define TIM_TIM15_TI2_RMP_GPIO  0x00000000U                                       /*!< TIM15 input 2 is connected to GPIO */
#define TIM_TIM15_TI2_RMP_COMP2 TIM_TISEL_TI2SEL_0                                /*!< TIM15 input 2 is connected to COMP2_OUT */
#define TIM_TIM15_TI2_RMP_COMP3 TIM_TISEL_TI2SEL_1                                /*!< TIM15 input 2 is connected to COMP3_OUT */


/** @defgroup TIM_EC_TIM16_TI1_RMP  TIM16 Timer Input Ch1 Remap
  */
#define TIM_TIM16_TI1_RMP_GPIO    0x00000000U                                     /*!< TIM16 input 1 is connected to GPIO */
#define TIM_TIM16_TI1_RMP_MCO     TIM_TISEL_TI1SEL_1                              /*!< TIM16 input 1 is connected to MCO */
#define TIM_TIM16_TI1_RMP_HSE_32  (TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)       /*!< TIM16 input 1 is connected to HSE/32 */
#define TIM_TIM16_TI1_RMP_RTC_WK  TIM_TISEL_TI1SEL_2                              /*!< TIM16 input 1 is connected to RTC_WAKEUP */
#define TIM_TIM16_TI1_RMP_LSE     (TIM_TISEL_TI1SEL_2 | TIM_TISEL_TI1SEL_0)       /*!< TIM16 input 1 is connected to LSE */
#define TIM_TIM16_TI1_RMP_LSI     (TIM_TISEL_TI1SEL_2 | TIM_TISEL_TI1SEL_1)       /*!< TIM16 input 1 is connected to LSI */


/** @defgroup TIM_EC_TIM17_TI1_RMP  TIM17 Timer Input Ch1 Remap
  */
#define TIM_TIM17_TI1_RMP_GPIO    0x00000000U                                     /*!< TIM17 input 1 is connected to GPIO */
#define TIM_TIM17_TI1_RMP_MCO     TIM_TISEL_TI1SEL_1                              /*!< TIM17 input 1 is connected to MCO */
#define TIM_TIM17_TI1_RMP_HSE_32  (TIM_TISEL_TI1SEL_1 | TIM_TISEL_TI1SEL_0)       /*!< TIM17 input 1 is connected to HSE/32 */
#define TIM_TIM17_TI1_RMP_RTC_WK  TIM_TISEL_TI1SEL_2                              /*!< TIM17 input 1 is connected to RTC_WAKEUP */
#define TIM_TIM17_TI1_RMP_LSE     (TIM_TISEL_TI1SEL_2 | TIM_TISEL_TI1SEL_0)       /*!< TIM17 input 1 is connected to LSE */
#define TIM_TIM17_TI1_RMP_LSI     (TIM_TISEL_TI1SEL_2 | TIM_TISEL_TI1SEL_1)       /*!< TIM17 input 1 is connected to LSI */


#define OCREF_CLEAR_SELECT_Pos (28U)
#define OCREF_CLEAR_SELECT_Msk (0x1U << OCREF_CLEAR_SELECT_Pos)                /*!< 0x10000000 */


/** @defgroup TIM_EC_OCREF_CLR_INT OCREF clear input selection
  */
#define TIM_OCREF_CLR_INT_ETR         OCREF_CLEAR_SELECT_Msk                   /*!< OCREF_CLR_INT is connected to ETRF */
#define TIM_OCREF_CLR_INT_COMP1       0x00000000U                              /*!< OCREF clear input is connected to COMP1_OUT */
#define TIM_OCREF_CLR_INT_COMP2       TIM1_AF2_OCRSEL_0                        /*!< OCREF clear input is connected to COMP2_OUT */
#define TIM_OCREF_CLR_INT_COMP3       TIM1_AF2_OCRSEL_1                        /*!< OCREF clear input is connected to COMP3_OUT */
#define TIM_OCREF_CLR_INT_COMP4       (TIM1_AF2_OCRSEL_1 | TIM1_AF2_OCRSEL_0)  /*!< OCREF clear input is connected to COMP4_OUT */


/** 
  * @brief  TIM base Init structure definition  
  */

typedef struct
{
  uint16_t Prescaler;                /*!< Specifies the prescaler value used to divide the TIM clock
                                      This parameter can be a number between 0x0000 and 0xFFFF */

  uint16_t CounterMode;              /*!< Specifies the counter mode
                                      This parameter can be a value of @ref TIM_Counter_Mode */

  uint16_t Period;                   /*!< Specifies the period value to be loaded into the active
                                      Auto-Reload Register at the next update event
                                      This parameter must be a number between 0x0000 and 0xFFFF  */ 

  uint16_t ClockDivision;            /*!< Specifies the clock division
                                      This parameter can be a value of @ref TIM_Clock_Division */

  uint8_t  RepetitionCounter;        /*!< Specifies the repetition counter value. Each time the RCR downcounter
                                       reaches zero, an update event is generated and counting restarts
                                       from the RCR value (N)
                                      This means in PWM mode that (N+1) corresponds to:
                                          - the number of PWM periods in edge-aligned mode
                                          - the number of half PWM period in center-aligned mode
                                      This parameter must be a number between 0x00 and 0xFF*/
} TIM_TimeBaseInitTypeDef;  

/**
  * @brief  TIM Output Compare configuration structure definition.
  */
typedef struct
{
  uint16_t OCMode;                   /*!< Specifies the TIM mode
                                      This parameter can be a value of @ref TIM_Output_Compare_and_PWM_modes */

  uint16_t OutputState;              /*!< Specifies the TIM Output Compare state
                                      This parameter can be a value of @ref TIM_Output_Compare_state */

  uint16_t OutputNState;             /*!< Specifies the TIM complementary Output Compare state
                                      This parameter can be a value of @ref TIM_Output_Compare_N_state */

  uint16_t Pulse;                    /*!< Specifies the pulse value to be loaded into the Capture Compare Register
                                      This parameter can be a number between 0x0000 and 0xFFFF */

  uint16_t OCPolarity;               /*!< Specifies the output polarity
                                      This parameter can be a value of @ref TIM_Output_Compare_Polarity */

  uint16_t OCNPolarity;              /*!< Specifies the complementary output polarity
                                      This parameter can be a value of @ref TIM_Output_Compare_N_Polarity*/

  uint16_t OCIdleState;              /*!< Specifies the TIM Output Compare pin state during Idle state
                                      This parameter can be a value of @ref TIM_Output_Compare_Idle_State */

  uint16_t OCNIdleState;             /*!< Specifies the TIM Output Compare pin state during Idle state
                                      This parameter can be a value of @ref TIM_Output_Compare_N_Idle_State */
} TIM_OCInitTypeDef;

/** 
  * @brief  TIM Input Capture Init structure definition  
  */

typedef struct
{

  uint32_t Channel;                  /*!< Specifies the TIM channel
                                      This parameter can be a value of @ref TIM_Channel */

  uint32_t ICPolarity;               /*!< Specifies the active edge of the input signal
                                      This parameter can be a value of @ref TIM_Input_Capture_Polarity */

  uint32_t ICSelection;              /*!< Specifies the input
                                      This parameter can be a value of @ref TIM_Input_Capture_Selection */

  uint32_t ICPrescaler;              /*!< Specifies the Input Capture Prescaler
                                      This parameter can be a value of @ref TIM_Input_Capture_Prescaler */

  uint32_t ICFilter;                 /*!< Specifies the input capture filter
                                      This parameter can be a number between 0x0 and 0xF 
                                      This parameter can be a value of @ref TIM_Input_Configuration_Filter*/
} TIM_ICInitTypeDef;

/** 
  * @brief  BDTR structure definition   
  */

typedef struct
{

  uint16_t OSSRState;                /*!< Specifies the Off-State selection used in Run mode
                                      This parameter can be a value of @ref TIM_Off-state_Selection_for_Run_Mode */

  uint16_t OSSIState;                /*!< Specifies the Off-State used in Idle state
                                      This parameter can be a value of @ref TIM_Off-state_Selection_for_Idle_Mode */

  uint16_t LOCKLevel;                /*!< Specifies the LOCK level parameters
                                      This parameter can be a value of @ref TIM_Lock_level */ 

  uint16_t DeadTime;                 /*!< Specifies the delay time between the switching-off and the
                                      switching-on of the outputs
                                      This parameter can be a number between 0x00 and 0xFF  */

  uint16_t BreakState;               /*!< Specifies whether the TIM Break input is enabled or not
                                      This parameter can be a value of @ref TIM_Break_Input_enable_disable */

  uint16_t BreakPolarity;            /*!< Specifies the TIM Break Input pin polarity
                                      This parameter can be a value of @ref TIM_Break_Polarity */
  
  uint16_t CMP1_BreakState;               /*!< Specifies whether the CMP1 Break input is enabled or not
                                      This parameter can be a value of @ref CMP1_BreakState_Input_enable_disable */

  uint32_t CMP1_BreakPolarity;            /*!< Specifies the CMP1 Break Input pin polarity
                                      This parameter can be a value of @ref CMP1_BreakPolarity */  
                                      
  uint16_t CMP2_BreakState;               /*!< Specifies whether the CMP2 Break input is enabled or not
                                      This parameter can be a value of @ref CMP2_BreakState_Input_enable_disable */

  uint32_t CMP2_BreakPolarity;            /*!< Specifies the CMP2 Break Input pin polarity
                                      This parameter can be a value of @ref CMP2_BreakPolarity */
                                      
  uint16_t CMP3_BreakState;               /*!< Specifies whether the CMP3 Break input is enabled or not
                                      This parameter can be a value of @ref CMP3_BreakState_Input_enable_disable */

  uint32_t CMP3_BreakPolarity;            /*!< Specifies the CMP3 Break Input pin polarity
                                      This parameter can be a value of @ref CMP3_BreakPolarity */

  uint16_t AutomaticOutput;          /*!< Specifies whether the TIM Automatic Output feature is enabled or not
                                      This parameter can be a value of @ref TIM_AOE_Bit_Set_Reset */	
                                      
  uint32_t HDFE; 						         /*!< Specifies whether the TIM Break Hardfault output is enabled or not
                                    This parameter can be a value of @ref TIM_HDFE_Bit_Set_Reset */
  
  uint32_t PVD; 						         /*!< Specifies whether the TIM Break PVD output is enabled or not
                                    This parameter can be a value of @ref TIM_PVD_Bit_Set_Reset */
} TIM_BDTRInitTypeDef;

/** 
  * @brief  ENCODER structure definition   
  */

typedef struct
{

  uint32_t EncoderMode;              /*!< Specifies the encoder resolution
                                      This parameter can be a value of @ref TIM_Encoder_Mode */

  uint32_t IC1Polarity;              /*!< Specifies the active edge of the input signal
                                      This parameter can be a value of @ref TIM_Input_Capture_Polarity */

  uint32_t IC1Selection;             /*!< Specifies the input
                                      This parameter can be a value of @ref TIM_Input_Capture_Selection */

  uint32_t IC1Prescaler;             /*!< Specifies the Input Capture Prescaler
                                      This parameter can be a value of @ref TIM_Input_Capture_Prescaler */

  uint32_t IC1Filter;                /*!< Specifies the input capture filter
                                      This parameter can be a number between 0x0 and 0xF 
                                      This parameter can be a value of @ref TIM_Input_Configuration_Filter*/

  uint32_t IC2Polarity;              /*!< Specifies the active edge of the input signal
                                      This parameter can be a value of @ref TIM_Input_Capture_Polarity */

  uint32_t IC2Selection;             /*!< Specifies the input
                                      This parameter can be a value of @ref TIM_Input_Capture_Selection */

  uint32_t IC2Prescaler;             /*!< Specifies the Input Capture Prescaler
                                      This parameter can be a value of @ref TIM_Input_Capture_Prescaler */

  uint32_t IC2Filter;                /*!< Specifies the input capture filter
                                      This parameter can be a number between 0x0 and 0xF 
                                      This parameter can be a value of @ref TIM_Input_Configuration_Filter*/

} TIM_ENCODERInitTypeDef;

/** 
  * @brief  HALLSENSOR structure definition   
  */

typedef struct
{
  uint16_t IC1Polarity;              /*!< Specifies the active edge of the input signal
                                      This parameter can be a value of @ref TIM_Input_Capture_Polarity */

  uint32_t IC1Prescaler;             /*!< Specifies the Input Capture Prescaler
                                      This parameter can be a value of @ref TIM_Input_Capture_Prescaler */

  uint32_t IC1Filter;                /*!< Specifies the input capture filter
                                      This parameter can be a number between 0x0 and 0xF 
                                      This parameter can be a value of @ref TIM_Input_Configuration_Filter */
	
  uint32_t CommutationDelay;         /*!< Specifies the compare value to be loaded into the Capture Compare Register
                                      A positive pulse (TRGO event) is generated with a programmable delay every time
                                      a change occurs on the Hall inputs.
                                      This parameter can be a number between Min_Data = 0x0000 and Max_Data = 0xFFFF */
	
	

} TIM_HALLSENSORInitTypeDef;

 void TIM_DeInit(TIM_TypeDef* TIMx);
 void TIM_TimeBaseStructInit(TIM_TimeBaseInitTypeDef* TIM_TimeBaseInitStruct);
 void TIM_OCStructInit(TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_ICStructInit(TIM_ICInitTypeDef* TIM_ICInitStruct);
 void TIM_BDTRStructInit(TIM_BDTRInitTypeDef* TIM_BDTRInitStruct);
 void TIM_TimeBaseInit(TIM_TypeDef* TIMx, TIM_TimeBaseInitTypeDef* TIM_TimeBaseInitStruct);
 void TIM_OC1Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC2Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC3Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC4Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC5Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_OC6Init(TIM_TypeDef* TIMx, TIM_OCInitTypeDef* TIM_OCInitStruct);
 void TIM_ICInit(TIM_TypeDef* TIMx, TIM_ICInitTypeDef* TIM_ICInitStruct);
 void TIM_BDTRInit(TIM_TypeDef* TIMx, TIM_BDTRInitTypeDef *TIM_BDTRInitStruct);
 void TIM_ENCODERInit(TIM_TypeDef *TIMx, TIM_ENCODERInitTypeDef *TIM_ENCODERInitStruct);
 void TIM_HALLSENSORInit(TIM_TypeDef *TIMx, TIM_HALLSENSORInitTypeDef *TIM_HALLSENSORInitStruct);
 void TIM_Enable_CEN(TIM_TypeDef *TIMx);
 void TIM_Disable_CEN(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_CENStatus(TIM_TypeDef *TIMx);
 void TIM_Enable_UpdateEvent(TIM_TypeDef *TIMx);
 void TIM_Disable_UpdateEvent(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_UpdateEventStatus(TIM_TypeDef *TIMx);
 void TIM_Set_UpdateSource(TIM_TypeDef *TIMx,uint32_t UpdateSource);
 uint32_t TIM_Get_UpdateSource(TIM_TypeDef *TIMx);
 void TIM_Set_OnePulseMode(TIM_TypeDef *TIMx,uint32_t OnePulseMode);
 uint32_t TIM_Get_OnePulseMode(TIM_TypeDef *TIMx);
 void TIM_Set_CounterMode(TIM_TypeDef *TIMx,uint32_t CounterMode);
 uint32_t TIM_Get_CounterMode(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_CounterDirection(TIM_TypeDef *TIMx);
 void TIM_Enable_ARRPreload(TIM_TypeDef *TIMx);
 void TIM_Disable_ARRPreload(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_ARRPreloadStatus(TIM_TypeDef *TIMx);
 void TIM_Set_ClockDivision(TIM_TypeDef *TIMx,uint32_t ClockDivision);
 uint32_t TIM_Get_ClockDivision(TIM_TypeDef *TIMx);
 void TIM_Enable_CC_Preload(TIM_TypeDef *TIMx);
 void TIM_Disable_CC_Preload(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_CC_Preload(TIM_TypeDef *TIMx);
 void TIM_Set_CC_UpdateSource(TIM_TypeDef *TIMx,uint32_t CCUpdateSource);
 uint32_t TIM_Get_CC_UpdateSource(TIM_TypeDef *TIMx);
 void TIM_Set_CC_DMASource(TIM_TypeDef *TIMx,uint32_t CCDMASource);
 uint32_t TIM_Get_CC_DMASource(TIM_TypeDef *TIMx);
 void TIM_Set_TriggerOutput(TIM_TypeDef *TIMx, uint32_t TriggerInput);
 void TIM_Enable_IC_XORCombination(TIM_TypeDef *TIMx);
 void TIM_Disable_IC_XORCombination(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_IC_XORCombination(TIM_TypeDef *TIMx);
 void TIM_Set_TriggerOutput2(TIM_TypeDef *TIMx, uint32_t ADCSynchronization);
 void TIM_Set_OC_IdleState(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t IdleState);
 uint32_t TIM_Get_OC_IdleState(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_SlaveMode(TIM_TypeDef *TIMx, uint32_t SlaveMode);
 void TIM_Set_TriggerInput(TIM_TypeDef *TIMx, uint32_t TriggerInput);
 void TIM_Enable_MasterSlaveMode(TIM_TypeDef *TIMx);
 void TIM_Disable_MasterSlaveMode(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_MasterSlaveModeStatus(TIM_TypeDef *TIMx);
 void TIM_Set_ETR(TIM_TypeDef *TIMx,uint32_t ETRPolarity, uint32_t ETRPrescaler,uint32_t ETRFilter);
 void TIM_Set_ETRSource(TIM_TypeDef *TIMx, uint32_t ETRSource);
 void TIM_Enable_SMSPreload(TIM_TypeDef *TIMx);
 void TIM_Disable_SMSPreload(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_SMSPreload(TIM_TypeDef *TIMx);
 void TIM_Set_SMSPreloadSource(TIM_TypeDef *TIMx, uint32_t PreloadSource);
 uint32_t TIM_Get_SMSPreloadSource(TIM_TypeDef *TIMx);
 void TIM_Enable_ExternalClock(TIM_TypeDef *TIMx);
 void TIM_Disable_ExternalClock(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_ExternalClockStatus(TIM_TypeDef *TIMx);
 void TIM_Set_ClockSource(TIM_TypeDef *TIMx,uint32_t ClockSource);
 void TIM_Set_EncoderMode(TIM_TypeDef *TIMx,uint32_t EncoderMode);
 void TIM_Enable_IT(TIM_TypeDef* TIMx, uint32_t TIM_IT);
 void TIM_Disable_IT(TIM_TypeDef* TIMx, uint32_t TIM_IT);
 void TIM_Enable_DMA(TIM_TypeDef* TIMx, uint32_t TIM_DMA);
 void TIM_Disable_DMA(TIM_TypeDef* TIMx, uint32_t TIM_DMA);
 uint32_t TIM_Get_Flag(TIM_TypeDef* TIMx, uint32_t Flag);
 void TIM_Clear_Flag(TIM_TypeDef* TIMx, uint32_t IT_Flag);
 void TIM_Set_GenerateEvent(TIM_TypeDef *TIMx, uint32_t Event);
 void TIM_Set_OC_Mode(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t Mode);
 void TIM_Set_OC_Polarity(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t Polarity);
 uint32_t TIM_Get_OC_Polarity(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Enable_OC_Fast(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Disable_OC_Fast(TIM_TypeDef *TIMx,uint32_t Channel);
 uint32_t TIM_Get_OC_FastStatus(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Enable_OC_Preload(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Disable_OC_Preload(TIM_TypeDef *TIMx,uint32_t Channel);
 uint32_t TIM_Get_OC_PreloadStatus(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Enable_OC_Clear(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Disable_OC_Clear(TIM_TypeDef *TIMx,uint32_t Channel);
 uint32_t TIM_Get_OC_ClearStatus(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Enable_CC_Channel(TIM_TypeDef *TIMx,uint32_t Channels);
 void TIM_Disable_CC_Channel(TIM_TypeDef *TIMx,uint32_t Channels);
 uint32_t TIM_Get_CC_ChannelStatus(TIM_TypeDef *TIMx,uint32_t Channels);
 void TIM_Set_OC_CompareCH1(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH2(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH3(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH4(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH5(TIM_TypeDef *TIMx,uint32_t CompareValue);
 void TIM_Set_OC_CompareCH6(TIM_TypeDef *TIMx,uint32_t CompareValue);
 uint32_t TIM_Get_OC_CompareCH1(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH2(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH3(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH4(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH5(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_OC_CompareCH6(TIM_TypeDef *TIMx);
 void TIM_Set_CH5CombinedChannels(TIM_TypeDef *TIMx, uint32_t GroupCH5);
 void TIM_OC_Set_PulseWidthPrescaler(TIM_TypeDef *TIMx, uint32_t PulseWidthPrescaler);
 uint32_t TIM_OC_Get_PulseWidthPrescaler(TIM_TypeDef *TIMx);
 void TIM_OC_Set_PulseWidth(TIM_TypeDef *TIMx, uint32_t PulseWidth);
 uint32_t TIM_OC_Get_PulseWidth(TIM_TypeDef *TIMx);
 void TIM_Set_IC(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t Configuration);
 void TIM_Set_IC_ActiveInput(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t ICActiveInput);
 uint32_t TIM_Get_IC_ActiveInput(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_IC_Prescaler(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t ICPrescaler);
 uint32_t TIM_Get_IC_Prescaler(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_IC_Filter(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t ICFilter);
 uint32_t TIM_Get_IC_Filter(TIM_TypeDef *TIMx,uint32_t Channel);
 void TIM_Set_IC_Polarity(TIM_TypeDef *TIMx,uint32_t Channel, uint32_t ICPolarity);
 uint32_t TIM_Get_IC_Polarity(TIM_TypeDef *TIMx,uint32_t Channel);
 uint32_t TIM_Get_IC_CaptureCH1(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_IC_CaptureCH2(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_IC_CaptureCH3(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_IC_CaptureCH4(TIM_TypeDef *TIMx);
 void TIM_Set_OC_DeadTime(TIM_TypeDef *TIMx,uint32_t DeadTime);
 void TIM_Set_CC_LockLevel(TIM_TypeDef *TIMx,uint32_t LockLevel);
 void TIM_Set_OffStates(TIM_TypeDef *TIMx,uint32_t OffStateIdle, uint32_t OffStateRun);
 void TIM_Enable_BRK(TIM_TypeDef *TIMx);
 void TIM_Disable_BRK(TIM_TypeDef *TIMx);
 void TIM_Set_BRK(TIM_TypeDef *TIMx, uint32_t BreakPolarity, uint32_t BreakFilter, uint32_t BreakAFMode);
 void TIM_Disarm_BRK(TIM_TypeDef *TIMx);
 void TIM_ReArm_BRK(TIM_TypeDef *TIMx);
 void TIM_Enable_BRK(TIM_TypeDef *TIMx);
 void TIM_Enable_BRK2(TIM_TypeDef *TIMx);
 void TIM_Set_BreakPolarity(TIM_TypeDef *TIMx,uint32_t BreakPolarity);
 void TIM_Set_BRK2(TIM_TypeDef *TIMx, uint32_t Break2Polarity, uint32_t Break2Filter, uint32_t Break2AFMode);
 void TIM_Disarm_BRK(TIM_TypeDef *TIMx);
 void TIM_Disarm_BRK2(TIM_TypeDef *TIMx);
 void TIM_Enable_BRK2(TIM_TypeDef *TIMx);
void TIM_Disable_BRK2(TIM_TypeDef *TIMx);
void TIM_Set_BRK2(TIM_TypeDef *TIMx, uint32_t Break2Polarity, uint32_t Break2Filter, uint32_t Break2AFMode);
void TIM_Disarm_BRK2(TIM_TypeDef *TIMx);
void TIM_ReArm_BRK2(TIM_TypeDef *TIMx);
void TIM_Set_Break2Polarity(TIM_TypeDef *TIMx,uint32_t BreakPolarity);
 void TIM_Enable_AOE(TIM_TypeDef *TIMx);
 void TIM_Disable_AOE(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_AOEStatus(TIM_TypeDef *TIMx);
 void TIM_Enable_MOE(TIM_TypeDef *TIMx);
 void TIM_Disable_MOE(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_MOEStatus(TIM_TypeDef *TIMx);
// void TIM_Enable_BreakInputSource(TIM_TypeDef *TIMx, uint32_t BreakInput, uint32_t Source);
// void TIM_Disable_BreakInputSource(TIM_TypeDef *TIMx, uint32_t BreakInput, uint32_t Source);
// void TIM_Set_BreakInputSourcePolarity(TIM_TypeDef *TIMx, uint32_t BreakInput, uint32_t Source, uint32_t Polarity);
 void TIM_Enable_AsymmetricalDeadTime(TIM_TypeDef *TIMx);
 void TIM_Disable_AsymmetricalDeadTime(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_AsymmetricalDeadTime(TIM_TypeDef *TIMx);
 void TIM_Set_FallingDeadTime(TIM_TypeDef *TIMx, uint32_t DeadTime);
 uint32_t TIM_Get_FallingDeadTime(TIM_TypeDef *TIMx);
 void TIM_Enable_DeadTimePreload(TIM_TypeDef *TIMx);
 void TIM_Disable_DeadTimePreload(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_DeadTimePreload(TIM_TypeDef *TIMx);
 void TIM_Enable_CMP1Break(TIM_TypeDef *TIMx);
 void TIM_Disable_CMP1Break(TIM_TypeDef *TIMx);
 void TIM_Set_CMP1BreakPolarity(TIM_TypeDef *TIMx,uint32_t BreakPolarity);
 void TIM_Enable_CMP2Break(TIM_TypeDef *TIMx);
 void TIM_Disable_CMP2Break(TIM_TypeDef *TIMx);
 void TIM_Set_CMP2BreakPolarity(TIM_TypeDef *TIMx,uint32_t BreakPolarity);
 void TIM_Enable_CMP3Break(TIM_TypeDef *TIMx);
 void TIM_Disable_CMP3Break(TIM_TypeDef *TIMx);
 void TIM_Set_CMP3BreakPolarity(TIM_TypeDef *TIMx,uint32_t BreakPolarity);
 void TIM_Enable_HardFaultBreak( TIM_TypeDef *TIMx );
 void TIM_Disable_HardFaultBreak( TIM_TypeDef *TIMx );
 void TIM_Enable_PVDBreak( TIM_TypeDef *TIMx );
 void TIM_Disable_PVDBreak( TIM_TypeDef *TIMx );
 void TIM_Set_BreakFilter(TIM_TypeDef *TIMx, uint32_t BreakFilter);
 void TIM_Set_DMABurst(TIM_TypeDef *TIMx, uint32_t DMABurstBaseAddress, uint32_t DMABurstLength);
 void TIM_Enable_EncoderIndex(TIM_TypeDef *TIMx);
 void TIM_Disable_EncoderIndex(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_EncoderIndex(TIM_TypeDef *TIMx);
 void TIM_Set_IndexDirection(TIM_TypeDef *TIMx, uint32_t IndexDirection);
 uint32_t TIM_Get_IndexDirection(TIM_TypeDef *TIMx);
 void TIM_Enable_FirstIndex(TIM_TypeDef *TIMx);
 void TIM_Disable_FirstIndex(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_FirstIndex(TIM_TypeDef *TIMx);
 void TIM_Set_IndexPositionning(TIM_TypeDef *TIMx, uint32_t IndexPositionning);
 uint32_t TIM_Get_IndexPositionning(TIM_TypeDef *TIMx);
 void TIM_Set_IDX(TIM_TypeDef *TIMx, uint32_t Configuration);
 void TIM_Set_Remap(TIM_TypeDef *TIMx, uint32_t Remap);
 void TIM_Enable_HSE32(TIM_TypeDef *TIMx);
 void TIM_Disable_HSE32(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_HSE32(TIM_TypeDef *TIMx);
 void TIM_Set_OCRefClearInputSource(TIM_TypeDef *TIMx, uint32_t OCRefClearInputSource);
 void TIM_Set_CounterValue(TIM_TypeDef *TIMx,uint32_t Counter);
 void TIM_Clear_CounterValue(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_CounterValue(TIM_TypeDef *TIMx);
 void TIM_Set_Prescaler(TIM_TypeDef *TIMx,uint32_t Prescaler);
 uint32_t TIM_Get_Prescaler(TIM_TypeDef *TIMx);
 void TIM_Set_AutoReload(TIM_TypeDef *TIMx,uint32_t AutoReload);
 void TIM_Enable_UIFRemap(TIM_TypeDef *TIMx);
 void TIM_Disable_UIFRemap(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_UIFCPY(uint32_t Counter);
 void TIM_Enable_Dithering(TIM_TypeDef *TIMx);
 void TIM_Disable_Dithering(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_Dithering(TIM_TypeDef *TIMx);
 uint32_t TIM_Get_AutoReload(TIM_TypeDef *TIMx);
 void TIM_Set_RepetitionCounter(TIM_TypeDef *TIMx,uint32_t RepetitionCounter);
 uint32_t TIM_Get_RepetitionCounter(TIM_TypeDef *TIMx);
 void TIM_Set_TI4(TIM_TypeDef* TIMx, TIM_ICInitTypeDef* TIM_ICInitStruct);
 void TIM_Set_TI3(TIM_TypeDef* TIMx, TIM_ICInitTypeDef* TIM_ICInitStruct);
 void TIM_Set_TI2(TIM_TypeDef* TIMx, TIM_ICInitTypeDef* TIM_ICInitStruct);
 void TIM_Set_TI1(TIM_TypeDef* TIMx, TIM_ICInitTypeDef* TIM_ICInitStruct);

  void TIM_Enable_BreakInputSource(TIM_TypeDef *TIMx, uint32_t Source);
  void TIM_Disable_BreakInputSource(TIM_TypeDef *TIMx, uint32_t Source);
  void TIM_Set_BreakInputSourcePolarity(TIM_TypeDef *TIMx,  uint32_t bkcmpP,uint32_t Polarity);

  void TIM_ConfigBRK(TIM_TypeDef *TIMx, uint32_t BreakPolarity, uint32_t BreakFilter,uint32_t BreakAFMode);
  void TIM_DisarmBRK(TIM_TypeDef *TIMx);
  void TIM_ReArmBRK(TIM_TypeDef *TIMx);
  uint8_t TIM_Read_ReArmBRK(TIM_TypeDef *TIMx);

  void TIM_Set_OC_CompareCH1N(TIM_TypeDef *TIMx,uint32_t CompareValue);
  void TIM_Set_OC_CompareCH2N(TIM_TypeDef *TIMx,uint32_t CompareValue);
  void TIM_Set_OC_CompareCH3N(TIM_TypeDef *TIMx,uint32_t CompareValue);
  void TIM_Set_OC_CompareCH4N(TIM_TypeDef *TIMx,uint32_t CompareValue);
  uint32_t TIM_Get_OC_CompareCH1N(TIM_TypeDef *TIMx);
  uint32_t TIM_Get_OC_CompareCH2N(TIM_TypeDef *TIMx);
  uint32_t TIM_Get_OC_CompareCH3N(TIM_TypeDef *TIMx);
  uint32_t TIM_Get_OC_CompareCH4N(TIM_TypeDef *TIMx);
  void TIM_Enable_CCR1N(TIM_TypeDef *TIMx);
  void TIM_Disable_CCR1N(TIM_TypeDef *TIMx);
  void TIM_Enable_CCR2N(TIM_TypeDef *TIMx);
  void TIM_Disable_CCR2N(TIM_TypeDef *TIMx);
  void TIM_Enable_CCR3N(TIM_TypeDef *TIMx);
  void TIM_Disable_CCR3N(TIM_TypeDef *TIMx); 
  void TIM_Enable_CCR4N(TIM_TypeDef *TIMx);
  void TIM_Disable_CCR4N(TIM_TypeDef *TIMx); 
  
  void TIM_Enable_Break_Control(TIM_TypeDef *TIMx);
  void TIM_Disable_Break_Control(TIM_TypeDef *TIMx);
  void TIM_Set_CH1Break_Invalid(TIM_TypeDef *TIMx);
  void TIM_Set_CH2Break_Invalid(TIM_TypeDef *TIMx);
  void TIM_Set_CH3Break_Invalid(TIM_TypeDef *TIMx);
  void TIM_Set_CH4Break_Invalid(TIM_TypeDef *TIMx);
  void TIM_Set_CH5Break_Invalid(TIM_TypeDef *TIMx);
  void TIM_Set_CH6Break_Invalid(TIM_TypeDef *TIMx);
  void TIM_Set_CH1Break_Valid(TIM_TypeDef *TIMx);
  void TIM_Set_CH2Break_Valid(TIM_TypeDef *TIMx);
  void TIM_Set_CH3Break_Valid(TIM_TypeDef *TIMx);
  void TIM_Set_CH4Break_Valid(TIM_TypeDef *TIMx);
  void TIM_Set_CH5Break_Valid(TIM_TypeDef *TIMx);
  void TIM_Set_CH6Break_Valid(TIM_TypeDef *TIMx);
  
 void TIMX_Enable_BreakInputSource(TIM_TypeDef *TIMx, uint32_t BreakInput, uint32_t Source);
 void TIMX_Disable_BreakInputSource(TIM_TypeDef *TIMx, uint32_t BreakInput, uint32_t Source);
 void TIMX_Set_BreakInputSourcePolarity(TIM_TypeDef *TIMx, uint32_t BreakInput, uint32_t Source, uint32_t Polarity);
  
	 void TIM_Enable_CCR1N(TIM_TypeDef *TIMx);
 void TIM_Enable_AutomaticOutput(TIM_TypeDef *TIMx);
 void TIM_Enable_AllOutputs(TIM_TypeDef *TIMx);
 void TIM_GenerateEvent_UPDATE(TIM_TypeDef *TIMx);
 void TIM_Clear_Flag_UPDATE(TIM_TypeDef *TIMx);
 void TIM_Enable_Counter(TIM_TypeDef *TIMx);

#ifdef __cplusplus
}
#endif

#endif /* __rx32s12xx_TIM_H__ */
